//"archfir3.sc","Przeniesienie do archiwum cz.3",12001,0,1.0.1,SYSTEM
//"System",2400,14,62
////////////////////////////
// Przeniesienie do archiwum cz.3
// archfir3.sc
///////////////////////////

//----------------------------------------------------------------------------------------------

String Sub DodajWartosc(int base, string pole, float fWartosc)
	DodajWartosc = SetField( base, pole, GetField(base, pole) + fWartosc )
EndSub

int Sub UpdateKwota(int base, long id, string pole, float fWartosc)
	UpdateKwota = -1

	SetKey(base, "id")
	SetKeySeg(base, "id", id)
	If !GetRec(base, EQ) Then
		SetField( base, pole, GetField(base, pole) + fWartosc )
		UpdateKwota = UpdateRec(base, "")
	EndIf
EndSub

int Sub ZastapKwote(int base, long id, string pole, float fWartosc)
	ZastapKwote = -1

	SetKey(base, "id")
	SetKeySeg(base, "id", id)
	If !GetRec(base, EQ) Then
		SetField( base, pole, fWartosc )
		ZastapKwote = UpdateRec(base, "")
	EndIf
EndSub

//----------------------------------------------------------------------------------------------

int Sub UsunNotatke(int bSrc, string typ, int nrBazy, long super)
	int err

	SetKey(bSrc, "super")
	SetKeySeg(bSrc,"typi", val(typ)) : SetKeySeg(bSrc,"baza", nrBazy) : SetKeySeg(bSrc,"super", super)

	err=GetRec(bSrc,EQ)
	If !err Then
		UsunRekord(bSrc, -1, "Notatek")
	EndIf
EndSub

//----------------------------------------------------------------------------------------------

int Sub KopiujNotatke(int bSrc, int bDst, string typ, int nrBazy, long super)
	int err

	SetKey(bSrc, "super")
	SetKeySeg(bSrc,"typi", val(typ)) : SetKeySeg(bSrc,"baza", nrBazy) : SetKeySeg(bSrc,"super", super)

	err=GetRec(bSrc,EQ)
	If !err Then
		KopiujRekord(bSrc, bDst, -1)
	EndIf
EndSub

//----------------------------------------------------------------------------------------------

int Sub UsunRekordyZZ(int typ, long id, int baza)
	int err

	SetKey(srcZZ, "cross1")
	SetKeySeg(srcZZ, "typi", typ) : SetKeySeg(srcZZ, "baza1", baza)
	SetKeySeg(srcZZ, "id1", id)
	err = GetRec(srcZZ, GE)
	While !err && GetKeySeg(srcZZ, "id1") == id
		UsunRekord(srcZZ, -1, "srcZZ")
		err = GetRec(srcZZ, NX)
	Wend

//	SetKeySeg(srcZZ, "typ", (using "%d", typ)) : SetKeySeg(srcZZ, "baza2", baza)
//	SetKeySeg(srcZZ, "id2", id)
//	err = GetRec(srcZZ, GE)
//	While !err && GetKeySeg(srcZZ, "id2") == id
//		UsunRekord(srcZZ, -1)
//		err = GetRec(srcZZ, NX)
//	Wend
EndSub

//----------------------------------------------------------------------------------------------
//----------------------------------------------------------------------------------------------

int Sub AktualizujWartoscRejestrowPN(int XT, int PN)
	int err, err1
	long id
	float fWartosc

	SetKey(XT, "kod") : SetKeySeg(XT, "typi",8)
	err = GetRec(XT, GE)
	While !err && GetKeySeg(XT, "typi")==8		// petla po wszystkich rejestrach
		id = GetField(XT, "klient")

		fWartosc = 0
		SetKey(PN, "rejestr") : SetKeySeg(PN, "rejestr", id)
		err1 = GetRec(PN, GE)
		while !err1 && GetKeySeg(PN, "rejestr") == id
			If GetField(PN, "typi") == 0 Then
				fWartosc += GetField(PN, "kwota")
			EndIf
			err1 = GetRec(PN, NX)
		wend
		SetKey(dstKH, "id") : SetKeySeg(dstKH, "id", id)
		GetRec(dstKH, EQ)
		SetField(dstKH, "stannl", fWartosc)
		UpdateRec(dstKH, "")

		fWartosc = 0
		SetKey(PN, "khid")
		SetKeySeg(PN, "khid", id) : SetKeySeg(PN, "typi", 1) : SetKeySeg(PN, "termin", "2099-01-01")
		err1 = GetRec(PN, LT)
		If !err1 && GetKeySeg(PN, "khid") == id Then
			fWartosc = GetField(PN, "stan") + GetField(PN, "kwota") + GetField(PN, "kwotarozl")
		EndIf
		SetKey(dstKH, "id") : SetKeySeg(dstKH, "id", id)
		GetRec(dstKH, EQ)
		SetField(dstKH, "stanpl", fWartosc)
		UpdateRec(dstKH, "")

		err = GetRec(XT, NX)
	wend
EndSub

int Sub AktualizujStanRejestrowPN(int XT, int PN)
	int err
	long id
	float fWartosc
	long lIlosc

	SetKey(XT, "kod")
	SetKeySeg(XT, "typi",8)
	err = GetRec(XT, GE)
	While !err && GetKeySeg(XT, "typi")==8		// petla po wszystkich rejestrach
		lIlosc = 0 : fWartosc = 0
		id = GetField(XT, "id")

		SetKey(PN, "rejestr") : SetKeySeg(PN, "rejestr", id)
		err = GetRec(PN, GE)
		while !err && GetKeySeg(PN, "rejestr") == id
			lIlosc += 1
			fWartosc += GetField(PN, "kwota")
			err = GetRec(PN, NX)
		wend

		SetField(XT, "zawartosc", lIlosc)
		UpdateRec(XT, "XT")

		err = GetRec(XT, NX)
	wend
EndSub

//----------------------------------------------------------------------------------------------
int sub ZliczDlaRodzaju(int XT, int DK, long kat)
	long a, root
	int err

	root = GetField(XT, "id")
	SetKey(DK, "rodzaj") : SetKeySeg(DK, "rodzaj", root) : SetKeySeg(DK, "typi",0)
	SetKeySeg(DK, "kod","")
	err = GetRec(DK, GE)
	While !err && GetKeySeg(DK, "rodzaj") == root
		If GetField(DK, "typi") != 99 then	a += 1
		err = GetRec(DK, NX)
	Wend

	If a != GetField(XT, "zawartosc") then
		SetField(XT, "zawartosc", a) : UpdateRec(XT, "XT")
	EndIf
EndSub

Int Sub ZliczRodzaje(int XT, int DK,  long root)
	int podkatalog

	SetKey(XT, "id") : SetKeySeg(XT, "id", root)
	If GetRec(XT, EQ) Then Exit

	// zliczenie dla gownego
	ZliczDlaRodzaju(XT, DK, root)

	SetKey(XT, "super")
	SetKeySeg(XT, "super", root)
	err = GetRec(XT, GE)
	While !err && GetKeySeg(XT, "super") == root
		podkatalog += 1
		ZliczDlaRodzaju(XT, DK, root)
		err = GetRec(XT, NX)
	Wend

	// zapisanie ilosci rodzajw
	SetKey(XT, "id") : SetKeySeg(XT, "id", root)
	If !GetRec(XT, EQ) Then
		If GetField(XT, "podkatalog") != podkatalog then
			SetField(XT, "podkatalog",podkatalog) : UpdateRec(XT, "XT")
		EndIf
	EndIf
EndSub

long l_wszystkie, l_wKoszu
Long Sub SprawdzKatalog(int XT, int DK, long id)
	int err, i
	long zawartosc
	long kat(1)

	SetKey(DK, "katalog") : SetKeySeg(DK, "katalog", id)
	err=GetRec(DK, GE)
	While !err && GetKeySeg(DK, "katalog") == id
		If GetField(DK, "typi")==100 || GetField(DK, "typi")==112 || GetField(DK, "typi") == 111 then
			l_wKoszu += 1
		Else
			l_wszystkie += 1
		Endif
		zawartosc += 1
		err=GetRec(DK, NX)
	Wend

	SetKey(XT, "id") : SetKeySeg(XT, "id", id)
	If !GetRec(XT, EQ) then
		If GetField(XT, "zawartosc") != zawartosc then
			SetField(XT, "zawartosc", zawartosc) : UpdateRec(XT, "XT")
		Endif
	EndIf

	// sprawdzenie podkatalogw
	SetKey(XT, "super") : SetKeySeg(XT, "super", id)
	err = GetRec(XT, GE)
	i = 1
	While !err && GetKeySeg(XT, "super") == id
		kat(i) = GetField(XT, "id") : i += 1 : grow kat, 1
		err = GetRec(XT, NX)
	Wend
	For i = 1 To Size(kat) < i
		If kat(i) Then SprawdzKatalog(XT, DK, kat(i))
	Next i
Endsub

Int Sub SprawdzDokumenty(int XT, int DK, long root)
	int podkatalog, err
	long temp, id
	
	l_wszystkie = l_wKoszu = 0

	SetKey(XT, "id") : SetKeySeg(XT, "id", root)
	If GetRec(XT, EQ) then exit

	id = GetField(XT, "id")
	SprawdzKatalog (XT, DK, id)
	
	root+=1000
	ZliczRodzaje(XT, DK, root)

	// zapisanie wartoci wszystkich oraz w koszu
	SetKey(XT, "id") : SetKeySeg(XT, "id", root+1000)
	If !GetRec(XT, EQ) Then
		If GetField(XT, "zawartosc") != l_wszystkie Then
			SetField(XT, "zawartosc", l_wszystkie) : UpdateRec(XT, "XT")
		Endif
	EndIf

	SetKey(XT, "id") : SetKeySeg(XT, "id", root+1099)
	If !GetRec(XT, EQ) Then
		If GetField(XT, "zawartosc") != l_wKoszu Then
			SetField(XT, "zawartosc", l_wKoszu) : UpdateRec(XT, "XT")
		Endif
	EndIf
EndSub

Int Sub AktualizujStanDokumentowDK(int XT, int DK)

	// zliczenie iloci dokumentw w katalogach i rodzajach
	SprawdzDokumenty(XT, DK, 2300)		// sprzeda
	SprawdzDokumenty(XT, DK, 2600)		// zakup
EndSub

//----------------------------------------------------------------------------------------------
//----------------------------------------------------------------------------------------------

// 0- nie, 1- tak
Int Sub CzyIstniejaKorektyPoDacie(int base, long id, String sData, string pole)
	If !id Then exit
	int err

	SetKey(base, "id") : SetKeySeg(base,"id", id)
	err=GetRec(base,EQ)

	While !err
		id = GetField(base, "idkorekt")
		If !id Then CzyIstniejaKorektyPoDacie = 0 : exit
		SetKeySeg(base,"id", id)
		err=GetRec(base, EQ)
		If !err Then 
			If GetField(base, pole) > sData Then CzyIstniejaKorektyPoDacie = 1 : exit
		EndIf
	Wend
EndSub	// po OPT.

//----------------------------------------------------------------------------------------------
// zmiana= 0 - bez zmian, zmiana= 1 - ustawiam flag w polu typ na 1
// ->DP
Int Sub PrzeniesPozycjeDokumentuDK(long iddk, int zmiana)
	int err, i = 1
	long iddp
	string typ

	SetKey(srcDP, "super") : SetKeySeg(srcDP, "super", iddk)
	err=GetRec(srcDP, GE)

	While !err && GetKeySeg(srcDP, "super") == iddk
		#ifdef HMHL
		If GetField(srcDP, "rezerwacja") Then
			UsunRezerwacje( GetField(srcDP, "rezerwacja") )
			SetKey(srcDP, "super") : SetKeySeg(srcDP, "super", iddk)
			err=GetRec(srcDP, GE)
		EndIf
		#endif
		iddp = GetField(srcDP, "id")
		KopiujRekord(srcDP, dstDP, -1)
		If !KopiujRekord(srcIDP, dstIDP, iddp) Then UsunRekord(srcIDP, -1, "srcIDP")
		KopiujNotatke(srcNT, dstNT, "16", 18, iddp)

		If zmiana == 1 Then
			typ = using "%d", GetField(srcDP, "typi") | 0x01
			SetField(srcDP, "typi", val(typ))
			SetField(srcDP, "rejestrVati", 4)
			UpdateRec(srcDP, "DP")
//			SetKey(srcIDP, "id") : SetKeySeg(srcIDP, "id", iddp)
//			if !GetRec(srcIDP, EQ) Then SetField(srcIDP, "typ", typ) : UpdateRec(srcIDP, "iDP")
		EndIf
		If zmiana == 0 Then
			UsunRekord(srcDP, -1, "srcDP")
			UsunNotatke(srcNT, "16", 18, iddp)
		EndIf
		err=GetRec(srcDP, NX)
	Wend
EndSub

Int Sub PrzeniesRekordyRV(long iddk)
	int err


	SetKey(srcRV, "dk_vat") 
	SetKeySeg(srcRV, "dkid", iddk)
	err=GetRec(srcRV, GE)

	While !err && GetKeySeg(srcRV, "dkid") == iddk
		KopiujRekord(srcRV, dstRV, -1)
		UsunRekord(srcRV, -1, "srcRV")
		err=GetRec(srcRV, NX)
	Wend
EndSub

//----------------------------------------------------------------------------------------------
//DK->DP
Long Sub PrzeniesDokumentyHandlowe(String sData)
	int err
	long iddk, RecordCount
	int t
	
	SetKey(srcDK0, "data") : SetKeySeg(srcDK0 ,"data", sDataOd)
	err = GetRec(srcDK0, LE)
	While !err && GetKeySeg(srcDK0, "data") != ""
		RecordCount += 1
		// odnalezienie dokumentw przeniesionych do archiwum
		If GetField(srcDK0, "subtypi")==2 && GetField(srcDK0, "rejestrVati")==4 Then
			DkPrzenDoArch( Size(DkPrzenDoArch) ) = GetField(srcDK0, "id")
			grow DkPrzenDoArch, 1
		EndIf

		err = GetRec(srcDK0, PR)
	Wend

	SetKey(srcDK0, "id") : SetKeySeg(srcDK0 ,"id", 0)
	err = GetRec(srcDK0, GT)

	PopUp(1,"Przenoszenie dokumentw handlowych.")
//	RecordCount = GetRecordCount(srcDK0)
	progress.Reset(RecordCount)
	While !err

		If GetField(srcDK0, "data") <= sData && GetField(srcDK0, "data") != "" Then
			progress.NextOne()
			PopUp(2, "Pozostao " + (using "%d", RecordCount) + " dokumentw.")
			If RecordCount Then RecordCount -= 1

			ZnajdzRekordySerii("DK", GetField(srcDK0, "seria"), GetField(srcDK0, "dzial"), GetField(srcDK0, "okres"), GetField(srcDK0, "serianr"), GetField(srcDK0, "kod"), GetField(srcDK0, "id"))
			iddk = GetField(srcDK0, "id")
		EndIf

		t = GetField(srcDK0, "typi")
		If t!=0 && t!=1 && t!=202 && t!=203 && t!=100 && t!=112 && t!=103 && !(t==102 && GetField(srcDK0, "subtypi")==2) Then
			CopyFields(srcDK0, dstDK)
			InsertRec(dstDK, "dstDK")
		EndIf

		If iddk Then
			PrzeniesDokumentyHandlowe += 1 
			SetKey(srcDK, "id") : SetKeySeg(srcDK, "id", iddk)
			GetRec(srcDK, EQ)
		
			KopiujRekord(srcDK, dstDK, -1)
			If !KopiujRekord(srcIDK, dstIDK, iddk) Then UsunRekord(srcIDK, -1, "srcIDK")
			KopiujNotatke(srcNT, dstNT, "0", 16, iddk)
		
#ifdef HMFP
			PrzeniesRekordyRV(iddk)
#endif
			If GetField(srcDK, "idkorekt") && CzyIstniejaKorektyPoDacie(srcDK1, iddk, sData, "data") Then
				PrzeniesPozycjeDokumentuDK(iddk, 1)
		
				SetField(srcDK, "subtypi", 2) : SetField(srcDK, "rejestrVati", 4)
				UpdateRec(srcDK, "DK")
			Else
				PrzeniesPozycjeDokumentuDK(iddk, 0)
				UsunRekord(srcDK, -1, "srcDK")
		
				UsunRekordyZZ(140, iddk, 16)
				UsunRekordyZZ(141, iddk, 16)
				UsunRekordyZZ(142, iddk, 16)
				UsunRekordyZZ(143, iddk, 16)
				UsunRekordyZZ(131, iddk, 16)
				UsunRekordyZZ(132, iddk, 16)
				UsunNotatke(srcNT, "0", 16, iddk)
			EndIf
		EndIf

		iddk = 0
		err=GetRec(srcDK0, NX)
	Wend

	progress.Reset(0)
	PopUp(1,"")
	PopUp(2,"")
EndSub	// po OPT.


//----------------------------------------------------------------------------------------------


//RL->PN, przeniesienie rozlicze i rozrachunkw
Int Sub PrzeniesRozliczeniaDoDokPlat(long idpn, int wyplata, string sData)
	string c1, r
	long idpn1
	int err, errIPN, i = 1, zn
	float wartoscRL

	SetKey(dstPN, "id") : SetKeySeg(dstPN, "id", idpn)
	If GetRec(dstPN, EQ) Then exit

	If wyplata == 0 Then c1 = "1" : r = "2" : zn = 1		// wpata
	If wyplata == 1 Then c1 = "2"	:	r = "1"	: zn = -1		// wypata

	SetKey(srcPN, "id")

	SetKey(dstIPN, "id") : SetKeySeg(dstIPN, "id", idpn)
	errIPN = GetRec(dstIPN, EQ)

	SetKey(srcRL, "cross"+c1)
	SetKeySeg(srcRL,"id"+c1, idpn) : SetKeySeg(srcRL,"id"+r, 0)
	err=GetRec(srcRL, GE)
	While !err && GetKeySeg(srcRL, "id"+c1) == idpn
		SetKeySeg(srcPN, "id", GetField(srcRL, "id"+r))
		If !GetRec(srcPN, EQ) Then

			wartoscRL = GetField(srcRL, "wartosc")
			If GetField(srcPN, "data") <= sData Then
				idpn1 = GetField(srcPN, "id")
				KopiujRekord(srcPN, dstPN1, -1)
				KopiujRekord(srcIPN, dstIPN1, GetField(srcRL, "id"+r))
				KopiujNotatke(srcNT, dstNT, "0", 32, GetField(srcRL, "id"))
				
				If !KopiujRekord(srcRL, dstRL, -1) Then
					UpdateKwota(srcPN, idpn1, "kwotarozl", wartoscRL*(-1)*zn)	// pomniejszam kwot rozliczon
					UpdateKwota(srcIPN, idpn1, "kwota", wartoscRL*(-1)*zn)			// pomniejszam kwot dokumentu
					UsunRekord(srcRL, -1, "srcRL")
				EndIf
			Else
				SetField(srcRL, "id"+c1, 0)
				UpdateRec(srcRL, "srcRL")
				
				If wartoscRL Then
					DodajWartosc(dstPN, "kwotarozl", wartoscRL*(-1)*zn)			// pomniejszam kwot rozliczon przeniesionego dokumentu PN
					SetField(dstPN, "typi", 2)
					If !errIPN Then
						SetField(dstIPN, "typi", 2)
						DodajWartosc(dstIPN, "kwotadorozl", wartoscRL*zn)			// powikszam kwot do rozliczenia
					EndIf
				EndIf
			EndIf
		EndIf
		err=GetRec(srcRL, NX)
	Wend
	UpdateRec(dstPN, "dstPN")
	If !errIPN Then UpdateRec(dstIPN, "")

EndSub

//----------------------------------------------------------------------------------------------
//RL->PN
Int Sub PrzeniesRozlDoRozrachunku(long idpn, int wyplata, string sData)
	int err, i = 1, zn
	Rc2 id(1)
	string c1, r
	float	wartoscRL, temp

	SetKey(dstPN, "id") : SetKeySeg(dstPN, "id", idpn)
	If GetRec(dstPN, EQ) Then exit

	If wyplata == 0 Then c1 = "2" : r = "1" : zn = 1
	If wyplata == 1 Then c1 = "1"	:	r = "2" : zn = -1

	SetKey(srcPN, "id")

	SetKey(srcRL, "cross"+c1)
	SetKeySeg(srcRL,"id"+c1, idpn) : SetKeySeg(srcRL,"id"+r, 0)
	err=GetRec(srcRL, GE)
	While !err && GetKeySeg(srcRL, "id"+c1) == idpn
		SetKeySeg(srcPN, "id", GetField(srcRL, "id"+r))
		If !GetRec(srcPN, EQ) Then
			wartoscRL = GetField(srcRL, "wartosc")
			If GetField(srcPN, "data") <= sData Then

				If !GetField(srcRL, "id"+r) Then 	//	czenie rozliczenia z patnoci
					SetKey(dstPN1, "numer") : SetKeySeg(dstPN1, "kod", GetField(srcRL, "kod"+r)) : SetKeySeg(dstPN1, "typi", 0)
					If !GetRec(dstPN1, GE) Then SetField(srcRL, "id"+r, GetField(dstPN1, "id"))
				EndIf
				KopiujRekord(srcRL, dstRL, -1)
				UsunRekord(srcRL, -1, "srcRL")
				
				KopiujRekord(srcPN, dstPN1, GetField(srcRL, "id"+r))
				KopiujRekord(srcIPN, dstIPN, GetField(srcRL, "id"+r))
				KopiujNotatke(srcNT, dstNT, "0", 32, GetField(srcRL, "id"))
				
				UpdateKwota(srcIPN, idpn, "kwota", wartoscRL*(-1)*zn)			// pomniejszam kwot dokumentu
				UpdateKwota(srcPN, idpn, "kwotarozl", wartoscRL*(-1)*zn)	// pomniejszam kwot rozliczon
			Else
//				DodajWartosc(dstPN, "kwota", wartoscRL*zn)									// powikszam kwot do rozliczenia
//				DodajWartosc(dstPN, "kwotarozl", wartoscRL*(-1)*zn)					// pomniejszam kwot rozliczon przeniesionego dokumentu PN
				
//				If wartoscRL Then
//					SetField(dstPN, "typ", "0")
//					SetKey(dstIPN, "id") : SetKeySeg(dstIPN, "id", idpn)
//					If !GetRec(dstIPN, EQ) Then
//						SetField(dstIPN, "typ", "0")
//						DodajWartosc(dstIPN, "kwotadorozl", wartoscRL*zn)			// powikszam kwot do rozliczenia
//						UpdateRec(dstIPN, "dstIPN")
//					EndIf
//				EndIf
//				UpdateRec(dstPN, "dstPN")
			EndIf
		EndIf
		err = GetRec(srcRL, NX)
	Wend
EndSub

//----------------------------------------------------------------------------------------------

float Sub SumaRozliczen(int bas, long idpn, int wyplata)
	int err, i = 1
	
	string c1 = "2", c2 = "1"
	If wyplata == 0 Then c1 = "2" : c2 = "1"	// naleno
	If wyplata == 1 Then c1 = "1"	: c2 = "2"	// zobowizanie
	
	SetKey(bas, "cross"+c1)
	SetKeySeg(bas,"id"+c1, idpn) : SetKeySeg(bas,"id"+c2, 0)
	err=GetRec(bas, GE)
	While !err && GetKeySeg(bas, "id"+c1) == idpn
		SumaRozliczen += GetField(bas, "wartosc")
		err=GetRec(bas, NX)
	Wend
EndSub

//----------------------------------------------------------------------------------------------

int Sub RaportPrzedPodzialem(long id)
	float k1, k2, k3

	Print LF
	Rysuj "_"
	Print LF + "Raport podziau rozrachunku: "

	SetKey(srcPN1, "id") : SetKeySeg(srcPN1, "id", id)
	If !GetRec(srcPN1, EQ) Then
		k2 = GetField(srcPN1, "kwota")
		k3 = GetField(srcPN1, "kwotarozl")
		Print (using "kod= %s	, data= %s", GetField(srcPN1, "kod"), GetField(srcPN1, "data")) + LF
	EndIf
//	SetKey(srcIPN1, "id") : SetKeySeg(srcIPN1, "id", id)
//	If !GetRec(srcIPN1, EQ) Then k1 = GetField(srcIPN1, "kwota")
	Print "PRZED PODZIAEM" +LF
	Print (using "Kwota dokumentu= %f	, Kwota do rozliczenia= %f	, Kwota rozliczona= %f", k2+k3, k2, k3) + LF
EndSub

//----------------------------------------------------------------------------------------------

int Sub RaportPodzialuRozrachunku(long id)
	float k1, k2, k3

	SetKey(srcPN1, "id")
	SetKeySeg(srcPN1, "id", id)
	If !GetRec(srcPN1, EQ) Then
		k2 = GetField(srcPN1, "kwota")
		k3 = GetField(srcPN1, "kwotarozl")
	EndIf
//	SetKey(srcIPN1, "id") : SetKeySeg(srcIPN1, "id", id)
//	If !GetRec(srcIPN1, EQ) Then k1 = GetField(srcIPN1, "kwota")
	Print "FIRMA" +LF
	Print (using "Kwota dokumentu= %f	, Kwota do rozliczenia= %f	, Kwota rozliczona= %f", k2+k3, k2, k3) + LF

	Print "ARCHIWUM" +LF
	k1 = k2 = k3 = 0
	SetKey(dstPN1, "id")
	SetKeySeg(dstPN1, "id", id)
	If !GetRec(dstPN1, EQ) Then k2 = GetField(dstPN1, "kwota") : k3 = GetField(dstPN1, "kwotarozl")
//	SetKey(dstIPN1, "id") : SetKeySeg(dstIPN1, "id", id)
//	If !GetRec(dstIPN1, EQ) Then k1 = GetField(dstIPN1, "kwota")
	Print (using "Kwota dokumentu= %f	, Kwota do rozliczenia= %f	, Kwota rozliczona= %f", k2+k3, k2, k3) + LF
EndSub

//----------------------------------------------------------------------------------------------

int Sub DodajRekordZZEdycjiPlatnosci(int PN, int ZZ)
		// czy bya edycja tej patnoci
		Clear(ZZ)
		SetField(ZZ, "subtypi", 58)
		SetField(ZZ, "typi", 160)
		SetField(ZZ, "baza1", 32)
		SetField(ZZ, "id1", GetField(PN, "id"))
		SetField(ZZ, "kod1", GetField(PN, "kod"))
		SetField(ZZ, "kod2", "Admin")
		SetField(ZZ, "data", GetField(PN, "data"))
		SetField(ZZ, "termin", sDataOd)
		SetField(ZZ, "cena", GetField(PN, "kwota") + GetField(PN, "kwotarozl"))
		SetField(ZZ, "waluta", "arc")	//archiwum
		InsertRec(ZZ, "ZZ")
EndSub

//----------------------------------------------------------------------------------------------

int Sub PrzeniesRekordyZZDokPN(int typ, int baza, long id, int srcZZ, int dstZZ)
	SetKey(srcZZ, "cross1")
	SetKeySeg(srcZZ, "typi", typ) : SetKeySeg(srcZZ, "baza1", baza)
	SetKeySeg(srcZZ, "id1", id)
	err = GetRec(srcZZ, GE)
	While !err && GetKeySeg(srcZZ, "id1") == id
		SetKey(dstZZ, "id") : SetKeySeg(dstZZ, "id", GetField(srcZZ, "id"))
		If GetRec(dstZZ, EQ) Then KopiujRekord(srcZZ, dstZZ, -1)
		err = GetRec(srcZZ, NX)
	Wend
EndSub

//----------------------------------------------------------------------------------------------

Int Sub UzupelnianieRekIPNwArch(int srcPN, int dstPN, int dstIPN)
	int err

	PopUp(1,"Uzupenianie rekordw indeksowych w archiwum.")
	SetKey(srcPN, "id")
	SetKey(dstIPN, "id")
	SetKey(dstPN, "id")
	err = GetRec(dstPN, FS)
	While !err
		// Sprawdzam czy istnieje rwnie w firmie
		SetKeySeg(srcPN, "id", GetField(dstPN, "id"))
		If !GetKey(srcPN, EQ) Then
			SetField( dstPN, "typi", 0 )
			UpdateRec(dstPN, "dstPN")
		EndIf
		If GetField(dstPN, "typi") != 1 Then
			SetKeySeg(dstIPN, "id", GetKeySeg(dstPN, "id"))
			If GetRec(dstIPN, EQ) Then CopyPNtoIPN(dstPN, dstIPN)
		EndIf
		err = GetRec(dstPN, NX)
	Wend
	PopUp(1,"")
EndSub

//--------------------------------------------

Int Sub WyrownanieKwotRozlwArch()
	int err, zn
	long idPlat, temp, RecordCount
	long idRozr
	long idRozrW
	float wartoscf, wartosca
	int typ, wyplata
	long dkid
	string temp1

	SetKey(dstPN1, "platnosc") : SetKeySeg(dstPN1, "typi", 0)
	SetKeySeg(dstPN1, "wyplatai", 0) : SetKeySeg(dstPN1, "termin", "")
	err = GetRec(dstPN1, GE)

	PopUp(1, "Wyrwnanie stanu rozliczenia rozrachunku.")
	RecordCount = GetRecordCount(dstPN1)
	progress.Reset(RecordCount)

	While !err && GetKeySeg(dstPN1, "typi") <= 1
		progress.NextOne()
		PopUp(2, "Pozostao " + (using "%d", RecordCount) + " dokumentw.")
		RecordCount =	RecordCount - 1

		typ = GetField(dstPN1, "typi")

		// Wszystkie rozrachunki
		If !(GetField(dstPN1, "flag") & 0x4000) Then	// bez raportw
			idRozrW = GetField(dstPN1, "id")
		EndIf

		//---------------------------
		// Wyrwnanie kwot rozlicze.

		If idRozrW Then
			wyplata = GetField(dstPN1, "wyplatai")
			wartosca = SumaRozliczen(dstRL, idRozrW, wyplata)
//			If wartosca Then
				If wyplata == 0 Then
					zn = 1
				Else
					zn = -1
				EndIf
				
				SetKey(dstIPN, "id") : SetKeySeg(dstIPN, "id", idRozrW)
				If !GetRec(dstIPN, EQ) Then
					ZastapKwote(dstPN, idRozrW, "kwota", GetField(dstIPN, "kwota")-wartosca*zn)					// kwota do rozliczenia
					ZastapKwote(dstIPN, idRozrW, "kwotadorozl", GetField(dstIPN, "kwota")-wartosca*zn)	// kwota do rozliczenia
					ZastapKwote(dstPN, idRozrW, "kwotarozl", wartosca*zn)																// kwota rozliczona
			
				SetKey(dstPN, "id") : SetKeySeg(dstPN, "id", idRozrW)
				If !GetRec(dstPN, EQ) Then
					ZastapKwote(dstDK, GetField(dstPN, "dkid"), "wplaty", GetField(dstPN, "kwotarozl"))
					ZastapKwote(dstIDK, GetField(dstPN, "dkid"), "wplaty", GetField(dstPN, "kwotarozl"))
		
					SetKey(dstDK, "id") : SetKeySeg(dstDK, "id", GetField(dstPN, "dkid"))
					If !GetRec(dstDK, EQ) Then SetField( dstDK, "oki", 0 ) : UpdateRec(dstDK, "")
					SetKey(dstIDK, "id") : SetKeySeg(dstIDK, "id", GetField(dstPN, "dkid"))
					If !GetRec(dstIDK, EQ) Then SetField( dstIDK, "oki", 0 ) : UpdateRec(dstIDK, "")
						
					If !Sign(GetField(dstPN, "kwota")) Then
						SetField( dstPN, "typi", 1 )
						UsunRekord(dstIPN, idRozrW, "dstIPN")
					EndIf
					UpdateRec(dstPN, "dstPN")
				EndIf
				EndIf
			EndIf
//		EndIf

		idPlat = 0
		idRozr = 0
		idRozrW = 0
		err=GetRec(dstPN1, NX)
	Wend

	progress.Reset(0)
	PopUp(1,"")
	PopUp(2,"")
EndSub

//----------------------------------------------------------------------------------------------

//PN->RL->PN
Long Sub PrzeniesDokumentyPlatnosci(String sData)
	int err, zn, err1
	long idPlat, temp, RecordCount
	long idRozr
	long idRozrW
	float wartoscf, wartosca, fEdycja
	int typ, wyplata
	long dkid

	SetKey(srcPN0, "id") : SetKeySeg(srcPN0, "id", 0)
	err = GetRec(srcPN0,GE)

	PopUp(1, "Analiza dokumentw patnoci.")
	RecordCount = GetRecordCount(srcPN0)
	progress.Reset(RecordCount)

While !err

	progress.NextOne()
	PopUp(2, "Pozostao " + (using "%d", RecordCount) + " dokumentw.")
	RecordCount =	RecordCount - 1

	typ = GetField(srcPN0, "typi")

	If GetField(srcPN0, "data") <= sData Then
		// Dokumenty patnoci
		If (typ == 2 || typ == 3) && GetField(srcPN0, "data") != "" Then
			idPlat = GetField(srcPN0, "id")
			ZnajdzRekordySerii("PN", GetField(srcPN0, "seria"), GetField(srcPN0, "dzial"), GetField(srcPN0, "okres"), GetField(srcPN0, "serianr"), GetField(srcPN0, "kod"), GetField(srcPN0, "id"))
		EndIf
		// Rozrachunki
		If typ == 0 || typ == 1 Then
			If !((GetField(srcPN0, "flag") & 0x4000) && GetField(srcPN0, "termin") > sData) && GetField(srcPN0, "termin")!="" Then	// lub raport
				idRozr = GetField(srcPN0, "id")
				ZnajdzRekordySerii("PN", GetField(srcPN0, "seria"), GetField(srcPN0, "dzial"), GetField(srcPN0, "okres"), GetField(srcPN0, "serianr"), GetField(srcPN0, "kod"), GetField(srcPN0, "id"))
			EndIf
		EndIf
	EndIf

	// Wszystkie rozrachunki
	If (typ == 0 || typ == 1) && !(GetField(srcPN0, "flag") & 0x4000) Then	// bez raportw
		idRozrW = GetField(srcPN0, "id")
	EndIf

	//--------------------------------------------
	// Przenoszenie dokumentw patnoci.

	If idPlat Then
		SetKey(srcPN, "id") : SetKeySeg(srcPN, "id", idPlat)
		If !GetRec(srcPN, EQ) Then
			wyplata = GetField(srcPN, "wyplatai")
			If !KopiujRekord(srcPN, dstPN, -1) Then PrzeniesDokumentyPlatnosci += 1
			UsunRekord(srcPN, -1, "srcPN")
			KopiujNotatke(srcNT, dstNT, "0", 32, idPlat)
			UsunNotatke(srcNT, "0", 32, idPlat)
			KopiujRekord(srcIPN, dstIPN, idPlat)
			UsunRekord(srcIPN, idPlat, "srcIPN")
			PrzeniesRozliczeniaDoDokPlat(idPlat, wyplata, sData)
		EndIf
	EndIf

	//------------------------------------
	// Przenoszenie rozrachunkw.
	If idRozr Then
		SetKey(srcPN, "id") : SetKeySeg(srcPN, "id", idRozr)
		If !GetRec(srcPN, EQ) Then

			// Sprawdzam czy rozrachunek istnieje rwnie w archiwum (czy by podzielony)
			SetKey(dstPN, "id") : SetKeySeg(dstPN, "id", idRozr)
			If !GetRec(dstPN, EQ) Then
				// Sprawdzam czy dokonywano edycji rozrachunku po archiwizacji
				SetKey(srcZZ, "cross1")
				SetKeySeg(srcZZ, "typi", 160) : SetKeySeg(srcZZ, "baza1", 32)
				SetKeySeg(srcZZ, "id1", idRozr) : SetKeySeg(srcZZ, "baza2", 0) : SetKeySeg(srcZZ, "id2", 0)
				err1 = GetRec(srcZZ, GE)
				While !err1 && GetField(srcZZ, "id1") == idRozr
					If DataPoprzedniejArch < GetField(srcZZ, "termin") Then
						// kwoty w archiwum powikszam o rnic PN.'kwota' biecej i kwoty pierwszej edycji po arch.
						fEdycja = GetField(srcPN, "kwota")- GetField(srcZZ, "cena")
						UpdateKwota(dstPN, idRozr, "kwota", fEdycja)
						UpdateKwota(dstIPN, idRozr, "kwota", fEdycja)
						UpdateKwota(dstIPN, idRozr, "kwotadorozl", fEdycja)
						exit
					EndIf
					err1 = GetRec(srcZZ, NX)
				Wend
			EndIf

			PrzeniesRekordyZZDokPN(160, 32, idRozr, srcZZ, dstZZ)

			typ = GetField(srcPn, "typi")
			wyplata = GetField(srcPN, "wyplatai")

			If !KopiujRekord(srcPN, dstPN, -1) Then PrzeniesDokumentyPlatnosci += 1
			KopiujRekord(srcIPN, dstIPN, idRozr)
			PrzeniesRozlDoRozrachunku(idRozr, wyplata, sData)

			KopiujNotatke(srcNT, dstNT, "0", 32, idRozr)

			wartoscf = SumaRozliczen(srcRL, idRozr, wyplata)
			If typ == 1 && wartoscf == 0 Then
				// rozrachunek rozliczony w caoi
				UsunRekord (srcPN, idRozr, "srcPN") : UsunRekord (srcIPN, idRozr, "srcIPN")
				UsunNotatke(srcNT, "0", 32, idRozr)
			EndIf
		EndIf
	EndIf

	//------------------------------------------------------
	// Wyrwnywanie kwot podzielonych rozrachunkw.
	
	If idRozrW Then
		SetKey(srcPN, "id") : SetKeySeg(srcPN, "id", idRozrW)
		If !GetRec(srcPN, EQ) Then
			dkid = GetField(srcPN, "dkid")
			wyplata = GetField(srcPN, "wyplatai")
		
			// usunicie dowizania do dokumentu DK
			SetKey(srcDK, "id") : SetKeySeg(srcDK, "id", dkid)
			If GetRec(srcDK, EQ) Then
				SetField(srcPN, "dkid", 0) : UpdateRec(srcPN, "PN")
			EndIf
		
			wartosca = SumaRozliczen(dstRL, idRozrW, wyplata)
			SetKey(dstPN, "id") : SetKeySeg(dstPN, "id", idRozrW)
			If wartosca || !GetRec(dstPN, EQ) Then
				PrzeniesRekordyZZDokPN(160, 32, idRozrW, srcZZ, dstZZ)	//rekordy edycji
			
				wartoscf = SumaRozliczen(srcRL, idRozrW, wyplata)
				If !KopiujRekord(srcPN, dstPN, -1) Then PrzeniesDokumentyPlatnosci += 1
				KopiujRekord(srcIPN, dstIPN, idRozrW)
			
//				RaportPrzedPodzialem(idRozrW)
					
				If wyplata == 0 Then
					zn = 1
				Else
					zn = -1
				EndIf
				
				DodajRekordZZEdycjiPlatnosci(srcPN, srcZZ)
				DodajRekordZZEdycjiPlatnosci(dstPN, dstZZ)
				
				// wyrwnanie kwoty rozliczonej na dokumencie DK
				ZastapKwote(srcDK, dkid, "wplaty", GetField(srcPN, "kwotarozl"))
				ZastapKwote(srcIDK, dkid, "wplaty", GetField(srcPN, "kwotarozl"))
		
//				RaportPodzialuRozrachunku(idRozrW)
			EndIf
		EndIf
	EndIf

	idPlat = 0
	idRozr = 0
	idRozrW = 0
	err=GetRec(srcPN0, NX)
Wend

	UzupelnianieRekIPNwArch(srcPN, dstPN, dstIPN)
	WyrownanieKwotRozlwArch()

	AktualizujStanRejestrowPN(srcXT, srcPN)
	AktualizujStanRejestrowPN(dstXT, dstPN)
	AktualizujWartoscRejestrowPN(dstXT, dstPN)

	progress.Reset(0)
	PopUp(1,"")
	PopUp(2,"")
EndSub
