//"archfir4.sc","Przeniesienie do archiwum cz.4",12001,0,1.0.1,SYSTEM
//"System",2400,14,62
////////////////////////////
// Przeniesienie do archiwum cz.4
// archfir4.sc
///////////////////////////

//---------------------------------------------

Int Sub AktualizujStanDokumentowMG(int XT, int base)
	// zliczenie iloci dokumentw w katalogach i rodzajach
	SprawdzDokumenty(XT, base, 2500)
EndSub

//---------------------------------------------

// PW->DW
Int Sub KopiujRozliczeniaIDostawy(long idmz)
	int err

	SetKey(srcPW, "dostawy")
	SetKeySeg(srcPW, "typi", 37) : SetKeySeg(srcPW, "idmg", idmz) : SetKeySeg(srcPW, "iddw", 0)

	err=GetRec(srcPW, GT)
	While !err && GetKeySeg(srcPW,"typi") == 37  && GetKeySeg(srcPW,"idmg") == idmz
		KopiujRekord(srcPW, dstPW, -1)
		If GetField(srcPW, "iddw") Then
			KopiujRekord(srcDW, dstDW, GetField(srcPW, "iddw"))
			KopiujNotatke(srcNT, dstNT, "0", 40, GetField(srcPW, "iddw"))
		EndIf
		UsunRekord(srcPW, -1, "srcPW")
		err=GetRec(srcPW, NX)
	Wend
EndSub

//--------------------------------------------
// zmiana= 0 - bez zmian, zmiana= 1 - ustawiam flag w polu typ na 1
// idhandl=0 - brak dokumentu w archiwum
//----
// MZ->PW->DW
Int Sub PrzeniesPozycjeDokumentuMG(long idmg, int zmiana, int idhandl)
	If !idmg Then exit
	
	int err, i = 1
	long id
	string typ

	SetKey(srcMZ, "super") : SetKeySeg(srcMZ, "super", idmg)
	err=GetRec(srcMZ, GE)

	While !err && GetKeySeg(srcMZ, "super") == idmg
		id = GetField(srcMZ, "id")

		KopiujRekord(srcMZ, dstMZ, -1)
		If !KopiujRekord(srcIMZ, dstIMZ, id) Then UsunRekord(srcIMZ, -1, "srcIMZ")
		If !idhandl Then
			SetKey(dstMZ, "id") : SetKeySeg(dstMZ, "id", id)
			If !GetRec(dstMZ, EQ) Then SetField(dstMZ, "idhandl", 0) : UpdateRec(dstMZ, "")
		EndIf
		
		KopiujNotatke(srcNT, dstNT, "16", 37, id)
		KopiujRozliczeniaIDostawy(id)

		If zmiana == 1 Then
			typ = using "%d", GetField(srcMZ, "typi") | 0x01
			SetField(srcMZ, "typi", val(typ)) : SetField(srcMZ, "rejestri", 4)
			UpdateRec(srcMZ, "MZ")
		EndIf
		If zmiana == 0 Then
			UsunRekord(srcMZ, -1, "srcMZ")
			UsunNotatke(srcNT, "16", 37, id)
		EndIf

		err=GetRec(srcMZ, NX)
	Wend
EndSub

//----------------------------------------------

Int Sub WyrownanieRozlMagWArchiwum()
	int err, juzjest, errMZ
	long id, i
	float dTemp, dWart, dKoszt, dZysk,dCena, netto, ilosc, WartoscSp, ZyskDod
	int nRozlMg, wFlag


	SetKey(srcDK0, "data") : SetKeySeg(srcDK0 ,"data", sDataOd)
	err = GetRec(srcDK0, LE)
	While !err && GetKeySeg(srcDK0, "data") != ""
		// odnalezienie dokumentw przeniesionych do archiwum
		If GetField(srcDK0, "subtypi")==2 && GetField(srcDK0, "rejestrVati")==4 Then
			juzjest = 0
			For i = 1 To i > Size(DkPrzenDoArch)
				If DkPrzenDoArch(i) == GetField(srcDK0, "id") Then juzjest = 1
			Next i
			If !juzjest Then
				DkPrzenDoArch( Size(DkPrzenDoArch) ) = GetField(srcDK0, "id")
				grow DkPrzenDoArch, 1
			EndIf
		EndIf
		err = GetRec(srcDK0, PR)
	Wend

	//---

	SetKey(dstDK, "id")
	SetKey(dstIDK, "id")
	SetKey(dstIDP, "id")
	SetKey(dstMZ, "idhandl")
	SetKey(dstDP, "super")
	For i = 1 To i > Size(DkPrzenDoArch)
		SetKeySeg(dstDK, "id", DkPrzenDoArch(i))
		WartoscSp = 0
		If !GetRec(dstDK, EQ) Then
			SetKeySeg(dstDP, "super", DkPrzenDoArch(i)) : SetKeySeg(dstDP, "lp", 0)
			err = GetRec(dstDP, GE)
			ZyskDod = 0
			While !err && GetKeySeg(dstDP, "super") == DkPrzenDoArch(i)
				If !(GetField(dstDP, "typi") & 0x01) Then // 1=komplet lub anulowano
					// sprawdzenie wartoci iloscdorozl i wartTowaru
					netto = ilosc = 0
					SetKeySeg(dstMZ, "idhandl", GetField(dstDP, "id")) : SetKeySeg(dstMZ, "data", "")
					errMZ = GetRec(dstMZ, GE)
					While !errMZ && GetKeySeg(dstMZ, "idhandl") == GetField(dstDP, "id")
						netto += GetField(dstMZ, "wartNetto") + GetField(dstMZ, "wartk")
						ilosc += GetField(dstMZ, "ilosc")
						errMZ = GetRec(dstMZ, NX)
					Wend
					SetField(dstDP, "wartTowaru", netto)
					SetField(dstDP, "iloscDoRozl", GetField(dstDP, "ilosc") - ilosc)
					UpdateRec(dstDP, "dstDP")
					
					// rekord indeksowy
					SetKeySeg(dstIDP, "id", GetField(dstDP, "id"))
					If !GetRec(dstIDP, EQ) Then
						dWart = dKoszt = dZysk = dCena = 0
						dTemp = GetField(dstDP, "iloscdorozl")
						nRozlMg = Sign(dTemp)
						wFlag = GetField(dstDP, "flag")
						
						If !nRozlMg && (wFlag & 0x0100) then
							dWart = GetField(dstDP, "wartTowaru")
							dKoszt = GetField(dstDP, "cenabaztow")
							nRozlMg = Sign(dWart - dKoszt)
						Endif
						
						If nRozlMg then
							SetField(dstIDP, "typi", GetField(dstIDP, "typi")|0x01 )
							dZysk = GetField(dstDP, "zyskdod")
							#ifdef HMHL
							dCena = dTemp
							#else
							dCena = 0.0
							#endif
							dKoszt = GetFIeld(dstDP, "wartTowaru")
							dKoszt += (dZysk * dCena)
							SetField(dstIDP, "wartTowaru", dKoszt)
						Else
							SetField(dstIDP, "wartTowaru", GetField(dstDP, "wartTowaru"))
						Endif
						UpdateRec(dstIDP, "")
					EndIf
					
					ZyskDod += GetField(dstDP, "iloscdorozl")*GetField(dstDP, "zyskDod")
					WartoscSp += netto
				EndIf
				err = GetRec(dstDP, NX)
			Wend
		
			SetKey(srcMG, "idhandl")
			SetKeySeg(srcMG, "idhandl", DkPrzenDoArch(i)) : SetKeySeg(srcMG, "data", "")
			If !GetRec(srcMG, GE) && GetKeySeg(srcMG, "idhandl") == DkPrzenDoArch(i) Then
				If GetField(srcMG, "subtypi")== 78 || GetField(srcMG, "subtypi")== 89 Then
					SetField(dstDK, "rozlmgi", 1)
				EndIf
			EndIf

			SetField(dstDK, "WartoscSp", WartoscSp)
			SetField(dstDK, "ZyskDod", ZyskDod)
			UpdateRec(dstDK, "dstDK")

			SetKeySeg(dstIDK, "id", DkPrzenDoArch(i))
			If !GetRec(dstIDK, EQ) Then
				SetField(dstIDK, "rozlmgi",		GetField(dstDK, "rozlmgi"))
				SetField(dstIDK, "WartoscSp", GetField(dstDK, "WartoscSp"))
				SetField(dstIDK, "zyskdod", 	GetField(dstDK, "zyskdod"))
				UpdateRec(dstIDK, "dstIDK")
			EndIf
		EndIf
	Next i
EndSub

//---------------------

Int Sub SprawdzPowiazanieZDokHandlowym(long idmg, long idhandl)
	If !idmg Then exit
	int err

	SetKey(srcDK, "id") : SetKeySeg(srcDK, "id", idhandl)
	If GetRec(srcDK, EQ) Then
		ImportDKZArchiwum(idhandl, "", sNewDir)
	EndIf
EndSub

//---

Int Sub SprawdzDkWArch(long idmg, long idhandl)		// 1 - istnieje dokument DK, 0 - brak
		If idhandl > 0 Then
			SetKey(dstDK, "id") : SetKeySeg(dstDK, "id", idhandl)
			If GetKey(dstDK, EQ) Then
				SetKey(dstMG, "id") : SetKeySeg(dstMG, "id", idmg)
				If !GetRec(dstMG, EQ) Then
					SetField(dstMG, "oki", 0)
					SetField(dstMG, "idhandl", 0)
					UpdateRec(dstMG, "")
					SetKey(dstIMG, "id") : SetKeySeg(dstIMG, "id", idmg)
					If !GetRec(dstIMG, EQ) Then SetField(dstIMG, "oki", 0) : UpdateRec(dstIMG, "")
				EndIf
			Else
				SprawdzDkWArch = 1
			EndIf
		Else
			SprawdzDkWArch = 1
		EndIf
EndSub

Int Sub PrzeniesRekordyIT(long iddk)
	int err

#ifdef HM
	SetKey(srcIT, "dokumenty") 
	SetKeySeg(srcIT, "iddkmg", iddk)
	err=GetRec(srcIT, GE)

	While !err && GetKeySeg(srcIT, "iddkmg") == iddk
		KopiujRekord(srcIT, dstIT, -1)
		UsunRekord(srcIT, -1, "srcIT")
		err=GetRec(srcIT, NX)
	Wend
#endif
EndSub
//-------------------------------------------
// MG->MZ->PW->DW
#ifdef HMHL
Long Sub PrzeniesDokumentyMagazynowe(String sData)
	int err
	long id, RecordCount
	int t

	SetKey(srcMG, "data") : SetKeySeg(srcMG ,"data", sDataOd)
	err = GetRec(srcMG, LE)
	While !err && GetKeySeg(srcMG, "data") != ""
		RecordCount += 1
		err = GetRec(srcMG, PR)
	Wend

	PopUp(1, "Przenoszenie dokumentw magazynowych.")
	progress.Reset(RecordCount)

	SetKey(srcMG, "id") : SetKeySeg(srcMG,"id", 0)
	err=GetRec(srcMG, GT)

While !err

	If GetField(srcMG, "data") <= sData && GetField(srcMG, "data") != "" Then
		progress.NextOne()
		PopUp(2, "Pozostao " + (using "%d", RecordCount) + " dokumentw.")
		If RecordCount Then RecordCount -= 1

		ZnajdzRekordySerii("MG", GetField(srcMG, "seria"), GetField(srcMG, "dzial"), GetField(srcMG, "okres"), GetField(srcMG, "serianr"), GetField(srcMG, "kod"), GetField(srcMG, "id"))
		id = GetField(srcMG, "id")
	Else
		If GetField(srcMG, "subtypi")== 78 || GetField(srcMG, "subtypi")== 89 Then
			SprawdzPowiazanieZDokHandlowym(GetField(srcMG, "id"), GetField(srcMG, "idhandl"))
		EndIf
	EndIf

	t = GetField(srcMG, "typi")
	If t!=201 && t!=111 && t!=103 && !(t==102 && GetField(srcMG, "subtypi")==2) Then
		CopyFields(srcMG, dstMG)
		InsertRec(dstMG, "dstMG")
	EndIf

	If id Then
//		SetKey(srcMG, "id") : SetKeySeg(srcMG, "id", id)
//		If !GetRec(srcMG, EQ) Then
			PrzeniesDokumentyMagazynowe += 1
			KopiujRekord(srcMG, dstMG, -1)
			If !KopiujRekord(srcIMG, dstIMG, id) Then UsunRekord(srcIMG, -1, "srcIMG")
			KopiujNotatke(srcNT, dstNT, "0", 33, id)

			PrzeniesRekordyIT(id)

			If GetField(srcMG, "idkorekt") && CzyIstniejaKorektyPoDacie(srcMG1, id, sData, "data") Then
				If GetField(srcMG, "subtypi")== 78 || GetField(srcMG, "subtypi")== 89 Then
					SprawdzPowiazanieZDokHandlowym(id, GetField(srcMG, "idhandl"))
					If SprawdzDkWArch(id, GetField(srcMG, "idhandl")) Then
						PrzeniesPozycjeDokumentuMG(id, 1, 1)
					Else
						PrzeniesPozycjeDokumentuMG(id, 1, 0)
					EndIf
				Else
					PrzeniesPozycjeDokumentuMG(id, 1, 1)
				EndIf

				SetField(srcMG, "subtypi", 2) : SetField(srcMG, "rejestrVati", 4)
				UpdateRec(srcMG, "MG")
			Else
				SetKey(srcDK, "id") : SetKeySeg(srcDK, "id", GetField(srcMG, "idhandl"))
				If (GetField(srcMG, "subtypi")== 78 || GetField(srcMG, "subtypi")== 89) && !GetRec(srcDK, EQ) Then
					SetField(srcMG, "subtypi", 2)  : SetField(srcMG, "rejestrVati", 4)
					UpdateRec(srcMG, "MG")

					If SprawdzDkWArch(id, GetField(srcMG, "idhandl")) Then
						PrzeniesPozycjeDokumentuMG(id, 1, 1)
					Else
						PrzeniesPozycjeDokumentuMG(id, 1, 0)
					EndIf
				Else
					PrzeniesPozycjeDokumentuMG(id, 0, 1)

					UsunRekord(srcMG, -1, "srcMG")
					UsunNotatke(srcNT, "0", 33, id)

					UsunRekordyZZ(133, id, 33)
					UsunRekordyZZ(134, id, 33)
				EndIf

			EndIf
//		EndIf
	EndIf

	id = 0
	err=GetRec(srcMG, NX)
Wend

	progress.Reset(0)
	PopUp(2,"")

	// wyrwnanie wartoci i iloci towaru rozliczonego magazynowy w pozycjach handlowych w archiwum
	PopUp(1, "Wyrwnanie stanu rozlicze magazynowych w archiwum.")
	WyrownanieRozlMagWArchiwum()

	PopUp(1,"")
EndSub
#endif

//-------------------------------------------

//	0 - znaleziony, !=0 - kod bdu lub -1
Int Sub ZnajdzDokumentPWwArch(int PW, long iddw)
	SetKey(PW, "pozycje")
	SetKeySeg(PW, "typi", 37)			// 37-powizanie dostawy z pozycj magazynow (baza MZ)
	SetKeySeg(PW, "iddw", iddw)
	SetKeySeg(PW, "idmg", 0)

	ZnajdzDokumentPWwArch = GetKey(PW, GE)

	If !ZnajdzDokumentPWwArch Then
		If GetKeySeg(PW, "iddw")==iddw Then
			ZnajdzDokumentPWwArch = 0
		Else
			ZnajdzDokumentPWwArch = -1
		EndIf
	EndIf
EndSub

//---------------------------------------------
#ifdef HMHL
Long Sub UtworzDokumentMG(int magazyn)
	int serianr, err

	SetKey (srcXT, "id")
	SetKeySeg (srcXT, "id", magazyn)
	GetRec (srcXT, EQ)

	srcOMG.SetKey ("seria")
	srcOMG.SetKeySeg ("seria", "sARC")
	srcOMG.SetKeySeg ("dzial", magazyn)
	srcOMG.SetKeySeg ("okres", 2201)
	err = srcOMG.GetRec(LT)
	if !err && srcOMG.GetKeySeg("seria")=="sARC" && srcOMG.GetKeySeg("dzial")==magazyn && srcOMG.GetKeySeg("okres")==2200 then
		serianr = srcOMG.GetField("serianr")
	endif	
	serianr+=1

	long lId
	lId = 65535		//@Mir
	srcOMG.SetKey("id") : srcOMG.SetKeySeg("id", lId)
	err = srcOMG.GetRec(GT)
	While !err && lId + 1 == srcOMG.GetKeySeg("id")
		lId += 1
		err = srcOMG.GetRec(NX)
	Wend
	lId += 1

	srcOMG.Clear()
	srcOMG.SetField ("id", lId)
	srcOMG.SetField ("data", sDataOd)
	srcOMG.SetField ("datasp", sDataOd)
	srcOMG.SetField ("termin", sDataOd)
	srcOMG.SetField ("flag", 256)
	srcOMG.SetField ("typi", 201)
	srcOMG.SetField ("subtypi", 74)
	srcOMG.SetField ("opis", "Wprowadzenie stanu po archiwizacji")
	srcOMG.SetField ("nazwa", "Protok wprowadzenia")
	srcOMG.SetField ("seria", "sARC")		//(ALT+255)+'sARC'
	srcOMG.SetField ("serianr", serianr)
	srcOMG.SetField ("kod", (using "%.4d", serianr) + "/" + Mid(Data(), 3, 2) + "/ARC-" + GetField(srcXT, "kod"))
	srcOMG.SetField ("rejestrVati",64)
	srcOMG.SetField ("rodzaj", 3500)
	srcOMG.SetField ("katalog", 2500)
	srcOMG.SetField ("osoba", "Admin")
	srcOMG.SetField ("okres", 2200)
	srcOMG.SetField ("oki", 1)
	srcOMG.SetField ("dzial", magazyn)
	srcOMG.SetField ("magazyn", magazyn)
	srcOMG.SetField ("typ_dk", "PW")
	srcOMG.Insert ()
	UtworzDokumentMG = lId
EndSub
#endif
//--------------------------------------------

Int Sub CzyIstniejeRozliczenie(int PW, long iddw)
	If !iddw Then exit
	int err

	SetKey(PW, "pozycje")

	SetkeySeg(PW, "typi", 37) : SetKeySeg(PW, "iddw", iddw) : SetKeySeg(PW, "idmg", 0)
	err = GetKey(PW, GE)
	If !err && GetKeySeg(PW, "iddw") == iddw Then CzyIstniejeRozliczenie = 1 : exit

//	SetkeySeg(PW, "typ", "39") : SetKeySeg(PW, "iddw", iddw) : SetKeySeg(PW, "idmg", 0)
//	err = GetKey(PW, GE)
//	If !err && GetKeySeg(PW, "iddw") == iddw Then CzyIstniejeRozliczenie = 1 : exit
EndSub

//---------------------------------------------

float dwIlosc,dwIloscdosp,dwWartoscDosp,dwIloscPz,dwStan,dwWartoscSt,dwCena
float fCenaIlosc,fCenaWartosc,fPrzecena

int sub ZliczPWKorekty(int PW1, long id )
	long idy(1)
	int ccnt
	SetKey(PW1, "idkoryg")
	SetKeySeg(PW1, "idkoryg",id)
	err=GetRec(PW1, GE)
	while !err && GetKeySeg(PW1, "idkoryg")==id
		fCenaIlosc += GetField(PW1, "ilosc")
		fCenaWartosc += GetField(PW1, "wartosc")
		if idy(size(idy)) then grow idy,1
		idy(size(idy)) = GetField(PW1,"id")
		err=GetRec(PW1, NX)
	wend
	for ccnt=1 to !idy(1) || ccnt>size(idy)
		ZliczPWKorekty(PW1, idy(ccnt) )
	next ccnt
endsub

int sub ZliczPW(int PW, int PW1, string typ, long iddw)
	SetKey(PW, "pozycje")
	SetKeySeg(pw, "typi",val(typ))
	SetKeySeg(pw, "iddw", iddw)
	SetKeySeg(pw, "idmg", 0)
	err=GetRec(pw, GE)
	while !err && GetField(pw,"iddw")==iddw && GetField(pw,"typi")==val(typ)
		if GetField(PW,"flag")&8 then // dostawa tworzca
			dwIlosc -= GetField(pw,"ilosc")
			// obliczanie ceny
			fCenaIlosc += GetField(pw,"ilosc")
			fCenaWartosc += GetField(pw,"wartosc")
			ZliczPWKorekty(PW1, GetField(pw,"id") )
		endif
		if GetField(pw,"subtypi")==91 then
			if Sign(GetField(pw,"ilosc"), 4)>0 then fPrzecena -= GetField(pw,"wartosc")/GetField(pw,"ilosc")
			if Sign(GetField(pw,"ilosc"), 4)<0 then fPrzecena += GetField(pw,"wartosc")/GetField(pw,"ilosc")
		endif
		if GetField(pw,"flag")&16 then dwIloscPz-=GetFIeld(pw,"ilosc") // przychd do magazynu
		dwIloscDosp-=GetFIeld(pw,"ilosc")
		if typ!="26" then	dwStan-=GetFIeld(pw,"ilosc") // nie rezerwacja

		dwWartoscDosp-=GetFIeld(pw,"wartosc")
		if typ!="26" then	dwWartoscSt -= GetField(pw,"wartosc") // nie rezerwacja
		
		err=GetRec(pw,NX)
	wend
endsub

int sub ZliczWartosci(int PW, int PW1, long iddw, long idtw)
	dwCena = dwIlosc = dwIloscdosp = dwWartoscDosp = dwIloscPz = dwStan = dwWartoscSt =0
	fCenaIlosc = fCenaWartosc = fPrzecena=0

	if idtw<0 then ZliczPW(PW, PW1, "39",iddw)		// dostawy z utworzone dok w buforze maj -idtw
	if idtw>=0 then
		ZliczPW(PW, PW1, "37",iddw)
		ZliczPW(PW, PW1, "26",iddw)
	endif
	if Sign(fCenaIlosc) then dwCena = fCenaWartosc/fCenaIlosc + fPrzecena
endsub

//--------------------------------------------
// tworzy rekord MZ i PW, aktualizuje stan dostawy w firmie i w archiwum
// zn - znacznik, zn="f" - aktualizuje stan w firmie, zn="a" - w archiwum, zn="fa" - w firmie i arch.
#ifdef HMHL
Int Sub AktualizujPozycje(long iddw, long super, string zn)
	int err, lp, w_ok
	float l_ilosc, l_wartosc
	long iddkmg

	string DataRozliczenia = "2090-01-01"
	long idtw = GetField(srcDW, "idtw")

If zn=="f" || zn=="fa" Then

	l_ilosc = GetField(srcDW, "stan")
	l_wartosc = GetField(srcDW, "wartoscst")

	SetKey(srcPW, "pozycje")
	SetkeySeg(srcPW, "typi", 37) : SetKeySeg(srcPW, "iddw", iddw) : SetKeySeg(srcPW, "idmg", 0)
	err = GetRec(srcPW, GE)
	While !err && GetKeySeg(srcPW, "iddw") == iddw
		l_ilosc += GetField(srcPW, "ilosc")
		l_wartosc += GetField(srcPW, "wartosc")

		// znajduj najwczeniejszy dok. PW - przychodowy, i przepisuj 'iddkmg' do DW.iddkpz
		If Sign(GetField(srcPW, "ilosc"), 4) < 0 && GetField(srcPW, "data") < DataRozliczenia Then
			DataRozliczenia = GetField(srcPW, "data")
			iddkmg = GetField(srcPW, "iddkmg")
		EndIf

		err=GetRec(srcPW, NX)
	Wend

	If !Sign(l_ilosc, 4) && !Sign(l_wartosc, 2) Then
		super = iddkmg
	Else
		SetKey(srcTW, "id")
		SetKeySeg(srcTW, "id", idtw)
		GetRec(srcTW, EQ)

		srcOMZ.SetKey ("super")
		srcOMZ.SetKeySeg ("super", super+1)
		srcOMZ.SetKeySeg ("lp", 0)
		err = srcOMZ.GetKey (LT)
		If !err && srcOMZ.GetKeySeg("super") == super Then
			lp = srcOMZ.GetKeySeg ("lp") + 1
		Else
			lp = 1
		EndIf
		
		srcOMZ.Clear ()
		srcOMZ.SetField ("lp", lp)
		srcOMZ.SetField ("flag", 768)
		srcOMZ.SetField ("subtypi", 201)
		srcOMZ.SetField ("super", super)
		srcOMZ.SetField ("idtw", idtw)
		srcOMZ.SetField ("kod", GetField(srcTW, "kod"))
		srcOMZ.SetField ("jm", GetField(srcTW, "jm"))
		srcOMZ.SetField ("jmwp", GetField(srcTW, "jm"))
		srcOMZ.SetField ("data", sDataOd)
		srcOMZ.SetField ("opis", GetField(srcTW, "nazwa"))
		srcOMZ.SetField ("ilosc", l_ilosc*(-1))
		srcOMZ.SetField ("iloscwp", l_ilosc*(-1))
		srcOMZ.SetField ("iloscdorozl", l_ilosc*(-1))
		srcOMZ.SetField ("magazyn", GetField(srcDW, "magazyn"))
		If Sign(l_ilosc, 4) Then srcOMZ.SetField ("cena", l_wartosc/l_ilosc)
		srcOMZ.SetField ("wartTowaru", l_wartosc*(-1))
		srcOMZ.SetField ("wartNetto", l_wartosc*(-1))
		srcOMZ.SetField ("przychod", l_wartosc*(-1))
		srcOMZ.Insert	()

//		If !srcOMZ.GetField("id") Then
//			srcOMZ.SetKey ("id")
//			srcOMZ.GetRec (LS)
//		EndIf
		
		//-----------------
		// utwrz rekord PW 
		Clear(srcPW)
		SetField( srcPW, "flag", 24)
		SetField( srcPW, "subtypi", 89)
		SetField( srcPW, "typi", 37)
		SetField( srcPW, "iddkmg", super)
		SetField( srcPW, "iddw", iddw)
		SetField( srcPW, "idtw", idtw)
		SetField( srcPW, "idmg", srcOMZ.GetField("id"))
		SetField( srcPW, "ilosc", l_ilosc*(-1))
		SetField( srcPW, "wartosc", l_wartosc*(-1))
		SetField( srcPW, "data", sDataOd)
		InsertRec(srcPW, "srcPW")
	EndIf

	//---------------------------
	// aktualizacja stanu dostawy

	ZliczWartosci(srcPW, srcPW1, iddw, idtw)
	SetField (srcDW, "data", DataRozliczenia)
	SetField (srcDW, "data", sDataOd)
	If super Then SetField (srcDW, "iddkpz", super)
	SetField (srcDW, "ilosc", dwIlosc)
	SetField (srcDW, "iloscPz", dwIloscPz)
	UpdateRec (srcDW, "DW")
EndIf

	If zn=="a" || zn=="fa" Then
		ZliczWartosci(dstPW, dstPW1, iddw, idtw)
		SetKey (dstDW, "id") : SetKeySeg (dstDW, "id", iddw)
		If !GetRec (dstDW, EQ) Then
			SetField (dstDW, "iloscdosp", dwIloscdosp)
			SetField (dstDW, "stan", dwStan)
			SetField (dstDW, "wartoscdosp", dwWartoscDosp)
			SetField (dstDW, "wartoscst", dwWartoscSt)
			SetField (dstDW, "iloscPz", dwIloscPz)
			SetField (dstDW, "cena", dwCena)

			w_ok=0
			If GetField(dstDW, "numer")>0 && Sign(GetField(dstDW, "stan"),4) then w_ok=1
			If GetField(dstDW, "numer")<0 && Sign(GetField(dstDW, "iloscdosp"),4) then w_ok=1
			If (w_ok && GetField(dstDW, "typi")==0) || (!w_ok && GetField(dstDW, "typi")!=0) then
				SetField(dstDW,"typi",w_ok)
			Endif
			UpdateRec (dstDW, "DW")
		EndIf
	EndIf

EndSub

//----------------------------------------------
// 1 - istnieje rezerwacja, 0 - brak rezerwacji
Int Sub AnalizujRezerwacje(int PW, int archDW, long iddw)
	If !iddw Then exit
	int err, errDW

	SetKey(PW, "pozycje")
	SetKeySeg(PW, "typi", 26) : SetKeySeg(PW, "iddw", iddw) : SetKeySeg(PW, "idmg", 0)
	err = GetRec(PW, GE)
	
	If !err && GetKeySeg(PW, "iddw") == iddw Then
		SetKey(archDW, "id") : SetKeySeg(archDW, "id", iddw)
		errDW = GetRec(archDW, EQ)
	EndIf

	While !err && GetKeySeg(PW, "iddw") == iddw
		If !errDW Then
			DodajWartosc(archDW, "iloscdosp", GetField(PW, "ilosc"))
			DodajWartosc(archDW, "wartoscdosp", GetField(PW, "wartosc"))
		EndIf
		AnalizujRezerwacje = 1
		err = GetRec(PW, NX)
	Wend
	If !errDW && AnalizujRezerwacje Then UpdateRec(archDW, "dstDW")
EndSub

record rMagazyn
	long idDWS(1)
	int count
	int idCount
		
	int sub GoToFirst()
		idCount = 1
	endsub
	
	int sub GoToNext()
		if idCount < size(idDWS) then
			idCount = idCount + 1
			GoToNext = 0
		else
			GoToNext = 1
		endif
	endsub
	
	long sub GetAt()
		if idCount <= size(idDWS) then
			GetAt = idDWS(idCount)
		else
			GetAt = 0
		endif
	endsub	

	long sub Get()
		if count >= 100 then
			grow idDWS,1
			count = 0
		endif
		Get = idDWS(size(idDWS))
	endsub	

	long sub Set(long id)
		idDWS(size(idDWS)) = id
	endsub	
	
	long sub Use()
		if count < 100 then
			count = count + 1
		else
			grow idDWS,1
			count = 0
		endif
		Use = idDWS(size(idDWS))
	endsub
endrec

//---------------------------------------------
// DW
Int Sub PrzeniesDostawy(String sData)
	int err
	rMagazyn Magazyny(255) // dokumenty wprowadzenia stanu
	long id, RecordCount, magazyn
	int i

	SetKey(srcDW, "id") : SetKeySeg(srcDW, "id", 0)
	err=GetRec(srcDW, GT)

	PopUp(1, "Analiza dostaw.")
	RecordCount = GetRecordCount(srcDW)
	progress.Reset(RecordCount)

	While !err
		progress.NextOne()
		PopUp(2, "Pozostao " + (using "%d", RecordCount) + " dostaw.")
		RecordCount =	RecordCount - 1

		If !ZnajdzDokumentPWwArch(dstPW, GetField(srcDW, "id")) && GetField(srcDW, "magazyn") Then
			id = GetField(srcDW, "id")
			magazyn = GetField(srcDW, "magazyn")

			If !AnalizujRezerwacje(srcPW, dstDW, id) && !Sign(GetField(srcDW, "iloscdosp"), 4) && !CzyIstniejeRozliczenie(srcPW, id) Then
				AktualizujPozycje(id, 0, "a")
				UsunRekord(srcDW, -1, "srcDW")
				UsunNotatke(srcNT, "0", 40, id)
			Else
				// jeli nie utworzono dokumentu magazynowego dla danego magazynu
				// lub jesli dokument zawiera wiecej niz 100 pozycje
				If Magazyny(magazyn).Get() == 0 Then
					Magazyny(magazyn).Set(UtworzDokumentMG( magazyn ))
				EndIf
				AktualizujPozycje(id, Magazyny(magazyn).Use(), "fa")
			EndIf
		EndIf

		err=GetRec(srcDW, NX)
	Wend

	float netto
	For i = 1 To 255 < i
		Magazyny(i).GoToFirst()
	Next i	
	
	For i = 1 To 255 < i
		netto = 0
		If (Magazyny(i).GetAt() != 0) Then
			do		
				SetKey (srcMZ, "super")
				SetKeySeg (srcMZ, "super", Magazyny(i).GetAt())
				SetKeySeg (srcMZ, "lp", 1)
				err = GetRec (srcMZ, GE)
				While !err && GetKeySeg(srcMZ, "super") == Magazyny(i).GetAt()
					if GetField(srcMZ, "typ")!="1" then netto += GetField(srcMZ, "wartNetto")		// 1=komplet lub anulowana
					err=GetRec (srcMZ, NX)
				Wend
				srcOMG.SetKey ("id")
				srcOMG.SetKeySeg ("id", Magazyny(i).GetAt())
				srcOMG.GetRec (EQ)
				srcOMG.SetField ("netto", netto)
				srcOMG.SetField ("przychod", netto)
				srcOMG.Update()
				netto = 0
			loop while !(Magazyny(i).GoToNext())
		EndIf
	Next i

	progress.Reset(0)

	PopUp(1,"")
	PopUp(2,"")

	PopUp(1, "Aktualizacja stanu dok. magazynowych.")

	AktualizujStanDokumentowMG(srcXT, srcMG)
	AktualizujStanDokumentowMG(dstXT, dstMG)

	PopUp(1,"")
EndSub
#endif

//----------------------------------------------------------------------------------------------

Int Sub UtworzRekordBDZZ(int BD, int ZZ, int typ)
	Clear(ZZ)
	SetField(ZZ, "typi",typ)
	SetField(ZZ, "baza1",0x1c)
	SetField(ZZ, "id1",GetField(bd,"id"))
	SetField(ZZ, "baza2",20)
	SetField(ZZ, "id2",GetField(bd,"magazyn")*0x1000000+GetField(bd,"khid"))
	SetField(ZZ, "kod1",GetField(bd,"kod"))
	SetField(ZZ, "kod2",GetField(bd,"khkod"))
	SetField(ZZ, "data",GetField(bd,"data"))
	SetField(ZZ, "termin",GetField(bd,"data"))
	SetField(ZZ, "cena",GetField(bd,"netto")+GetField(bd,"vat"))
	SetField(ZZ, "opis",GetField(bd,"nazwa"))
#ifdef HMHL
	SetField(ZZ, "magazyn",GetField(bd,"magazyn"))
#endif
	InsertRec(zz, "ZZ")
EndSub

//-------------------------------------------
// zwraca sum pozycji z dokumentw

Float Sub SumaPozHandl(int DP, long idBP)
	int err
	
	SetKey(DP,"idhandl")
	SetKeySeg(DP,"idhandl",idBP) : SetKeySeg(DP,"data","0000-00-00")
	err=GetRec(DP,GE)
	While !err && GetKeySeg(DP, "idhandl") == idBP
		SumaPozHandl += GetField(DP, "ilosc")
		err=GetRec(dp,NX)
	Wend
EndSub

//-------------------------------------------

Int Sub PrzeniesPozDokBP(long idbd, int usun)
	If !idbd Then exit

	long id	
	int err
	string typ
	float iloscdorozl

	SetKey(srcBP, "super") : SetKeySeg(srcBP, "super", idbd)
	err=GetRec(srcBP, GE)
	While !err && GetKeySeg(srcBP, "super") == idbd
		id = GetField(srcBP, "id")
		iloscdorozl = GetField(srcBP, "ilosc") - SumaPozHandl(dstDP, id)
		SetField(srcBP, "iloscdorozl", iloscdorozl)
		KopiujRekord(srcBP, dstBP, -1)
		KopiujNotatke(srcNT, dstNT, "16", 30, id)
		#ifdef HMHL
		If GetField(dstBP, "rezerwacja") Then UsunRezerwacje( GetField(dstBP, "rezerwacja") )
		#endif
		If usun Then
			#ifdef HMHL
			If GetField(srcBP, "rezerwacja") Then UsunRezerwacje( GetField(srcBP, "rezerwacja") )
			#endif
			SetKey(srcBP, "super") : SetKeySeg(srcBP, "super", idbd)
			GetRec(srcBP, GE)
			UsunRekord(srcBP, -1, "srcBP")
			UsunNotatke(srcNT, "16", 30, id)
		EndIf
		err=GetRec(srcBP, NX)
	Wend
EndSub

//-----------------------

Int Sub PrzeniesRekordyBD_ZZ(long id, string typ, int usun)
	int err
	SetKey(srcZZ, "cross1")
	SetKeySeg(srcZZ, "typi", val(typ)) : SetKeySeg(srcZZ, "baza1", 28)
	SetKeySeg(srcZZ, "id1", id)
	err = GetRec(srcZZ, GE)
	While !err && GetKeySeg(srcZZ, "id1") == id
		KopiujRekord(srcZZ, dstZZ, -1)
		If usun Then UsunRekord(srcZZ, -1, "srcZZ")
		err = GetRec(srcZZ, NX)
	Wend
EndSub

//----------------------
// 0- brak, 1- istnieje, 2-istnieje jako przeniesiony do archiwum
Int Sub CzyIstniejeDokDKdoZamowienia(int DK, long id)
	int err

	SetKey(DK, "id")

	SetKey(srcZZ, "cross1")
	SetKeySeg(srcZZ, "typi", 144) : SetKeySeg(srcZZ, "baza1", 28)
	SetKeySeg(srcZZ, "id1", id)
	err = GetRec(srcZZ, GE)
	While !err && GetKeySeg(srcZZ, "id1") == id
		SetKeySeg(DK, "id", GetField(srcZZ, "id2"))
		If !GetRec(DK, EQ) Then
			If GetField(DK, "subtypi")==2 && GetField(DK, "rejestrVati")==4 Then
				CzyIstniejeDokDKdoZamowienia = 2
			Else
				CzyIstniejeDokDKdoZamowienia = 1 : exit
			EndIf
		EndIf
		err = GetRec(srcZZ, NX)
	Wend
EndSub

//---------------------

Int Sub PrzeniesDokZBuforaBD(string sData)
	int err, err1, temp
	long id
	long RecordCount

	SetKey(srcBD, "data") : SetKeySeg(srcBD ,"data", sDataOd)
	err = GetKey(srcBD, LE)
	While !err && GetKeySeg(srcBD, "data") != ""
		RecordCount += 1
		err = GetKey(srcBD, NX)
	Wend

	SetKey(srcBD, "id") : SetKeySeg(srcBD, "id", 0)
	err=GetRec(srcBD, GT)

	PopUp(1, "Przenoszenie dokumentw z bufora.")
	progress.Reset(RecordCount)

	While !err
		If GetField(srcBD, "data") <= sData && (GetField(srcBD, "typi")==203 || GetField(srcBD, "typi")==1) Then
			progress.NextOne()
			PopUp(2, "Pozostao " + (using "%d", RecordCount) + " dokumentw.")
			RecordCount =	RecordCount - 1
			id = GetField(srcBD, "id")

			If GetField(srcBD, "oki") == 1 && !CzyIstniejeDokDKdoZamowienia(srcDK, id) Then
				KopiujRekord(srcBD, dstBD, -1)
				KopiujNotatke(srcNT, dstNT, "0", 28, id)

				UsunRekord(srcBD, -1, "srcBD")
				UsunNotatke(srcNT, "0", 28, id)

				PrzeniesPozDokBP(id, 1)
				PrzeniesRekordyBD_ZZ(id, "137", 1)	// zamwienia wasnego
				PrzeniesRekordyBD_ZZ(id, "138", 1)	// zamwienia obcego
				PrzeniesRekordyBD_ZZ(id, "144", 1)	// do dokumentw handlowych
			Else
				temp = CzyIstniejeDokDKdoZamowienia(srcDK, id)
				If temp==1 Then SetField(srcBD, "oki", 0)
				KopiujRekord(srcBD, dstBD, -1)
				KopiujNotatke(srcNT, dstNT, "0", 28, id)
				PrzeniesPozDokBP(id, 0)
			
				If GetField(srcBD, "oki")==0 && GetField(srcBD, "typi") == 203 Then
					UtworzRekordBDZZ(srcBD, dstZZ, 0x89)	// zamwienia wasnego
				EndIf
				If GetField(srcBD, "oki")==0 && GetField(srcBD, "typi") == 1 Then
					UtworzRekordBDZZ(srcBD, dstZZ, 0x8A)	// zamwienia obcego
				EndIf

				// Przenoszenie rekordw ZZ do dokumentw handlowy do zamwienia, ZZ.typ="144"
				SetKey(srcZZ, "cross1")
				SetKeySeg(srcZZ, "typi", 144) : SetKeySeg(srcZZ, "baza1", 28)
				SetKeySeg(srcZZ, "id1", id)
				err1 = GetRec(srcZZ, GE)
				While !err1 && GetKeySeg(srcZZ, "id1") == id
					SetKey(dstDK, "id") : SetKeySeg(dstDK, "id", GetField(srcZZ, "id2"))
					If !GetRec(dstDK, EQ) Then KopiujRekord(srcZZ, dstZZ, -1)
					err1 = GetRec(srcZZ, NX)
				Wend
			EndIf
		EndIf
		err=GetRec(srcBD, NX)
	Wend

	progress.Reset(0)
	PopUp(1,"")
	PopUp(2,"")
EndSub
