//"autoeksp.sci","Auto eksport",12006,0,2.0.0,SYSTEM
//"Eksport - include",12005,14,16
/////////////////////////////////////////
// autoeksp.sci
// Auto eksport
/////////////////////////////////////////
limit 10000
#ifdef HM
#define HMHL
#endif
#ifdef HL
#define HMHL
#endif

long	DECLARE EksportKodTypDokumentu(long id, string baza)
int		DECLARE EksportKorekt(long id, string baza)
int		DECLARE EksportDokPozMagazynoweDoHandl(long idDK)
int		DECLARE EksportDokPozHandlDoMag(long idMG)
int		DECLARE EksportKodTowaru(long idTW)
int		DECLARE EksportKodKontrahenta(long idKH, string tekst)
int		DECLARE EksportKodMagazynu(long idMAG, string pole)
String	DECLARE GetRejestrPlatnosciPN(long idPN)

string DECLARE FieldNumToDesc(int type)
int		DECLARE WczytajOpis( string bastype )
int 	DECLARE EksportRekord(string BasName, long id)

#define szSectionOddzDokPN 					"Z oddziau. Dok. pieniny"
#define szSectionOddzDokSprz				"Z oddziau. Dok. sprzeday"
#define szSectionOddzDokZak					"Z oddziau. Dok. zakupu"
#define szSectionOddzDokMG					"Z oddziau. Dok. magazynowy"

#define szSectionOddzDokPowiazany 	"Dokument powizany"
#define szSectionPosDok							"Pozycja dokumentu"

#define szSectionOddzIdKorekty 			"Korekta dokumentu"
#define szSectionOddzIdDokKoryg 		"Dokument korygowany"
#define szSectionOddzIdDokNadrz 		"Dokument nadrzdny"
#define szSectionOddzIdDokPodrz 		"Dokument podrzdny"

#define szSectionOddzRozliczenie		"Handel_RL"

#define szSectionVATKasowy				"VAT kasowy"
#define XTtypdkKWM			90		//korekta wartoci magazynu

int DOODDZIALU = 1
int VATKASOWY = 0
Record rField
	String FieldName[20]
	String FieldName_[20]
	String Type[20]
EndRec

rField rFields(1)

#ifdef HM
	VATKASOWY = 1
#endif
#ifdef FP
	VATKASOWY = 1
#endif

int DECLARE PrintError(String msg)

//---------------------------------------------------------------------------
Int Sub	EksportRekord(string BasName, long id)
//---------------------------------------------------------------------------
	BaseAll bas
	If bas.SetBase(BasName) then PrintError("Bd otwarcia " +BasName)
	bas.Open()

	int i

	bas.SetKey("id")
	bas.SetKeySeg("id", id)
	If !bas.GetRec(EQ) Then 
		WczytajOpis(BasName)
		For i=1 to i > size (rFields)
			Select Case rFields(i).Type
				Case "FT_INT"
					eksport.Pole(rFields(i).FieldName_, (Using "%l",		bas.GetField(rFields(i).FieldName)))
				Case "_FLOAT_"
					eksport.Pole(rFields(i).FieldName_, (Using "%.12f", bas.GetField(rFields(i).FieldName)))
				Case Else
					eksport.Pole(rFields(i).FieldName_, bas.GetField(rFields(i).FieldName))
			EndSelect
		Next i
	EndIf

	bas.Close()
EndSub

//---------------------------------------------------------------------------
string sub FieldNumToDesc(int type)
//---------------------------------------------------------------------------
	select case type
	case 0
		FieldNumToDesc = "FT_STRING"
	case 1
		FieldNumToDesc = "FT_INT"
	case 2
		FieldNumToDesc = "FT_FLOAT"
	case 3
		FieldNumToDesc = "FT_DATE"
	case 4
		FieldNumToDesc = "FT_TIME"
	case 5
		FieldNumToDesc = "FT_DECIMAL"
	case 6
		FieldNumToDesc = "FT_MONEY"
	case 7
		FieldNumToDesc = "FT_LOGICAL"
	case 8
		FieldNumToDesc = "FT_NUMERIC"
	case 9
		FieldNumToDesc = "FT_BFLOAT"
	case 10
		FieldNumToDesc = "FT_LSTRING"
	case 11
		FieldNumToDesc = "FT_ZSTRING"
	case 14
		FieldNumToDesc = "FT_UBINARY"
	case 15
		FieldNumToDesc = "FT_AUTOINC"
	case else
		PrintError("nieznany typ pola")
	endselect
endsub

//---------------------------------------------------------------------------
int sub WczytajOpis( string bastype )
//---------------------------------------------------------------------------
	int f
	int nFields

	nFields=0
	shrink rFields, -1
	BASEDEF bdef

	If bdef.GetInfo( bastype ) then PrintError("Nieznana baza "+bastype)
	For f=1 to f > bdef.GetFieldCount()
		nFields += 1
		if nFields != 1 then grow rFields, 1
		rFields(nFields).FieldName = lcase(bdef.GetFieldName(f))
		Select case lCase(rFields(nFields).FieldName)
			case "typi","subtypi","znaczniki","rejestrvati","rejestri","oki","rozlmgi","stvati","vatspi","zaokragi","jmdefi","metodai","przeliczi","grupaceni","exp_fki","limiti","plattypi","bazai","rodzzaki","typcenyzki","rodzaji","infoi"
				rFields(nFields).FieldName_=mid(rFields(nFields).FieldName,1,len(rFields(nFields).FieldName)-1)
			case else
				rFields(nFields).FieldName_=rFields(nFields).FieldName
		endSelect
		buf = ucase(FieldNumToDesc(bdef.GetFieldType(f)))
		rFields(nFields).Type = buf
		If buf == "FT_FLOAT" || buf == "FT_MONEY" || buf == "FT_NUMERIC" || buf == "FT_BFLOAT" Then
			rFields(nFields).Type = "_FLOAT_"
		EndIf
	Next f
endsub

//---------------------------------------------------------------------------
int Sub EksportDokPozHandlDoMag(long idMG)
//---------------------------------------------------------------------------
#ifdef HMHL
	long err, err1
	BaseAll basDK
	BaseAll basDP
	BaseAll basMG
	BaseAll basMZ
	BaseAll basZZ

	If basDK.SetBase("DK") then PrintError("Bd otwarcia DK")
	basDK.Open()
	If basDP.SetBase("DP") then PrintError("Bd otwarcia DP")
	basDP.Open()
	If basMG.SetBase("MG") then PrintError("Bd otwarcia MG")
	basMG.Open()
	If basMZ.SetBase("MZ") then PrintError("Bd otwarcia MZ")
	basMZ.Open()
	If basZZ.SetBase("ZZ") then PrintError("Bd otwarcia ZZ")
	basZZ.Open()


	basMG.SetKey("id") : basMG.SetKeySeg("id", idMG)
	basMG.GetRec(EQ)
	basDK.SetKey("id") : basDK.SetKeySeg("id", basMG.GetField("idhandl"))
	If !basDK.GetRec(EQ) Then
		eksport.PoczatekPodsekcji( szSectionOddzDokPowiazany )
			eksport.Pole("typ", ToString(basDK.GetField(funZnaki("typi"))))
			eksport.Pole("kod", basDK.GetField("kod"))

			// aktualizowane pola dokumentu DK
			eksport.Pole("rozlmg", ToString(basDK.GetField(funZnaki("rozlmgi"))))
			eksport.Pole("ok", ToString(basDK.GetField(funZnaki("oki"))))
			eksport.Pole("wartoscSp", (Using "%.12f", basDK.GetField("wartoscSp")))
			eksport.Pole("wplaty", (Using "%.12f", basDK.GetField("wplaty")))
			eksport.Pole("zyskdod", (Using "%.2f", basDK.GetField("zyskdod")))
			
			// Pozycje dokumentu
			basDP.SetKey("id")
			basMZ.SetKey("super") : basMZ.SetKeySeg("super", idMG) : basMZ.SetKeySeg("lp", 0)
			err1 = basMZ.GetRec(GE)
			While !err1 && basMZ.GetKeySeg("super") == idMG
				eksport.PoczatekPodsekcji ( szSectionPosDok )
					eksport.Pole ( "lpMZ", (Using "%l", basMZ.GetField("lp")) )
					basDP.SetKeySeg( "id", basMZ.GetField("idhandl"))
					If !basDP.GetRec(EQ) Then
						eksport.Pole( "lpDP", (Using "%l", basDP.GetField("lp")) )
						eksport.Pole( "kodTW", basDP.GetField("kod") )
						// aktualizowane pola pozycji dokumentu DK
						eksport.Pole( "wartTowaru", (Using "%.12f", basDP.GetField("wartTowaru")) )
						eksport.Pole( "iloscdorozl", (Using "%.12f", basDP.GetField("iloscdorozl")) )
						eksport.Pole( "rozlhandl", (Using "%.12f", basDP.GetField("rozlhandl")) )
					Else
						eksport.Pole("lpDP", "0")
					EndIf
				eksport.KoniecSekcji()
				err1 = basMZ.GetRec(NX)				
			Wend
		eksport.KoniecSekcji()
	EndIf

	// eksport zwizkw z innymi dokumentami, jeli s ...

	basZZ.SetKey("cross2") : basZZ.SetKeySeg("typi", 151) : basZZ.SetKeySeg("baza1", 33) : basZZ.SetKeySeg("id2", idMG)
	err = basZZ.GetRec(GE)
	
	if !err && basZZ.GetField("typi") == 151 && basZZ.GetField("baza1") == 33 && basZZ.GetField("id2") == idMG then
		err = basDK.GetRecById(basZZ.GetField("id1"))
		If !err Then
			eksport.PoczatekPodsekcji( szSectionOddzDokPowiazany )
				eksport.Pole("typ", ToString(basDK.GetField(funZnaki("typi"))))
				eksport.Pole("kod", basDK.GetField("kod"))

				// aktualizowane pola dokumentu DK
				eksport.Pole("rozlmg", ToString(basDK.GetField(funZnaki("rozlmgi"))))
				eksport.Pole("ok", ToString(basDK.GetField(funZnaki("oki"))))
				eksport.Pole("wartoscSp", (Using "%.12f", basDK.GetField("wartoscSp")))
				eksport.Pole("wplaty", (Using "%.12f", basDK.GetField("wplaty")))
				eksport.Pole("zyskdod", (Using "%.2f", basDK.GetField("zyskdod")))
				
				// Pozycje dokumentu
				basDP.SetKey("id")
				basMZ.SetKey("super") : basMZ.SetKeySeg("super", idMG) : basMZ.SetKeySeg("lp", 0)
				err1 = basMZ.GetRec(GE)
				While !err1 && basMZ.GetKeySeg("super") == idMG
					eksport.PoczatekPodsekcji ( szSectionPosDok )
						eksport.Pole ( "lpMZ", (Using "%l", basMZ.GetField("lp")) )
						basDP.SetKeySeg( "id", basMZ.GetField("idhandl"))
						If !basDP.GetRec(EQ) Then
							eksport.Pole( "lpDP", (Using "%l", basDP.GetField("lp")) )
							eksport.Pole( "kodTW", basDP.GetField("kod") )
							// aktualizowane pola pozycji dokumentu DK
							eksport.Pole( "wartTowaru", (Using "%.12f", basDP.GetField("wartTowaru")) )
							eksport.Pole( "iloscdorozl", (Using "%.12f", basDP.GetField("iloscdorozl")) )
							eksport.Pole( "rozlhandl", (Using "%.12f", basDP.GetField("rozlhandl")) )
						Else
							eksport.Pole("lpDP", "0")
						EndIf
					eksport.KoniecSekcji()
					err1 = basMZ.GetRec(NX)				
				Wend
			eksport.KoniecSekcji()
		EndIf
	endif

	basDK.Close()
	basDP.Close()
	basMG.Close()
	basMZ.Close()
#endif
EndSub

//---------------------------------------------------------------------------
int Sub EksportDokPozFWZdoWNT(long idDK)
//---------------------------------------------------------------------------
#ifdef HMHL
	long err, err1
	BaseAll basDK
	BaseAll basDP
	BaseAll basDK2
	BaseAll basDP2
	BaseAll basZZ

	If basDK.SetBase("DK") then PrintError("Bd otwarcia DK")
	basDK.Open()
	If basDP.SetBase("DP") then PrintError("Bd otwarcia DP")
	basDP.Open()
	If basDK2.SetBase("DK") then PrintError("Bd otwarcia DK")
	basDK2.Open()
	If basDP2.SetBase("DP") then PrintError("Bd otwarcia DP")
	basDP2.Open()
	If basZZ.SetBase("ZZ") then PrintError("Bd otwarcia ZZ")
	basZZ.Open()

	// eksport zwizkw z innymi dokumentami, jeli s ...

	basZZ.SetKey("cross2") : basZZ.SetKeySeg("typi", 151) : basZZ.SetKeySeg("baza2", 34) : basZZ.SetKeySeg("id2", idDK)
	err = basZZ.GetRec(GE)
	
	if !err && basZZ.GetField("typi") == 151 && basZZ.GetField("baza2") == 34 && basZZ.GetField("id2") == idDK then
		err = basDK.GetRecById(basZZ.GetField("id1"))
		If !err Then
			eksport.PoczatekPodsekcji( szSectionOddzDokPowiazany )
				eksport.Pole("typ", ToString(basDK.GetField(funZnaki("typi"))))
				eksport.Pole("kod", basDK.GetField("kod"))

				// aktualizowane pola dokumentu DK
				eksport.Pole("rozlmg", ToString(basDK.GetField(funZnaki("rozlmgi"))))
				eksport.Pole("ok", ToString(basDK.GetField(funZnaki("oki"))))
				eksport.Pole("wartoscSp", (Using "%.12f", basDK.GetField("wartoscSp")))
				eksport.Pole("wplaty", (Using "%.12f", basDK.GetField("wplaty")))
				eksport.Pole("zyskdod", (Using "%.2f", basDK.GetField("zyskdod")))
				
				// Pozycje dokumentu

				// ...
			eksport.KoniecSekcji()
		EndIf
	endif

	basDK.Close()
	basDP.Close()
	basDK2.Close()
	basDP2.Close()
#endif
EndSub

//---------------------------------------------------------------------------
int Sub EksportDokPozWNTdoFWZ(long idDK)
//---------------------------------------------------------------------------
#ifdef HMHL
	long err, err1
	BaseAll basDK
	BaseAll basDP
	BaseAll basDK2
	BaseAll basDP2
	BaseAll basZZ

	If basDK.SetBase("DK") then PrintError("Bd otwarcia DK")
	basDK.Open()
	If basDP.SetBase("DP") then PrintError("Bd otwarcia DP")
	basDP.Open()
	If basDK2.SetBase("DK") then PrintError("Bd otwarcia DK")
	basDK2.Open()
	If basDP2.SetBase("DP") then PrintError("Bd otwarcia DP")
	basDP2.Open()
	If basZZ.SetBase("ZZ") then PrintError("Bd otwarcia ZZ")
	basZZ.Open()

	// eksport zwizkw z innymi dokumentami, jeli s ...

	basZZ.SetKey("cross1") : basZZ.SetKeySeg("typi", 151) : basZZ.SetKeySeg("baza1", 34) : basZZ.SetKeySeg("id1", idDK)
	err = basZZ.GetRec(GE)
	
	if !err && basZZ.GetField("typi") == 151 && basZZ.GetField("baza1") == 34 && basZZ.GetField("id1") == idDK then
		err = basDK.GetRecById(basZZ.GetField("id2"))
		If !err Then
			eksport.PoczatekPodsekcji( szSectionOddzDokPowiazany )
				eksport.Pole("typ", ToString(basDK.GetField(funZnaki("typi"))))
				eksport.Pole("kod", basDK.GetField("kod"))

				// aktualizowane pola dokumentu DK
				eksport.Pole("rozlmg", ToString(basDK.GetField(funZnaki("rozlmgi"))))
				eksport.Pole("ok", ToString(basDK.GetField(funZnaki("oki"))))
				eksport.Pole("wartoscSp", (Using "%.12f", basDK.GetField("wartoscSp")))
				eksport.Pole("wplaty", (Using "%.12f", basDK.GetField("wplaty")))
				eksport.Pole("zyskdod", (Using "%.2f", basDK.GetField("zyskdod")))
				
				// Pozycje dokumentu

				// ...
			eksport.KoniecSekcji()
		EndIf
	endif

	basDK.Close()
	basDP.Close()
	basDK2.Close()
	basDP2.Close()
#endif
EndSub

//---------------------------------------------------------------------------
int Sub EksportDokMM(long id)
//---------------------------------------------------------------------------
#ifdef HM
	long err
	BaseAll basMG

	If basMG.SetBase("MG") then PrintError("Bd otwarcia MG")
	basMG.Open()

	basMG.SetKey("id") : basMG.SetKeySeg("id", -id)
	If !basMG.GetRec(EQ) Then
		eksport.PoczatekPodsekcji( szSectionOddzDokPowiazany )
			eksport.Pole("typ", (using "%d",basMG.GetField("typi")))
			eksport.Pole("kod", basMG.GetField("kod"))
		eksport.KoniecSekcji()
	EndIf

	basMG.Close()
#endif
EndSub

//---------------------------------------------------------------------------
int Sub EksportDokTR(long id)
//---------------------------------------------------------------------------
	long err
	BaseAll basPN

	If basPN.SetBase("PN") then PrintError("Bd otwarcia PN")
	basPN.Open()

	if 0 == basPN.GetRecById(id) Then
		eksport.PoczatekPodsekcji( szSectionOddzDokPowiazany )
			eksport.Pole("rejestr_platnosci", GetRejestrPlatnosciPN(id))
			eksport.Pole("seria", basPN.GetField("seria"))
			eksport.Pole("dzial", (Using "%l", basPN.GetField("dzial")))
			eksport.Pole("okres", (Using "%l", basPN.GetField("okres")))
			eksport.Pole("serianr", (Using "%l", basPN.GetField("serianr")))
		eksport.KoniecSekcji()
	EndIf

	basPN.Close()
EndSub

//---------------------------------------------------------------------------
int Sub EksportDokPozMagazynoweDoHandl(long idDK)
//---------------------------------------------------------------------------
#ifdef HMHL
	long err, err1, idMG
	int iSubtyp
	BaseAll basDK
	BaseAll basDP
	BaseAll basMG
	BaseAll basMZ
	BaseAll basZZ

	If basDK.SetBase("DK") then PrintError("Bd otwarcia DK")
	basDK.Open()
	If basDP.SetBase("DP") then PrintError("Bd otwarcia DP")
	basDP.Open()
	If basMG.SetBase("MG") then PrintError("Bd otwarcia MG")
	basMG.Open()
	If basMZ.SetBase("MZ") then PrintError("Bd otwarcia MZ")
	basMZ.Open()
	If basZZ.SetBase("ZZ") then PrintError("Bd otwarcia ZZ")
	basZZ.Open()

	basDP.SetKey("id")

	basDK.GetRecById(idDK)
	iSubtyp = ToInt(basDK.GetField(funZnaki("subtypi")))
	if ( iSubtyp == FWS ) then
		basZZ.SetKey("cross1") : basZZ.SetKeySeg("typi", 151) : basZZ.SetKeySeg("baza1", 16) : basZZ.SetKeySeg("id1", idDK)
		err = basZZ.GetRec(GE)
		
		if !err && basZZ.GetField("typi") == 151 && basZZ.GetField("baza1") == 16 && basZZ.GetField("id1") == idDK then
			err = basMG.GetRecById(basZZ.GetField("id2"))
			if !err then
				idMG = basMG.GetField("id")
				eksport.PoczatekPodsekcji( szSectionOddzDokPowiazany )
					eksport.Pole("typ", ToString(basMG.GetField(funZnaki("typi"))))
					eksport.Pole("kod", basMG.GetField("kod"))

					// aktualizowane pola dokumentu MG
					eksport.Pole("ok", ToString(basMG.GetField(funZnaki("oki"))))
					
					// Pozycje dokumentu
					basMZ.SetKey("super") : basMZ.SetKeySeg("super", idMG) : basMZ.SetKeySeg("lp", 0)
					err1 = basMZ.GetRec(GE)
					While !err1 && basMZ.GetKeySeg("super") == idMG
						eksport.PoczatekPodsekcji( szSectionPosDok )
							eksport.Pole( "lpMZ", (Using "%l", basMZ.GetField("lp")) )
							basDP.SetKeySeg( "id", basMZ.GetField("idhandl"))
							If !basDP.GetRec(EQ) Then
								eksport.Pole( "lpDP", (Using "%l", basDP.GetField("lp")) )
								eksport.Pole( "kodTW", basDP.GetField("kod") )
							Else
								eksport.Pole("lpDP", "0")
							EndIf
						eksport.KoniecSekcji()
						err1 = basMZ.GetRec(NX)
					Wend
				eksport.KoniecSekcji()

			endif
		endif
	else
		basMG.SetKey("idhandl") : basMG.SetKeySeg("idhandl", idDK)
		err = basMG.GetRec(GE)
		While !err && basMG.GetKeySeg("idhandl") == idDK
			idMG = basMG.GetField("id")
			eksport.PoczatekPodsekcji( szSectionOddzDokPowiazany )
				eksport.Pole("typ", ToString(basMG.GetField(funZnaki("typi"))))
				eksport.Pole("kod", basMG.GetField("kod"))

				// aktualizowane pola dokumentu MG
				eksport.Pole("ok", ToString(basMG.GetField(funZnaki("oki"))))
				
				// Pozycje dokumentu
				basMZ.SetKey("super") : basMZ.SetKeySeg("super", idMG) : basMZ.SetKeySeg("lp", 0)
				err1 = basMZ.GetRec(GE)
				While !err1 && basMZ.GetKeySeg("super") == idMG
					eksport.PoczatekPodsekcji( szSectionPosDok )
						eksport.Pole( "lpMZ", (Using "%l", basMZ.GetField("lp")) )
						basDP.SetKeySeg( "id", basMZ.GetField("idhandl"))
						If !basDP.GetRec(EQ) Then
							eksport.Pole( "lpDP", (Using "%l", basDP.GetField("lp")) )
							eksport.Pole( "kodTW", basDP.GetField("kod") )
						Else
							eksport.Pole("lpDP", "0")
						EndIf
					eksport.KoniecSekcji()
					err1 = basMZ.GetRec(NX)
				Wend
			eksport.KoniecSekcji()
			err = basMG.GetRec(NX)
		Wend
	endif

	basDK.Close()
	basDP.Close()
	basMG.Close()
	basMZ.Close()
	basZZ.Close()
#endif
EndSub

//---------------------------------------------------------------------------
long Sub EksportKodTypDokumentu(long id, string baza) //DK, MG
//---------------------------------------------------------------------------
	BaseAll bas
	If bas.SetBase(baza) then PrintError("Bd otwarcia bazy " & baza)
	bas.Open()
	If !bas.GetRecById(id) Then
		EksportKodTypDokumentu = bas.GetField("id")
		eksport.PoczatekPodsekcji( szSectionOddzDokPowiazany )
			eksport.Pole("typ", ToString(bas.GetField(funZnaki("typi"))))
			eksport.Pole("kod", bas.GetField("kod"))
		eksport.KoniecSekcji()
	EndIf
	bas.Close()
EndSub

//---------------------------------------------------------------------------
int Sub EksportKorekt(long id, string baza)	//DK, MG
//---------------------------------------------------------------------------
	long iddokkoryg, idkorekt,err

	BaseAll bas
	If bas.SetBase(baza) then PrintError("Bd otwarcia bazy " & baza)
	bas.Open()

	bas.SetKey("id") : bas.SetKeySeg("id", id)
	bas.GetRec(EQ)

	If bas.GetField("iddokkoryg") == 0 Then
		// jeli dokument
		idkorekt = bas.GetField("idkorekt")

		If bas.GetField("idkorekt") != 0 Then
			bas.SetKeySeg( "id", bas.GetField("idkorekt") )
			While !bas.GetRec(EQ)
				eksport.PoczatekPodsekcji( szSectionOddzIdKorekty )
					eksport.Pole("typ", ToString(bas.GetField(funZnaki("typi"))))
					eksport.Pole("kod", bas.GetField("kod"))
				eksport.KoniecSekcji()
				bas.SetKeySeg("id", bas.GetField("idkorekt"))
			Wend
		EndIf

		bas.SetKey("id") : bas.SetKeySeg("id", idkorekt)
		If !bas.GetRec(EQ) Then
			eksport.PoczatekPodsekcji( szSectionOddzIdDokPodrz )
				eksport.Pole("typ", ToString(bas.GetField(funZnaki("typi"))))
				eksport.Pole("kod", bas.GetField("kod"))
			eksport.KoniecSekcji()
		EndIf
	Else
		//jeli korekta
		iddokkoryg = bas.GetField("iddokkoryg")
		idkorekt = bas.GetField("idkorekt")

		bas.SetKey("id") : bas.SetKeySeg("id", iddokkoryg)
		If !bas.GetRec(EQ) Then
			eksport.PoczatekPodsekcji( szSectionOddzIdDokKoryg )
				eksport.Pole("typ", ToString(bas.GetField(funZnaki("typi"))))
				eksport.Pole("kod", bas.GetField("kod"))
			eksport.KoniecSekcji()

			Do
				If (bas.GetField("idkorekt") == id) && (bas.GetField("idkorekt") != 0) Then
					eksport.PoczatekPodsekcji( szSectionOddzIdDokNadrz )
						eksport.Pole("typ", ToString(bas.GetField(funZnaki("typi"))))
						eksport.Pole("kod", bas.GetField("kod"))
					eksport.KoniecSekcji()
				EndIf
				bas.SetKeySeg("id", bas.GetField("idkorekt"))
			Loop While !bas.GetRec(EQ)
		EndIf

		bas.SetKey("id") : bas.SetKeySeg("id", idkorekt)
		If !bas.GetRec(EQ) Then
			eksport.PoczatekPodsekcji( szSectionOddzIdDokPodrz )
				eksport.Pole("typ", ToString(bas.GetField(funZnaki("typi"))))
				eksport.Pole("kod", bas.GetField("kod"))
			eksport.KoniecSekcji()
		EndIf

		// jeli jest to korekta magazynowa zrobiona z poziomu dokumentu
		If baza == "MG" && iddokkoryg < 0 Then
			bas.SetKey("idhandl") : bas.SetKeySeg("idhandl", -iddokkoryg)
			err = bas.GetRec(GE)
			While !err && bas.GetKeySeg("idhandl") == (-iddokkoryg)
				eksport.PoczatekPodsekcji( szSectionOddzIdDokNadrz )
					eksport.Pole("typ", ToString(bas.GetField(funZnaki("typi"))))
					eksport.Pole("kod", bas.GetField("kod"))
				eksport.KoniecSekcji()
				err = bas.GetRec(NX)
			Wend
		EndIf

	EndIf
	bas.Close()
EndSub


//---------------------------------------------------------------------------
int Sub EksportKodTowaru(long idTW)
//---------------------------------------------------------------------------
	BaseAll bas
	If bas.SetBase("TW") then PrintError("Bd otwarcia TW")
	bas.Open()
	If !bas.GetRecById(idTW) Then eksport.Pole("kodTW", bas.GetField("kod"))
	bas.Close()
EndSub


//---------------------------------------------------------------------------
int Sub EksportKodKontrahenta(long idKH, string tekst)
//---------------------------------------------------------------------------
	BaseAll bas
	If bas.SetBase("KH") then PrintError("Bd otwarcia KH")
	bas.Open()
	If !bas.GetRecById(idKH) Then eksport.Pole(tekst, bas.GetField("kod"))
	bas.Close()
EndSub


//---------------------------------------------------------------------------
int	Sub EksportKodMagazynu(long idMAG, string pole)
//---------------------------------------------------------------------------
	BaseAll bas
	If bas.SetBase("XT") then PrintError("Bd otwarcia XT")
	bas.Open()
	If pole == "" Then pole = "kodMag"
	If !bas.GetRecById(idMAG) Then eksport.Pole(pole, bas.GetField("kod"))
	bas.Close()
EndSub


//---------------------------------------------------------------------------
String	Sub GetRejestrPlatnosciPN(long idPN)
//---------------------------------------------------------------------------
	BaseAll basPN
	If basPN.SetBase("PN") then PrintError("Bd otwarcia bazy " & "PN")
	basPN.Open()
	If !basPN.GetRecById(idPN) Then
		If ( !basXT.GetRecById(basPN.GetField("rejestr"))) && (0 == basPN.GetField("dkid")) Then
			GetRejestrPlatnosciPN =	basXT.GetField("kod")
		endif
	endif
	basPN.Close()
EndSub


//---------------------------------------------------------------------------
long	Sub EksportMagazynDKzPN(long idPN, string pole)
//---------------------------------------------------------------------------
	BaseAll basPN
	If basPN.SetBase("PN") then PrintError("Bd otwarcia bazy " & "PN")
	basPN.Open()
	BaseAll basDK
	If basDK.SetBase("DK") then PrintError("Bd otwarcia bazy " & "DK")
	basDK.Open()
	If !basPN.GetRecById(idPN) Then
		EksportMagazynDKzPN = basPN.GetField("dkid")
		If 0 != EksportMagazynDKzPN Then
			If !basDK.GetRecById( EksportMagazynDKzPN ) Then
				EksportKodMagazynu(basDK.GetField("magazyn"), pole)
			EndIf
		EndIf
	EndIf
	basDK.Close()
	basPN.Close()
EndSub


//---------------------------------------------------------------------------
int	Sub EksportRozliczeniaDK(long idDK)
//---------------------------------------------------------------------------
	BaseAll basPN
	If basPN.SetBase("PN") then PrintError("Bd otwarcia PN")
	basPN.Open()
	BaseAll basPN3
	If basPN3.SetBase("PN") then PrintError("Bd otwarcia PN")
	basPN3.Open()
	BaseAll basRL
	If basRL.SetBase("RL") then PrintError("Bd otwarcia RL")
	basRL.Open()

	long err
	string c1, r
	basPN.SetKey("dkid") : basPN.SetKeySeg("dkid", idDK)
	If !basPN.GetRec(EQ) Then
		If ToInt(basPN.GetField(funZnaki("wyplatai"))) == 1 Then c1 = "1" : r = "2"		// wpata
		If ToInt(basPN.GetField(funZnaki("wyplatai"))) == 0 Then c1 = "2"	:	r = "1"		// wypata

		basRL.SetKey("cross"+c1)
		basRL.SetKeySeg("id"+c1, basPN.GetField("id")) : basRL.SetKeySeg("id"+r, 0)
		err = basRL.GetRec(GE)
		While !err && basRL.GetField("id"+c1) == basPN.GetField("id")
			eksport.PoczatekPodsekcji( szSectionOddzRozliczenie )

				// pola do aktualizacji dokumentw PN
				If !basPN3.GetRecById( basRL.GetField("id"+r) ) Then
					eksport.Pole( "pn_kwota" + r, (Using "%.12f", basPN3.GetField("kwota")) )
					eksport.Pole( "pn_kwotarozl", (Using "%.12f", basPN3.GetField("kwotarozl")) )
					eksport.Pole( "pn_typ", ToString(basPN3.GetField(funZnaki("typi"))))
					eksport.Pole( "data_pn", basPN3.GetField("data") )
					eksport.Pole( "wyplata", ToString(basPN3.GetField(funZnaki("wyplatai"))))
				EndIf

				eksport.Pole("typPN", ToString(basPN.GetField(funZnaki("typi"))))
				eksport.Pole("rejestr_platnosci1", GetRejestrPlatnosciPN(basRL.GetField("id1")))
				eksport.Pole("rejestr_platnosci2", GetRejestrPlatnosciPN(basRL.GetField("id2")))

				EksportMagazynDKzPN(basRL.GetField("id1"), "kodMag1")
				EksportMagazynDKzPN(basRL.GetField("id2"), "kodMag2")
				EksportRekord("RL", basRL.GetField("id") )
			eksport.KoniecSekcji()
			err = basRL.GetRec(NX)
		Wend
	EndIf

	basPN3.Close()
	basPN.Close()
	basRL.Close()
EndSub

#include "Auto eksport 2"

//---------------------------------------------------------------------------
//	str.wydruk(0 ,-1 , -1)
//	WczytajOpis("DK")
//	int i
//	For i=1 to i > size (rFields)
//		print i,,rFields(i).FieldName,, rFields(i).Type; LF
//	Next i

//---------------------------------------------------------------------------
// Wyrzucanie do pliku pl tabeli
//---------------------------------------------------------------------------
/*
	int fl = open "v:/MZ.TXT" for Output
	str.wydruk(0 ,-1 , -1)
	WczytajOpis("MZ")
	int i
	For i=1 to i > size (rFields)
		print #fl; ,, "$"; rFields(i).FieldName, " = "; "["; rFields(i).FieldName; "]"; LF
		print i,,rFields(i).FieldName,, rFields(i).Type; LF
	Next i
*/
