//"diag_dw.sc","51dw : diagnostyka dostaw towarw",12004,0,1.0.6,SYSTEM
//"Diagnostyka",12001,14,16
////////////////////////////
// 51dw : diagnostyka dostaw towarw
// diag_dw.sc
////////////////////////////
// napisa: Sebastian Nowak
// data:    99.01.19

string NAZWA_PLIKU = "DIAG_DW.TXT"

string sRaportDescription,sPom


#include "Diagnostyka - funkcje"
UsunRekord_0("DW")

sDialogTitle += "dostaw DW"

StageAddDesc("Raport sprawdza obecno rekordw dostaw dla pozycji dokumentw")
StageAddDesc("magazynowych oraz rekordw rezerwacji ilociowych.")
StageAddStage("Sprawdzenie dostaw")
StageAddStage("Sprawdzenie rezerwacji ilociowych")
StageAddStage("Sprawdzenie wartoci w dostawach")
ChooseStages(400)


float dwIlosc,dwIloscdosp,dwWartoscDosp,dwIloscPz,dwStan,dwWartoscSt,dwCena
float fCenaIlosc,fCenaWartosc,fPrzecena,fWartAkt,fIloscAkt,fCenaAkt
int mz,pw,pw2,pw3,dw,dw2,dw3,dw4,mg,pw4,xt
int dokMgNotPresent
long id_mmminus,iddw,lIdMZTworz,lIdPWTworz
BaseTW tw
BaseZZ zz
BaseMZ mz2
BaseBZ bz

//********************

long sub GetNumber()
	GetNumber = 0x1000000
	Clear(dw2)
	SetKeySeg(dw2,"idtw",GetField(pw,"idtw")+1)
	SetKeySeg(dw2,"numer",-0x1000000)
	if !GetKey(dw2,LT) then GetNumber = GetKeySeg(dw2,"numer")+1
endsub

int sub ZliczPWKorekty( long id )
	long idy(1)
	int ccnt
	SetKeySeg(pw4,"idkoryg",id)
	err=GetRec(pw4,GE)
	while !err && GetKeySeg(pw4,"idkoryg")==id
		fCenaIlosc += GetField(pw4,"ilosc")
		fCenaWartosc += GetField(pw4,"wartosc")
		fIloscAkt+=GetFIeld(pw4,"ilosc")
		fWartAkt+=GetField(pw4,"wartosc")
		if idy(size(idy)) then grow idy,1
		idy(size(idy))=GetField(pw4,"id")
		err=GetRec(pw4,NX)
	wend
	for ccnt=1 to !idy(1) || ccnt>size(idy)
		ZliczPWKorekty( idy(ccnt) )
	next ccnt
endsub

int sub ZliczPW(string typ, long id)
	SetKeySeg(pw2,"typi",val(typ))
	SetKeySeg(pw2,"iddw",id)
	SetKeySeg(pw2,"idmg",0)
	err=GetRec(pw2,GE)
	while !err && GetField(pw2,"iddw")==id && GetField(pw2,"typi")==val(typ)
		if GetField(pw2,"flag")&8 then // dostawa tworzca
			lIdMZTworz=GetField(pw2,"idmg")
			lIdPWTworz=GetField(pw2,"id")
			dwIlosc -= GetField(pw2,"ilosc")
			// obliczanie ceny
			fCenaIlosc += GetField(pw2,"ilosc")
			fCenaWartosc += GetField(pw2,"wartosc")
			ZliczPWKorekty( GetField(pw2,"id") )
		endif
		fIloscAkt+=GetFIeld(pw2,"ilosc")
		fWartAkt+=GetField(pw2,"wartosc")
		if GetField(pw2,"subtypi")==91 then
			//if Sign(GetField(pw2,"ilosc"), 4)>0 then fPrzecena -= GetField(pw2,"wartosc")/GetField(pw2,"ilosc")
		//	if Sign(GetField(pw2,"ilosc"), 4)<0 then fPrzecena += GetField(pw2,"wartosc")/GetField(pw2,"ilosc")
			if sign(fIloscAkt,4) then
				fCenaAkt=fWartAkt/fIloscAkt
			endif
		endif
		if GetField(pw2,"flag")&16 then dwIloscPz-=GetFIeld(pw2,"ilosc") // przychd do magazynu
		dwIloscDosp-=GetFIeld(pw2,"ilosc")
		if typ!="26" then	dwStan-=GetFIeld(pw2,"ilosc") // nie rezerwacja
		dwWartoscDosp-=GetFIeld(pw2,"wartosc")
		if typ!="26" then	dwWartoscSt -= GetField(pw2,"wartosc") // nie rezerwacja
		err=GetRec(pw2,NX)
	wend
endsub


int sub ZliczWartosci(long id, long idtw)
	dwCena = dwIlosc = dwIloscdosp = dwWartoscDosp = dwIloscPz = dwStan = dwWartoscSt =0
	fCenaIlosc = fCenaWartosc = fIloscAkt = fWartAkt = 0
	fPrzecena=fCenaAkt=0
	lIdMZTworz=lIdPWTworz = 0
	if idtw<0 then ZliczPW("39",id)		// dostawy z utworzone dok w buforze maj -idtw
	if idtw>=0 then
		ZliczPW("37",id)
		ZliczPW("26",id)
	endif
	if Sign(fCenaIlosc) then dwCena = fCenaWartosc/fCenaIlosc 
	if SIgn(fCenaAkt) then dwCena=fCenaAkt
endsub

int sub NormalizeTyp( int b, int czy_pyt)
	int w_ok
	w_ok=0
	if GetField(b,"numer")>0 && Sign(GetField(b,"stan"),4) then w_ok=1
	if GetField(b,"numer")<0 && Sign(GetField(b,"iloscdosp"),4) then w_ok=1
	if (w_ok && GetField(b,"typi")==0 && GetField(b,"stan") > 0) || (!w_ok && GetField(b,"typi")!=0) then
		SetField(b,"typi",w_ok)
		if czy_pyt then
			if TextOutAndAsk3(12,using "Dostawa '%s' jest niepoprawnie zaznaczona jako %s",GetField(b,"kod"),iif(w_ok,"rozliczona","nie rozliczona") ) then
				UpdateRec(b,"DW")
			else
				TextOut(sNoRepair)
			endif
		endif
	endif
endsub

int sub DiagWart(string pole, int prec)
float wart
float id

	wart = GetField(dw,pole)
	id = GetField(dw,"id")
	if sign(wart-round(wart,prec),6) then
		if TextOutAndAsk(2,(using "Warto pola '%s' posiada cyfry poza wymagan pozycj dokadnoci. Rekord id=%d",pole,id),(". Czy zaokrgli?")) then
			SetField(dw,pole,round(wart,prec))
			UpdateRec(dw,"DW")
		else
			TextOut(sNoRepair)
		endif
	endif
endsub
//********************

int sm=OpenBase("sm")

int sub PrzeliczDw(int dw)
	PrzeliczDw = PrzeliczDostawe(GetField(dw,"id"), "")

	float dWart, dStan, dStanMg

	if PrzeliczDw == -4702 then 

		//szacujemy warto do jakiej naleaoby zwikszy warto stanu
		dWart = GetField(dw, "cena") * GetField(dw, "ilosc")
		if !sign(dWart - 0) then dWart = 1000000
	
		//sztuczne zwikszenie wartoci stanw pomaga to obej ograniczenie f. PrzeliczDostawe
		SetKey(sm, "towar")
		SetKeySeg(sm, "idtw", GetField(dw, "idtw"))
		SetKeySeg(sm, "magazyn", GetField(dw, "magazyn"))

		if !GetRec(sm, EQ) then
			dStanMg = GetField(sm, "wartosc")
			SetField(sm, "wartosc", dWart)
			PutRec(sm)
		endif

		SetKey(sm, "towar")
		SetKeySeg(sm, "idtw", GetField(dw, "idtw"))
		SetKeySeg(sm, "magazyn", 0)

		if !GetRec(sm, EQ) then
			dStan = GetField(sm, "wartosc")
			SetField(sm, "wartosc", dWart)
			PutRec(sm)
		endif
		
		PrzeliczDw = PrzeliczDostawe(GetField(dw,"id"), "")	


		//przywrcenie pocztkowej wartoci stanw
		SetKey(sm, "towar")
		SetKeySeg(sm, "idtw", GetField(dw, "idtw"))
		SetKeySeg(sm, "magazyn", GetField(dw, "magazyn"))

		if !GetRec(sm, EQ) then
			SetField(sm, "wartosc", dStanMg)
			PutRec(sm)
		endif

		SetKey(sm, "towar")
		SetKeySeg(sm, "idtw", GetField(dw, "idtw"))
		SetKeySeg(sm, "magazyn", 0)

		if !GetRec(sm, EQ) then
			SetField(sm, "wartosc", dStanMg)
			PutRec(sm)
		endif

	endif
endsub


TextOut("Podsumowanie sprawdzania poprawnoci bazy dostaw\n\n")


// spradzanie przyj od strony bazy MZ

mz=OpenBase("mz")
pw=OpenBase("pw")
pw2=OpenBase("pw")
pw3=OpenBase("pw")
pw4=OpenBase("pw")
dw=OpenBase("dw")
dw2=OpenBase("dw")
dw3=OpenBase("dw")
dw4=OpenBase("dw")
mg=OpenBase("mg")
xt=OpenBase("xt")

SetKey(mz,"super")
SetKey(pw,"dostawy")
SetKey(pw2,"pozycje")
SetKey(pw3,"dostawy")
SetKey(pw4,"idkoryg")
SetKey(dw,"id")
SetKey(dw2,"towar")
SetKey(dw3,"id")
SetKey(mg,"id")
SetKey(xt,"id")

PopUp(1,"Sprawdzanie przyj")
err = GetRec(mz,GE)

if !StageT(1) then err=1

while !err
	SetKeySeg(xt,"id",GetField(mz,"magazyn"))
	if GetField(mz,"flag") & 0x100  && !(GetField(mz,"typi")&0x01) && (!GetRec(xt,EQ) && !(GetField(xt,"flag")&0x10)) then
		// przyjcie do magazynu
		PopUp(2,GetField(mz,"kod"))
		SetKeySeg(pw,"typi",37)
		SetKeySeg(pw,"idmg",GetField(mz,"id"))
		SetKeySeg(pw,"iddw",0)
		err=GetRec(pw,GE)

		if err || GetField(pw,"typi")!=37 || GetField(pw,"idmg")!=GetField(mz,"id") then
			// nie ma rekordu PW
			if Sign(GetField(mz,"ilosc"),4) || Sign(GetField(mz,"wartNetto")) then
				AskOkEnd(10,using "Brak rekordu w bazie PW dla pozycji przyjcia do magazynu id=%l. Uruchom raport diagnostyczny dla bazy PW",GetField(mz,"id"))
			endif
			err=1
		endif

		while !err && GetField(pw,"typi")==37 && GetField(pw,"idmg")==GetField(mz,"id")
			SetKeySeg(dw,"id",GetField(pw,"iddw"))
			if GetKey(dw,EQ) then
				// brak rekordu w bazie DW

				SetKeySeg(mg,"id",GetField(mz,"super"))
				dokMgNotPresent = GetRec(mg,EQ)
				if dokMgNotPresent then TextOutAskOkEnd(2,using "Brak dokumentu dla pozycji magazynowej '%s'. Uruchom raport diagnostyczny dla bazy MG.\n",GetField(mz,"kod")) 
				buf = iif(dokMgNotPresent==0, GetField(mg,"kod"),"")
			
				if TextOutAndAsk( 1, (using "Brak rekordu dostawy w bazie DW dla pozycji '%s' dokumentu przychodowego '%s'",GetField(mz,"kod"),buf),". Czy naprawi?") then

					// zliczenie wydan z tej dostawy
					ZliczWartosci(GetField(pw,"iddw"),0)

					Clear(dw)
					SetField(dw,"ilosc",dwIlosc)
					SetField(dw,"iloscdosp",dwIloscDosp)
					SetField(dw,"cena",dwCena)
					SetField(dw,"wartoscdosp",dwWartoscDosp)
					SetField(dw,"iloscPz",dwIloscPz)
					SetField(dw,"stan",dwStan)
					SetField(dw,"wartoscSt",dwWartoscSt)

					SetField(dw,"id",GetField(pw,"iddw"))
					buf = "0"
					if Sign(dwStan,4) then buf = "1"
					SetField(dw,"typi",val(buf))

					if !dokMgNotPresent then
						SetField(dw,"kod",GetField(mg,"kod"))
						SetField(dw,"flag", GetField(mg,"oki"))
						if GetField(mg,"idhandl")>0 then SetField(dw,"iddkzk",GetField(mg,"idhandl"))
					endif
					SetField(dw,"iddkpz",GetField(pw,"iddkmg"))
					SetField(dw,"idkh",GetField(mz,"idkh"))
					SetField(dw,"idtw",GetField(pw,"idtw"))
					SetField(dw,"data",GetField(mz,"data"))
					if lIdMZTworz && !mz2.GetRecById(lIdMZTworz) then SetField(dw,"data",mz2.GetField("data"))
					SetField(dw,"magazyn",GetField(mz,"magazyn"))
					SetField(dw,"numer",GetNumber())
					if GetField(mz,"flag") & 0xC00 then
						// odzyskiwany rekord jest dostawa dowiazana do innej
						id_mmminus = - GetField(mz,"idhandl")
						// dla pozycji mm- znajdujemy wydanie na identyczna ilosc oraz wartosc
						iddw = 0
						SetKeySeg(pw3,"typi",37)
						SetKeySeg(pw3,"idmg",id_mmminus)
						SetKeySeg(pw3,"iddw",0)
						err = GetRec(pw3,GE)
						while !err && !iddw && GetKeySeg(pw3,"typi")==37 && GetKeySeg(pw3,"idmg")==id_mmminus
							if !Sign(GetField(pw3,"ilosc")+GetField(pw,"ilosc"),4) && !Sign(GetField(pw3,"wartosc")+GetField(pw,"wartosc")) then
								// jest wydanie na taka sama ilosc
								// dowiazuje do tego wydania, chociaz to moze byc nie prawda
								iddw = GetField(pw3,"iddw")

								// sprawdzenie czy taka dostawa juz nie isntnieje, jesli tak to szukamy dalej
								SetKey(dw4, "iddw")
								SetKeySeg(dw4, "iddw", iddw)
								SetKeySeg(dw4, "magazyn", GetField(mz,"magazyn"))

								if !GetRec(dw4, EQ) then
									iddw = 0
								endif
							endif
							err = GetRec(pw3,NX)
						wend
						SetField(dw,"iddw",iddw)
						if iddw then
							SetKeySeg(dw3,"id",iddw)
							if !GetRec(dw3,EQ) then SetField(dw,"kod",GetField(dw3,"kod"))
						endif
					endif
					InsertRec(dw,"dw")
				else
					TextOut( sNoRepair )
				endif
			endif

			err=GetRec(pw,NX)
		wend

	endif

	err = GetRec(mz,NX)
wend

StageSummary(1)

// sprawdzanie rezezwacji ilociowych

PopUp(1,"Sprawdzanie rezerwacji ilociowych")
SetKey(pw3,"pozycje")
SetKey(dw,"id")
SetKeySeg(pw3,"typi",26)
SetKeySeg(pw3,"iddw",0)
SetKeySeg(pw3,"idmg",0)
err=GetKey(pw3,GE)

if !StageT(2) then err=1

while !err && GetKeySeg(pw3,"typi")==26
	PopUp(2,using "%l",GetKeySeg(pw3,"iddw"))
	SetKeySeg(dw,"id",GetKeySeg(pw3,"iddw"))
	if GetKey(dw,EQ) then
		if GetRec(pw3,EQ) then Message using "Bd wewntrzny czytania rekordu PW"
		buf = "<BRAK REKORDU>"
		if tw.GetRecById(GetField(pw3,"idtw")) then
			TextOutAskOkEnd(3,using "Brak towaru dla rekordu PW id=%l. Uruchom raport diagnostyczny dla bazy PW\n",GetField(pw3,"idtw"))
		else
			buf = tw.GetFIeld("kod")
		endif
		if zz.GetRecById(GetField(pw3,"idmg")) then
			TextOutAskOkEnd(4,using "Brak rekordu rezerwacji ZZ oraz rekordu rezerwacji ilociowej dla rekordu PW id=%l. Uruchom raport diagnostyczny dla bazy PW\n",GetField(pw3,"idmg"))
		else
			firma.Magazyn(zz.GetField("magazyn"))
			if TextOutAndAsk3(5,(using "Brak rekordu rezerwacji ilociowej dla towaru '%s' w magazynie '%s' rekord PW id=%l",buf,firma.kodmagazynu,GetField(pw3,"id"))) then

				ZliczWartosci(GetField(pw3,"iddw"),GetField(dw,"idtw"))

				Clear(dw)
				SetField(dw,"id",GetField(pw3,"iddw"))
				SetField(dw,"ilosc",dwIlosc)
				SetField(dw,"iloscdosp",dwIloscDosp)
				SetField(dw,"cena",dwCena)
				SetField(dw,"wartoscdosp",dwWartoscDosp)
				SetField(dw,"iloscPz",dwIloscPz)
				SetField(dw,"stan",dwStan)
				SetField(dw,"wartoscSt",dwWartoscSt)
				SetField(dw,"numer",-zz.GetField("magazyn"))
				SetField(dw,"kod","Rezerwacja ilociowa")
				buf = "0"
				if Sign(dwIloscDosp,4) then buf="1"
				SetField(dw,"typi",val(buf))
				SetField(dw,"idtw",GetField(pw3,"idtw"))
				SetField(dw,"magazyn",zz.GetField("magazyn"))
				SetField(dw,"data","9998-12-31")
				InsertRec(dw,"DW")
			else
				TextOut(sNoRepair)
			endif
		endif
	endif
	SetKeySeg(pw3,"iddw",GetKeySeg(pw3,"iddw")+1)
	SetKeySeg(pw3,"idmg",0)
	err=GetKey(pw3,GE)
wend

StageSummary(2)


// dla wszystkich dostaw sprawdzenie ich wartoci
PopUp(1,"Sprawdzanie wartoci dostaw")
PopUp(2,"")

int dk = OpenBase("dk")
string strSeria = "id"

SetKey(dk, "seria")
SetKeySeg(dk, "seria", strSeria)
SetKeySeg(dk, "serianr", 99999)

string dataP = ""
if !GetRec(dk, LT) && GetField(dk, "seria") == strSeria then
	dataP = GetField(dk, "datasp")	//data przecicia jeli bya przeprowadzana archiwizacja
endif

close dk

SetKey(pw3,"id")
SetKey(dw,"id")
Progress.Reset(GetRecordCount(dw))
err=GetRec(dw,FS)
int iErr = 0

if !StageT(3) then err=1
while !err
// sprawdzanie dokladnosci wartosci
	DiagWart("ilosc",4)
	DiagWart("iloscdosp",4)
	DiagWart("wartoscdosp",2)
	DiagWart("iloscPz",4)
	DiagWart("stan",4)
	DiagWart("wartoscst",2)

	progress.NextOne()

	if GetField(dw, "subtypi") != 2 then 
		NormalizeTyp(dw,1)
		if tw.GetRecById(GetField(dw,"idtw")) then TextOutAskOKEnd(6,using"Dostawa '%s' id=%l skojarzona jest z nieistniejcym towarem\n",GetField(dw,"kod"),GetField(dw,"id"))
		ZliczWartosci(GetField(dw,"id"),GetField(dw,"idtw"))
		if lIdMZTworz then
			if GetField(dw,"idtw")>0 then
				err=mz2.GetRecById(lIdMZTworz)
				sPom = mz2.GetField("data")
			else
				err=bz.GetRecById(lIdMZTworz)
				sPom = bz.GetField("data")
			endif
		endif
		if lIdMZTworz && !err then
			if sPom!=GetField(dw,"data") then
				if TextOutAndAsk(11,(using "Nie zgadza si data utworzenia dostawy '%s' id=%l z dat pozycji tworzcej t dostaw",GetField(dw,"kod"),GetField(dw,"id")),"\nCzy zapisa dat z pozycji dokumentu tworzcego jako dat utworzenia dostawy?" ) then
					SetField(dw,"data",sPom)
					UpdateRec(dw,"DW")
					SetKeySeg(pw3,"id",lIdPWTworz)
					if lIdPWTworz && !GetRec(pw3,EQ) then SetField(pw3,"data",sPom) : PutRec(pw3)
				else
					TextOut(sNoRepair)
				endif
			endif
		endif
		if (Sign(GetField(dw,"ilosc") - dwIlosc,4) || Sign(GetField(dw,"iloscDosp") - dwIloscDosp,4) || Sign(GetField(dw,"iloscPz") - dwIloscPz,4) || Sign(GetField(dw,"stan") - dwStan,4))	|| (Sign(GetField(dw,"numer")) >= 0 && Sign(GetField(dw,"iloscDosp"),4) < 0) || Sign(GetField(dw,"ilosc"),4) < 0 || Sign(GetField(dw,"iloscPz"),4) < 0 || Sign(GetField(dw,"stan"),4) < 0	|| (Sign(GetField(dw,"numer")) < 0 && Sign(GetField(dw,"iloscDosp"),4) > 0) then
			firma.magazyn(GetFIeld(dw,"magazyn"))
			if (Sign(GetField(dw,"numer")) >= 0 &&  Sign(dwIloscDosp,4) < 0 ) || Sign(dwIlosc,4) < 0 || Sign(dwIloscPz,4) < 0 || Sign(dwStan,4) < 0	|| (Sign(GetField(dw,"numer")) < 0 && Sign(dwIloscDosp,4) > 0) then
				if Sign(GetField(dw,"numer")) >= 0 then
					TextOut(using "Ujemna suma ilosci w rozliczeniach magazynowych dostawy '%s' towaru '%s' rekordu DW id=%l\n",GetField(dw,"kod"),tw.GetField("kod"),GetField(dw,"id"))
				else
					TextOut(using "Dodatnia suma ilosci w rozliczeniach magazynowych rezerwacji '%s' towaru '%s' rekordu DW id=%l\n",GetField(dw,"kod"),tw.GetField("kod"),GetField(dw,"id"))
				endif
			else
				if TextOutAndAsk(7,(using "Nie zgadzaj si ilosci w dostawie '%s' towaru '%s' rekordu DW id=%l",GetField(dw,"kod"),tw.GetField("kod"),GetField(dw,"id")),(using "\nIlosc: jest %.2f  powinno by %.2f\nIloscDosp: jest %.2f  powinno by %.2f\nIloscPz: jest %.2f  powinno by %.2f\nStan: jest %.2f  powinno by %.2f\nCzy zapisa nowe wartoci?",GetField(dw,"ilosc"),dwIlosc,GetField(dw,"iloscDosp"),dwIloscDosp,GetField(dw,"iloscPz"),dwIloscPz, GetField(dw,"stan"),dwStan)) then
					SetField(dw,"ilosc",dwIlosc)
					SetField(dw,"iloscDosp",dwIloscDosp)
					SetField(dw,"iloscPz",dwIloscPz)
					SetField(dw,"Stan",dwStan)
					NormalizeTyp(dw,0)
					UpdateRec(dw,"DW")
				else
					TextOut(sNoRepair)
				endif
			endif
		endif
		if Sign(GetFIeld(dw,"wartoscDosp")-dwWartoscDosp,2) || Sign(GetField(dw,"wartoscSt")-dwWartoscSt,2) || Sign(GetFIeld(dw,"wartoscDosp"),2) < 0 || Sign(GetField(dw,"wartoscSt"),2) < 0 then
			if Sign(dwWartoscDosp,2) < 0 || Sign(dwWartoscSt,2) < 0 then
				TextOut(using "Ujemna suma wartosci w rozliczeniach magazynowych dostawy '%s' towaru '%s' rekordu DW id=%l\n",GetField(dw,"kod"),tw.GetField("kod"),GetField(dw,"id"))
			else
				if TextOutAndAsk(8,(using "Nie zgadzaj si wartoci w dostawie '%s' towaru '%s' rekordu DW id=%l",GetField(dw,"kod"),tw.GetField("kod"),GetField(dw,"id")),(using "\nWartoscDosp: jest %.2f  powinno by %.2f\nWartoscSt: jest %.2f  powinno by %.2f\nCzy zapisa nowe wartoci?",Round(GetField(dw,"wartoscDosp"),2),Round(dwWartoscDosp,2),Round(GetField(dw,"wartoscSt"),2),Round(dwWartoscSt,2))) then
					SetField(dw,"wartoscDosp",Round(dwWartoscDosp,2))
					SetField(dw,"WartoscSt",Round(dwWartoscSt,2))
					UpdateRec(dw,"DW")
				else
					TextOut(sNoRepair)
				endif
			endif
		endif
		if dataP < GetField(dw, "data") && ((Sign(dwcena,2) && Sign(GetFIeld(dw,"cena")-dwcena,2)) || Sign(GetFIeld(dw,"cena"),2) < 0) then
			if Sign(dwcena,2) == -1 then
				TextOut(using "Nie zgadza si cena w rozliczeniach magazynowych dostawy '%s' towaru '%s' rekordu DW id=%l\n",GetField(dw,"kod"),tw.GetField("kod"),GetField(dw,"id"))
			else
				if TextOutAndAsk(9,(using "Nie zgadza si cena w dostawie '%s' towaru '%s' rekordu DW id=%l",GetField(dw,"kod"),tw.GetField("kod"),GetField(dw,"id")),(using "\nCena: jest %f  powinno by %f\nCzy zapisa now warto?",Round(GetField(dw,"cena"),2),Round(dwCena,2))) then
					SetField(dw,"cena",Round(dwCena,2))
					UpdateRec(dw,"DW")
				else
					TextOut(sNoRepair)
				endif
			endif
		endif

		if Sign(GetField(dw,"numer"))>=0 then
			if Sign(GetField(dw,"stan"),4)<0 || Sign(GetField(dw,"iloscdosp"),4)<0 then
				TextOut(using "Stan"+iif(Sign(GetField(dw,"stan"),4)<0,""," handlowy")+" towaru '%s' w dostawie '%s' rekordu DW id=%l jest ujemny.\n",tw.GetField("kod"),GetField(dw,"kod"),GetField(dw,"id"))		
			else
				if Sign(GetField(dw,"wartoscSt"),4)<0 || Sign(GetField(dw,"wartoscdosp"),4)<0 then
					if TextOutAndAsk(13, (using "Warto stanu"+iif(Sign(GetField(dw,"wartoscSt"),4)<0,""," handlowego")+" towaru '%s' w dostawie '%s' rekordu DW id=%l jest ujemna.\n",tw.GetField("kod"),GetField(dw,"kod"),GetField(dw,"id")), ("Czy przeliczy dostaw ?")) then
						iErr = PrzeliczDw(dw)
						if iErr != 0 then
							TextOut(using "Nie naprawiono, wystpi bd nr %d\n", iErr)
						else
							TextOut(sRepaired)
						endif
					else
						TextOut(sNoRepair)
					endif
				else
					if (Sign(GetField(dw,"stan"),4)==0 && Sign(GetField(dw,"wartoscSt"),4)>0) || (Sign(GetField(dw,"iloscdosp"),4)==0 && Sign(GetField(dw,"wartoscdosp"),4)>0) then
						if TextOutAndAsk(12, (using "Warto stanu"+iif((Sign(GetField(dw,"stan"),4)==0 && Sign(GetField(dw,"wartoscSt"),4)>0),""," handlowego")+" towaru '%s' w dostawie '%s' rekordu DW id=%l jest dodatnia a stan jest zerowy.\n",tw.GetField("kod"),GetField(dw,"kod"),GetField(dw,"id")), ("Czy przeliczy dostaw ?")) then
							iErr = PrzeliczDw(dw)
							if iErr != 0 then
								TextOut(using "Nie naprawiono, wystpi bd nr %d\n", iErr)
							else
								TextOut(sRepaired)
							endif
						else
							TextOut(sNoRepair)
						endif
					endif
				endif

			endif
		endif
	endif

	err=GetRec(dw,NX)
wend

StageSummary(3)

ShowFileInfo()
