//"dokeng.sci","Engine do dokumentw",12000,0,2.1.8,SYSTEM
//"Dokumenty sprzeday",12400,14,62
////////////////////////////
// Engine do dokumentw
// dokeng.sci
////////////////////////////

// wykomentowa ponisz lini, aby drukowanie ORYGINA/KOPIA itd. na podstawie arg3
// arg9=""


Limit 10000

#ifdef HM
#define HMHL
#endif
#ifdef HL
#define HMHL
#endif

#define WDT			"114"	//Wewntrzwsplnotowa dostawa towaru
#define FWS			116		//Faktura wewntrzna (sprzeday)
#define RW           76      //rozchod wewnetrzny 
#define typDOK       32		// typ dokumentu
#define WKS         118      //Faktura wewnetrzna korekta(sprzedazy)
#define FZS			108
#define IMPORTOWANY 0x20 //dokument importowany

record InfoVat
  float stawka
  string nazwa[10]
  int aktywna
  float netto
  float vat
  float brutto
endrec

record InfoPoz
	string Opis[41]
	string Kod[40]
	string sww[21]
	string KodObcy[26]
	float Ilosc
	float IloscWP
	string Jm[9]
	string JmWP[9]
	float CenaNetto
	float CenaNettoWP
	float CenaBrutto
	float CenaBruttoWP
	float WartoscNetto
	float WartoscBrutto
	float KwotaVat
	float Rabat
	float CenaPodstawowa
	float CenaPodstawowaWP
	float CenaBazTow
	float iloscdorozl
	int 	flag
	float wartTowaru
	int stawka
	long id_notatka
	long idtw
	float CenaWWal // <- CEna Brutto
	float WartWWal // <- Wartosc Brutto
	float WartoscNettoIl
	float WartoscBruttoIl
	float KwotaVatIl
endrec

record InfoDost
	int  lp
	long id
	string nazwa[40]
endrec

InfoPoz Pozycje(1)
InfoPoz PozycjeZKompletow(1)
InfoVat StVat(1)
InfoDost Dostawy(1)
//wszystkie zmienne z NP na koncu dotycza pozycji nie podleg. VAT
int CzyNP
MapValue poz_opis
string Wydania(2)
string Platnosci(3)
int StVatPos, xpos, KolTab1NP(1),StlTab1NP(1),StlTabHNP(1),nInc=1
float SumaWal,fCenaTur,fWartoscTur,fIloscTur
int mytab, mystyl(2), SumTab(1),bezVAT

string sBroken,sNazwaTur, sJMTur
int bRabatDlaWartosci, bNotatkaKh, iBroken, idw
int kolvat(1), cursize=1, cursize1=1, pom, pom1, nDostawy
int dk,dp,nt,nt2,tw,khdk,pw,dw,real_dk,real_dp
string VATWal //mowi czy dokument dk jest walutowy -> 101

BaseZZ dzz
#ifdef HMHL
BaseMZ mz
#endif
long iddok = Val ( Arg1 )
if !iddok then message "Raport mona wykona tylko z okna dokumentu" : Error ""
int GRAF = !Val ( Arg0 )
int BUFOR = Val ( Arg2 )

#include "Wydruki - include"

string sub Notatka_pozycji(int pos)
	if !(Pozycje(pos).id_notatka) then  Notatka_pozycji = "" : exit
	SetKey(nt,"id")
	SetKeySeg(nt,"id",Pozycje(pos).id_notatka)
	if GetRec(nt,EQ) then Notatka_pozycji = "" : exit
	Notatka_pozycji = GetField(nt,"opis")
endsub
//----------------------------------------------------------

String Sub DajNotatkaKontrahenta(long idkh)
	SetKey(nt,"super")
	SetKeySeg(nt,"typi",0)
	SetKeySeg(nt,"baza",20)
	SetKeySeg(nt,"super",idkh)
	if GetRec(nt,EQ) then DajNotatkaKontrahenta = "" : exit
	Arg "\r",""
	buf = GetField( nt,"opis" )
	replace arg
	DajNotatkaKontrahenta = buf
EndSub
//--------------------------------------------------------

string sub KodPaskowy_pozycji(int pos)
	if !(Pozycje(pos).idtw) then  KodPaskowy_pozycji = "" : exit
	SetKeySeg(tw,"ID",Pozycje(pos).idtw)
	if GetRec(tw,EQ) then KodPaskowy_pozycji = "" : exit
	KodPaskowy_pozycji = GetField(tw,"kodpaskowy")
endsub
string sub DajPCN(int pos)
	if !(pozycje(pos).idtw) then DajPCN = "" : exit
	SetKeySeg(tw,"ID",Pozycje(pos).idtw)
	if GetRec(tw,EQ) then DajPCN ="" : exit
	DajPCN = GetField(tw,"pcn")
endsub
float sub ObliczRabat(float tot_netto)
int i
	for i=1 to i>size(Pozycje)
		ObliczRabat +=(Pozycje(i).WartoscNetto/tot_netto)*Pozycje(i).Rabat
	next i
endsub



if arg9 then
	sNapis = arg9
else
	select case Val ( Arg3 )
		case 0
			sNapis = "ORYGINA"
		case 1
			sNapis = "KOPIA"
		case 2
			sNapis = "ORYGINA/KOPIA"
		case 4
			sNapis = "DUPLIKAT"
	endselect
endif


string sub DajNIP( string NIP )
// funkcja zwraca "REGON: ","PESEL: ","NIP: "
// w zmiennej buf zwraca cig odpowiednich cyfr
	buf=NIP
	if find regular "{[rRpP]}/:{*$}" then
		Select Case regular 1
		Case "R","r"
			DajNip = "REGON: "
		Case "P","p"
			DajNip = "PESEL: "
		EndSelect
		NIP = regular 2
		buf = NIP
	else
		DajNIP="NIP: "
		buf = NIP
	endif
endsub

int Sub ZbierzDostawy(int lp)
int err
#ifdef HMHL
	if !dzz.GetRecById(GetField(dp,"rezerwacja")) && !(dzz.GetField("subtypi") & 0x01) then
		SetKeySeg(pw,"typi",26)
		SetKeySeg(pw,"idmg",dzz.GetField("id"))
		SetKeySeg(pw,"iddw",0)
		err=GetRec(pw,GE)
		while !err && GetField(pw,"idmg")==dzz.GetField("id") && GetField(pw,"typi")==26	
			// czy ta dostawa ju jest
			for idw=1 to idw>nDostawy
				if dostawy(idw).lp==lp && dostawy(idw).id==GetField(pw,"iddw") then
					idw=nDostawy+2
				endif
			next idw
			if idw==nDostawy+1 then		// dodajemy now dostaw
				if nDostawy then grow dostawy,1
				nDostawy+=1
				dostawy(nDostawy).lp=lp
				dostawy(nDostawy).id=GetField(pw,"iddw")
				SetKeySeg(dw,"id",GetField(pw,"iddw"))
				if !GetRec(dw,EQ) then dostawy(nDostawy).nazwa=GetField(dw,"kod")
			endif
			err=GetRec(pw,NX)
		wend
	endif
	mz.SetKeySeg("idhandl",GetField(dp,"id"))
	mz.SetKeySeg("data","")
	err=mz.GetRec(GE)
	while !err && mz.GetField("idhandl")==GetField(dp,"id")
		SetKeySeg(pw,"typi",37)
		SetKeySeg(pw,"idmg",mz.GetField("id"))
		SetKeySeg(pw,"iddw",0)
		err = GetRec(pw,GE)
		while !err && GetKeySeg(pw,"typi")==37 && GetKeySeg(pw,"idmg")==mz.GetField("id")
			SetKeySeg(dw,"id",GetField(pw,"iddw"))
			if !GetRec(dw,EQ) then
				for idw=1 to idw>nDostawy
					if dostawy(idw).lp==lp && dostawy(idw).id==GetField(dw,"id") then
						idw=nDostawy+2
					endif
				next idw
				if idw==nDostawy+1 then
					if nDostawy then grow dostawy,1
					nDostawy+=1
					dostawy(nDostawy).lp=lp
					dostawy(nDostawy).id=GetField(dw,"id")
					dostawy(nDostawy).nazwa=GetField(dw,"kod")
				endif
			endif
			err=GetRec(pw,NX)
		wend
		err=mz.GetRec(NX)
	wend
#endif
EndSub

int pn1
int dokid
pn1 = Open KatalogFirmy() + "51pn.dat" for base "PN"
BaseError(pn1,4)

string sub dajdate(long id)
	
	setkey(pn1,"id")
	setkeyseg(pn1,"id",id)
	if getrec(pn1,ge) !=0 then
		message "Bd"
	else
		//jezeli nie termin zmien na data
		dajdate = getfield(pn1,"termin")
	endif
endsub
//--------------------------------------------------------

nt = Open KatalogFirmy()+"51nt.dat" For base "NT"
BaseError ( nt,2 )
nt2 = Open KatalogFirmy()+"51nt.dat" For base "NT"
BaseError ( nt2,2 )
tw = Open KatalogFirmy()+"51tw.dat" For base "TW"
BaseError ( tw,2 )
khdk = Open KatalogFirmy()+"51kh.dat" For base "KH"
BaseError ( khdk,2 )
SetKey(khdk,"id")
SetKey(tw,"id")
if BUFOR then
	dk = Open KatalogFirmy()+"51bd.dat" For base "BD"
	BaseError ( dk,4 )
	dp = Open KatalogFirmy()+"51bp.dat" For base "BP"
	BaseError ( dp,4 )
	real_dk = Open KatalogFirmy()+"51dk.dat" For base "DK"
	BaseError ( real_dk,4 )
	real_dp = Open KatalogFirmy()+"51dp.dat" For base "DP"
	BaseError ( real_dp,4 ) 
else
	dk = Open KatalogFirmy()+"51dk.dat" For base "DK"
	BaseError ( dk,4 )
	dp = Open KatalogFirmy()+"51dp.dat" For base "DP"
	BaseError ( dp,4 )
endif
SetKey ( dk,"id" )
SetKeySeg( dk,"id",iddok )
if GetRec( dk,EQ ) then BaseError ( dk,4 )
if GetField(dk, "flag") & 0x0800 Then bRabatDlaWartosci = 1
SetKey ( dp,"super" )
SetKeySeg( dp,"super",iddok )
int xt,err,mg,pn,uz

uz = Open KatalogFirmy() + "51uz.dat" for base "UZ"
BaseError(uz,4)
SetKey( uz, "kodnasz")
SetKeySeg(uz,"typi",32)

dzz.Open()

#ifdef HMHL
pw = Open KatalogFirmy()+"51pw.dat" For base "PW"
SetKey(pw,"dostawy")

dw = Open KatalogFirmy()+"51dw.dat" For base "DW"
SetKey(dw,"id")

mz.Open()
mz.SetKey("idhandl")

mg = Open KatalogFirmy() + "51mg.dat" for base "MG"
BaseError(mg,4)
SetKey(mg,"idhandl")
SetKeySeg(mg,"idhandl",iddok)
SetKeySeg(mg,"data","")
err = GetRec(mg,GE)
while !err && GetKeySeg(mg,"idhandl")==iddok
	if Wydania(1) then grow Wydania,2
	Wydania( size(Wydania)-1 )=GetField(mg,"kod")
	Wydania( size(Wydania) )=GetField(mg,"data")
	err = GetRec(mg,NX)
wend
close mg
#endif
pn = Open KatalogFirmy() + "51pn.dat" for base "PN"
BaseError(pn,4)
SetKey(pn,"dkid")
SetKeySeg(pn,"dkid",idDok)
if !GetRec(pn,EQ) then
	mg = open KatalogFirmy() + "51rl.dat" for base "RL"
	BaseError(mg,4)
	SetKey(mg,"cross2")
	SetKeySeg(mg,"id2",GetField(pn,"id"))
	err = GetRec(mg,GE)
	while !err && GetField(mg,"id2")==GetField(pn,"id")
		if Platnosci(1) then grow Platnosci,3
		Platnosci( size(Platnosci)-2 )=GetField(mg,"kod1")
		//bylo getfield(mg,"data")
		if getfield(mg,"id1") then
			Platnosci( size(Platnosci)-1 )= dajdate(getfield(mg,"id1"))
		else
			Platnosci(size(Platnosci)-1)=getField(mg,"data")
		endif
		Platnosci( size(Platnosci)   )=Kwota(GetField(mg,"wartosc"))
		err=GetRec(mg,NX)
	wend
	SetKey(mg,"cross1")
	SetKeySeg(mg,"id1",GetField(pn,"id"))
	SetKeySeg(mg,"id2",0)
	err = GetRec(mg,GE)
	while !err && GetField(mg,"id1")==GetField(pn,"id")
		if Platnosci(1) then grow Platnosci,3
		Platnosci( size(Platnosci)-2 )=GetField(mg,"kod1")
		Platnosci( size(Platnosci)-1 )=	GetField(mg,"data")
		Platnosci( size(Platnosci)   )=Kwota(GetField(mg,"wartosc"))
		err=GetRec(mg,NX)
	wend
	close mg
endif
close pn

//-----------------------------------------------------------
xt = Open KatalogFirmy()+"51xt.dat" For base "XT"
BaseError ( xt,4 )

int CZYNETTO
if VAT then CZYNETTO = GetField( dk,"grupaceni" ) & 1
int nImportowany
if (GetField(dk,"exp_fki") & IMPORTOWANY) then nImportowany=1
float tot_netto,tot_nettoNP
float tot_vat,tot_brutto,tot_wartbaza, tot_akcyza
VATWal = (using "%d",GetField(dk,"subtypi"))
int iTyp=GetField( dk, "subtypi" )

#ifndef ZALICZKA
	if iTyp==FZS then 
	if (message "Uwaga ten raport nie jest przeznaczony dla Faktur zaliczkowych.\nCzy kontynuowa wydruk?{{icon=? buttons=(&Nie:2)[&Tak:1]}}") == 2 then error ""
	endif
#endif

int bRW = 0
#ifdef HMHL
mg = Open KatalogFirmy() + "51mg.dat" for base "MG"
BaseError(mg,4)
SetKey(mg,"id")
SetKeySeg(mg,"id",VAL(GetField( dk, "odebrane" )))
if !GetRec(mg,EQ) then
	bRW = iif(GetField( mg, "subtypi" )== RW, 1, 0)
	if Wydania(1) then grow Wydania,2
	Wydania( size(Wydania)-1 )=GetField( mg, "kod")
	Wydania( size(Wydania) )=GetField( mg, "data")
endif
close mg
#endif
//w przypadku gdy dok. jest anulowany VatWal=0, wiec wartosc VatWal nadawana automatycznie
if VatWal=="0" then
	Select case GetReportName()
//		sprzedaz vat
		case "Dokument VAT I","Dokument VAT format HTML","Dokument VAT format RTF","Dokument VAT I org+kop na stronie","Dokument VAT tekstowy I org+kop","Dokument VAT tekstowy I"
			VatWal="40"
		//sprzedaz vat w walucie
		case "Dokument VAT tekstowy w walucie" , "Dokument VAT w walucie","Dokument VAT w walucie format HTML","Dokument VAT w walucie format RTF"
			VatWal="101"
		//dok. eksportowy
		case "Dokumenteksport tekstowyI","Dokumenteksport I", "Dokumenteksport PLN", "Dokumenteksport I ang","Dokument eksportowy format HTML","Dokument eksportowy format RTF", "Dokumenteksport tekstowyI ang"
			SetKey ( xt,"kod" )
			SetKeySeg( xt,"typi",typDOK )
			SetKeySeg( xt,"kod",GetField(dk,"typ_dk") )
			if (!GetRec ( xt,GE ) && GetField(xt,"typi") == typDOK && GetField(xt,"kod") == GetField(dk,"typ_dk")) then
				VatWal=(using "%d",GetField( xt,"long" ))
			else
				VatWal="46"
			endif
		//bez vat
		case "Dokument bez VAT I", "Dokument bez VAT format HTML","Dokument bez VAT format RTF","Dokument bez VAT tekstowy I"
			VatWal="79"
	endSelect
endif

if VAT then
	tot_netto = GetField( dk, "netto" )
	tot_Vat = GetField( dk, "vat" )
	tot_brutto = GetField( dk, "netto" ) + GetField( dk, "vat" )
else
	tot_netto=0
endif


//if VAT || VatWal==WDT then
	SetKey ( xt,"super" )
	SetKeySeg( xt,"super",10000 )
	err=GetRec ( xt,GE )
	while (!err)&&(GetKeySeg(xt,"super")==10000)
		if GetField(xt,"subtypi")!=255 then
	  		pom = GetField( xt,"subtypi" ) + 1
	  		pom1 = GetField( xt,"long" ) + 1
 	 		if pom>cursize then cursize = Grow stvat,pom-cursize
  			if pom1>cursize1 then cursize1 = Grow kolvat,pom1-cursize1
  			StVat(pom).stawka = GetField( xt,"wartosc" )
  			StVat(pom).nazwa = GetField( xt,"kod" )
	  		StVat(pom).aktywna = GetField( xt, "flag" ) & 128
 	 		kolvat(pom1)=pom
			buf = StVat(pom).nazwa
			move to 1
			while replace ""," "
			wend
			StVat(pom).nazwa = buf
		endif
		err=GetRec ( xt,NX )
	wend
//endif
//dla makra StVAT
Select case iTyp
		case 46,114,115,72
			bezVat=2
		case 126
		Grow stvat,1
		bezVat=size(stvat)
		stvat(bezVat).nazwa="NP"
		stvat(bezVat).stawka=0
EndSelect
#include "Patnoci"

//-------------------------------------------------
float fKurs = GetField( dk,"kurs" )
int nIloczynowa 
if VAT then nIloczynowa= !(GetField( dk, "flag") & 0x8000)

int lp,lpkp,bNoPoz		// lpkp - indeks pozycji z kompletw
SetKey ( nt,"id" )
SetKey ( nt2,"super" )
SetKeySeg( nt2,"typi",0 )
SetKeySeg( nt2,"baza",22 )
poz_opis.Type(string)
err = GetRec( dp,GE )
if err || GetKeySeg( dp,"super" ) != iddok then bNoPoz = 1
while ( !err ) && ( GetKeySeg( dp,"super" ) == iddok )
if ! (GetField(dp,"flag") & 0x4000) then
	lp += 1
	if lp != 1 then	Grow Pozycje,1
	Pozycje(lp).Jm = GetField( dp,"jm" )
	Pozycje(lp).JmWP = GetField( dp,"jmwp" )
	Pozycje(lp).Ilosc = GetField ( dp,"ilosc" )
	Pozycje(lp).IloscWP = GetField ( dp,"iloscwp" )
	SetKeySeg(nt2,"super",GetField(dp,"idtw"))
	if !GetRec(nt2,EQ) then Pozycje(lp).id_notatka = GetFIeld(nt2,"id")
	if VatWal == WDT then Pozycje(lp).stawka=2
	if VAT then
		if GetField(dp,"stvati")==255 then
			Pozycje(lp).stawka=-1
			CzyNP=1
		else
			Pozycje(lp).stawka = GetField( dp,"stvati" ) + 1
		endif
		if CZYNETTO then
			if GetField( dp,"jmwp" ) != GetField( dp,"jm" ) then
				Pozycje(lp).CenaNetto = GetField ( dp,"cena" )/(Pozycje(lp).Ilosc /	Pozycje(lp).IloscWP)
			else
				Pozycje(lp).CenaNetto = GetField ( dp,"cena" )
			endif
			Pozycje(lp).CenaNettoWP = GetField ( dp,"cena" )
#ifndef ZALICZKA
			if sign(fKurs,4) && fKurs!=1 then
			Pozycje(lp).WartoscNetto= round(Pozycje(lp).Ilosc*Pozycje(lp).CenaNetto/fKurs,2)*fKurs
			if lp==1 then tot_netto=0:tot_vat=0:tot_brutto=0
			tot_netto+=Pozycje(lp).WartoscNetto 
			tot_vat+=GetField(dp,"wartVat")
			tot_brutto+=Pozycje(lp).WartoscNetto+GetField(dp,"wartVat")
			else
#endif
			Pozycje(lp).WartoscNetto = GetField( dp,"wartNetto" )
#ifndef ZALICZKA
			endif
#endif
			if Pozycje(lp).stawka>-1 then
				Pozycje(lp).KwotaVat = GetField( dp,"wartVat" )//Pozycje(lp).WartoscNetto * stvat(Pozycje(lp).stawka).stawka//, 2 )
				Pozycje(lp).WartoscBrutto = Pozycje(lp).WartoscNetto + Pozycje(lp).KwotaVat
			endif
			if Pozycje(lp).stawka>-1 then
				Pozycje(lp).CenaBrutto = Pozycje(lp).CenaNetto * (1+stvat(Pozycje(lp).stawka).stawka)
				Pozycje(lp).CenaBruttoWP = Pozycje(lp).CenaNettoWP * (1+stvat(Pozycje(lp).stawka).stawka)
			endif
		else
			if Pozycje(lp).stawka!=-1 then
				Pozycje(lp).WartoscBrutto = GetField(dp,"wartNetto")+GetField(dp,"wartVat")
#ifdef WALVAT				
				Pozycje(lp).WartoscNetto =  GetField(dp,"wartNetto")
#else
				Pozycje(lp).WartoscNetto =  Pozycje(lp).WartoscBrutto/(1+stvat(Pozycje(lp).stawka).stawka) 
#endif		 
				Pozycje(lp).KwotaVat = GetField( dp,"wartVat" )//Pozycje(lp).WartoscBrutto - Pozycje(lp).WartoscNetto
			else
				Pozycje(lp).CenaNetto=GetField(dp,"Wartnetto")/Pozycje(lp).Ilosc
				Pozycje(lp).WartoscNetto=GetField(dp,"wartNetto")
			endif
			if GetField( dp,"jmwp" ) != GetField( dp,"jm" ) then
				Pozycje(lp).CenaNettoWP=Pozycje(lp).CenaNetto/Pozycje(lp).IloscWP
				Pozycje(lp).CenaBrutto = GetField(dp,"cena")/(Pozycje(lp).Ilosc /	Pozycje(lp).IloscWP)
			else
				Pozycje(lp).CenaNettoWP=Pozycje(lp).CenaNetto
				Pozycje(lp).CenaBrutto = GetField(dp,"cena")
			endif
			Pozycje(lp).CenaBruttoWP = GetField(dp,"cena")
			if Pozycje(lp).stawka!=-1 then
#ifdef	WALVAT	
				Pozycje(lp).CenaNetto = Pozycje(lp).WartoscNetto/Pozycje(lp).Ilosc
				Pozycje(lp).CenaNettoWP = Pozycje(lp).WartoscNetto/Pozycje(lp).IloscWP
#else		
				Pozycje(lp).CenaNetto =  Pozycje(lp).CenaBrutto/(1+stvat(Pozycje(lp).stawka).stawka)
				Pozycje(lp).CenaNettoWP = Pozycje(lp).CenaBruttoWP/(1+stvat(Pozycje(lp).stawka).stawka) 
#endif		 
			endif
		endif
		if Pozycje(lp).stawka>-1 then
			stvat(Pozycje(lp).stawka).vat += GetField( dp,"wartVat" )
			if sign(fKurs,4) && CZYNETTO && fKurs!=1 then
			stvat(Pozycje(lp).stawka).brutto += Pozycje(lp).WartoscNetto+Pozycje(lp).KwotaVat
			stvat(Pozycje(lp).stawka).netto +=Pozycje(lp).WartoscNetto
			else 
				if sign(fKurs,4)&& fKurs!=1 then 
				stvat(Pozycje(lp).stawka).brutto += Round(Pozycje(lp).WartoscNetto+Pozycje(lp).KwotaVat)
				stvat(Pozycje(lp).stawka).netto +=Pozycje(lp).WartoscNetto
				else			
				stvat(Pozycje(lp).stawka).brutto += GetField( dp,"wartNetto" ) + GetField( dp,"wartVat" )
				stvat(Pozycje(lp).stawka).netto += GetField( dp,"wartNetto" )
				endif
			endif
		else
			tot_nettoNP+=GetField(dp,"wartNetto")
		endif
	else
		if GetField( dp,"jmwp" ) != GetField( dp,"jm" ) then
			Pozycje(lp).CenaNetto = GetField ( dp,"cena" )/(	Pozycje(lp).Ilosc /	Pozycje(lp).IloscWP)
		else
			Pozycje(lp).CenaNetto = GetField ( dp,"cena" )
		endif
		Pozycje(lp).CenaNettoWP = GetField ( dp,"cena" )
		if sign(fKurs,4) && fKurs!=1 then
		Pozycje(lp).WartoscNetto=Round(Pozycje(lp).CenaNetto/fKurs*Pozycje(lp).Ilosc,2)*fkurs
		else
		Pozycje(lp).WartoscNetto = GetField(dp,"wartNetto")//((Pozycje(lp).CenaNettoWP/fkurs) * Pozycje(lp).IloscWP) * fkurs
		endif
		tot_netto+=Round(Pozycje(lp).WartoscNetto/iif(fKurs!=0,fKurs,1),2)
	endif
	Pozycje(lp).Opis = GetField ( dp,"opis" )
	if GetField( dp,"idlongname" ) then
		SetKeySeg ( nt,"id",GetField( dp,"idlongname" ) )
		if GetRec( nt,EQ ) then BaseError ( nt,2 )
		poz_opis.Set((using"%d",lp),GetField ( nt,"opis" ))
	else
		poz_opis.Set((using"%d",lp),GetField ( dp,"opis" ))
	endif
	SetKeySeg(uz,"iduz",GetField(dp,"idtw"))
	SetKeySeg(uz,"idkh",GetField(dp,"idkh"))
	if !GetRec(uz,EQ) then Pozycje(lp).KodObcy=GetField(uz,"kodobcy")
	if VatWal!= WDT then
	Pozycje(lp).sww = GetField ( dp,"opisdod" )
	else
	Pozycje(lp).sww = "Art.42 ust.1"
    endif
	Pozycje(lp).Kod = GetField ( dp,"kod" )
	Pozycje(lp).idtw = GetField ( dp,"idtw" )
	if GetField( dp,"jmwp" ) != GetField( dp,"jm" ) then
		Pozycje(lp).CenaPodstawowa = GetField( dp,"cenaBazaPl" )/(Pozycje(lp).Ilosc /	Pozycje(lp).IloscWP)
	else
		Pozycje(lp).CenaPodstawowa = GetField( dp,"cenaBazaPl" )
	endif
	Pozycje(lp).CenaPodstawowaWP = GetField( dp,"cenaBazaPl" )
	Pozycje(lp).CenaBazTow = GetField( dp,"cenaBazTow" )
	Pozycje(lp).iloscdorozl = GetField( dp,"iloscdorozl" )
	Pozycje(lp).flag = GetField( dp,"flag" )
	Pozycje(lp).wartTowaru = GetField( dp,"wartTowaru" )
	if !GetField( dp,"cenaBazaPl" ) then SetField(dp,"cenaBazaPl",1)
	Pozycje(lp).Rabat = 100 * ( GetField( dp,"cenaBazaPl" )-GetField( dp,"cena" ) )/GetField( dp,"cenaBazaPl" )
	tot_wartbaza += val( using "%.2f",GetField( dp,"cenaBazaPl" ) * iif((GetField ( dp,"jm" )==GetField ( dp,"jmwp" )),GetField ( dp,"ilosc" ),GetField ( dp,"iloscwp" )) )
	if VatWal == "101" then
		if Pozycje(lp).stawka!=-1 then
			Pozycje(lp).CenaWWal = (Pozycje(lp).CenaBrutto / fkurs)
			Pozycje(lp).WartWWal = (Pozycje(lp).WartoscBrutto / fkurs)
		else
			Pozycje(lp).CenaWWal = (Pozycje(lp).CenaNetto / fkurs)
			Pozycje(lp).WartWWal = (Pozycje(lp).WartoscNetto / fkurs)
		endif
	endif
	//dostawy
	ZbierzDostawy(lp)
else
	ZbierzDostawy(GetField(dp,"lp"))
		lpkp += 1
		if lpkp != 1 then Grow PozycjeZKompletow,1
		PozycjeZKompletow(lpkp).idtw = GetField ( dp,"idtw" )
		PozycjeZKompletow(lpkp).iloscdorozl = GetField( dp,"iloscdorozl" )
		PozycjeZKompletow(lpkp).flag = GetField( dp,"flag" )
		PozycjeZKompletow(lpkp).wartTowaru = GetField( dp,"wartTowaru" )

endif		// !(GetField(dp,"flag") & 0x4000)
//korekta oblicze dla iloczynowych	
	if nIloczynowa && lp then
		if CZYNETTO then
			if Pozycje(lp).stawka>0 then Pozycje(lp).KwotaVatIl=Pozycje(lp).WartoscNetto*stvat(Pozycje(lp).stawka).stawka
			Pozycje(lp).WartoscBruttoIl=Pozycje(lp).WartoscNetto+Pozycje(lp).KwotaVatIl	
			Pozycje(lp).WartoscNettoIl=Pozycje(lp).WartoscNetto
		else
			if Pozycje(lp).stawka>0 then Pozycje(lp).KwotaVatIl=Pozycje(lp).WartoscBrutto*stvat(Pozycje(lp).stawka).stawka/(1+stvat(Pozycje(lp).stawka).stawka)		
			Pozycje(lp).WartoscNettoIl=Pozycje(lp).WartoscBrutto-Pozycje(lp).KwotaVatIl
			Pozycje(lp).WartoscBruttoIl=Pozycje(lp).WartoscBrutto
		endif
	endif
	err = GetRec( dp,NX )
wend
string sWaluta = GetField( dk,"waluta" )
sNazwaDok = GetField( dk, "nazwa" )
sDataWyst = GetField( dk,"data" )
sNumerDok = GetField( dk,"kod" )
string sDataSp = GetField( dk,"datasp" )
string sNabywca = GetField( dk,"khnazwa" )
string sNabKodPocz = GetField( dk,"khkodpocz" )
string sNabMiasto = GetField( dk,"khmiasto" )
string sNabAdres = BuildAdresKh(dk)
string sNabNip = GetField( dk,"khnip" )
string sNabKod = GetField( dk,"khkod" )
string sNabTel1
string sNabTel2
string sNabFax
string sNabEMail
string sNabPesel
string sNabRegon
SetKeySeg(khdk,"id",GetField(dk,"khid"))
if !GetRec(khdk,EQ) then
	sNabTel1 = GetField( khdk,"tel1" )
	sNabTel2 = GetField( khdk,"tel2" )
	sNabFax = GetField( khdk,"fax" )
	sNabEMail = GetField( khdk,"email" )
	sNabPesel = GetField(khdk,"pesel")
	sNabRegon = GetField(khdk,"regon")
endif
string sOdbPesel
string sOdbRegon
string sOdbiorca = GetField( dk, "odnazwa" )
string sOdbKodPocz = GetField(dk,"odkodpocz")
string sOdbMiasto = GetField(dk,"odmiasto")
string sOdbAdres = BuildAdresOd( dk )
string sOdbTel1
string sOdbTel2
string sOdbFax
string sOdbEMail

SetKeySeg(khdk,"id",GetField(dk,"odid"))
if !GetRec(khdk,EQ) then
	sOdbTel1 = GetField( khdk,"tel1" )
	sOdbTel2 = GetField( khdk,"tel2" )
	sOdbFax = GetField( khdk,"fax" )
	sOdbEMail = GetField( khdk,"email" )
	sOdbPesel = GetField(khdk,"pesel")
	sOdbRegon = GetField(khdk,"regon")
endif
string sFmPesel
string sFmRegon
SetKeySeg(khdk,"id",1)//firma
if !GetRec(khdk,EQ) then
	sFmPesel = GetField(khdk,"pesel")
	sFmRegon = GetField(khdk,"regon")
endif
string sOpis = GetField( dk,"opis" )
string sTerminPlat = GetField( dk, "plattermin" )
float fWplaty = GetField( dk,"wplaty" )
int bRealizacja=GetFIeld(dk,"oki")
int bAnulowano
if GetField( dk,"subtypi" ) == 0 || GetField( dk,"subtypi" ) == 1 || GetField(dk,"subtypi")==3 then bAnulowano = 1
//0 - dokumenty anulowane, 1 - ?, 3 - paragon z wystawiona do niego faktura
float fRabat
//stara metoda naliczania rabatow
//if Sign(tot_wartbaza) then
//	if ( CZYNETTO || !VAT ) then
//		fRabat = 100*(tot_wartbaza-tot_netto)/tot_wartbaza
//	else
//		fRabat = 100*(tot_wartbaza-tot_brutto)/tot_wartbaza
//	endif
//endif
//nowa metoda naliczania rabatu dokumentu 
#ifdef DOKEXP
	if tot_netto then fRabat=Round(ObliczRabat(tot_netto*fKurs),2)
#else
	if tot_netto then fRabat=Round(ObliczRabat(tot_netto),2)
#endif
	
SetKey ( nt,"super" )
SetKeySeg( nt,"typi",0 )
SetKeySeg( nt,"baza",16 )
if BUFOR then SetKeySeg(nt,"baza",28)
SetKeySeg( nt,"super",iddok )
string sNotatka
if !GetRec( nt,EQ ) then
	Arg "\r",""
	buf = GetField( nt,"opis" )
	replace arg
	sNotatka = buf
endif

SetKey ( xt,"id" )
SetKeySeg( xt,"id",GetField( dk,"rodzaj" ) )
string sNotatkaRodz
if !GetRec( xt,EQ ) then
	SetKey ( nt,"super" )
	SetKeySeg( nt,"typi",0 )
	SetKeySeg( nt,"baza",16 )
	SetKeySeg( nt,"super",GetField( xt,"klient" ))
	if !GetRec( nt,EQ ) then
		Arg "\r",""
		buf = GetField( nt,"opis" )
		replace arg
		sNotatkaRodz = buf
	endif
endif

firma.Magazyn(GetField(dk,"magazyn"))
if !firma.Uzywaj then firma.Magazyn(0)
close uz

//-----------------------------------------------------
// Cakowita akcyza
float SUB ObliczAkcyze()
	String kalkakcwal
	Float kalkakc
	float tot_akcyza = 0
	int i

FOR i = 1 TO i > lp		// sumuj po pozycjach
	IF Pozycje(i).idtw && tot_akcyza != -1 && (Pozycje(i).flag & 0x0200) THEN // .., .., sprawdzam czy jest to towar
			IF Pozycje(i).iloscdorozl THEN		// sprawdzam czy towar jest cakowicie rozliczony
				tot_akcyza = -1 								// towar nie jest rozliczony nie mona uwzgldnia akcyzy
			ELSE
				SetKeySeg(tw,"id",Pozycje(i).idtw)
				IF !GetRec(tw,EQ) && GetField(tw,"kalkakc") THEN // .., sprawdzam czy na towar jest akcyza
			
					kalkakcwal = GetField(tw,"kalkakcwal")
					kalkakc = GetField(tw,"kalkakc")	

					IF !kalkakcwal THEN
						tot_akcyza += iif((GetField ( dp,"jm" )==GetField ( dp,"jmwp" )),GetField ( dp,"ilosc" ),GetField ( dp,"iloscwp" )) * kalkakc
					ELSE IF kalkakcwal == "%" THEN
						kalkakc = kalkakc/100
						tot_akcyza += Pozycje(i).wartTowaru * kalkakc / (kalkakc+1) // akcyza obliczana na podstawie "wartTowaru"
					ELSE 
						tot_akcyza += KursWaluty(kalkakcwal) * kalkakc * iif((GetField ( dp,"jm" )==GetField ( dp,"jmwp" )),GetField ( dp,"ilosc" ),GetField ( dp,"iloscwp" ))
					ENDIF
					ENDIF
				ENDIF
			ENDIF
	ENDIF
NEXT i

FOR i = 1 TO i > lpkp // sumuj po pozycjach z kompletw
	IF PozycjeZKompletow(i).idtw && tot_akcyza != -1 && (PozycjeZKompletow(i).flag & 0x0200) THEN // .., .., sprawdzam czy jest to towar
			IF PozycjeZKompletow(i).iloscdorozl THEN		// sprawdzam czy towar jest cakowicie rozliczony
				tot_akcyza = -1 													// towar nie jest rozliczony nie mona uwzgldnia akcyzy
			ELSE
				SetKeySeg(tw,"id",PozycjeZKompletow(i).idtw)
				IF !GetRec(tw,EQ) && GetField(tw,"kalkakc") THEN // .., sprawdzam czy na towar jest akcyza
			
					kalkakcwal = GetField(tw,"kalkakcwal")
					kalkakc = GetField(tw,"kalkakc")	

					IF !kalkakcwal THEN
						tot_akcyza += PozycjeZKompletow(i).Ilosc * kalkakc
					ELSE IF kalkakcwal == "%" THEN
						kalkakc = kalkakc/100
						tot_akcyza += PozycjeZKompletow(i).wartTowaru * kalkakc / (kalkakc+1) // akcyza obliczana na podstawie "wartTowaru"
					ELSE 
						tot_akcyza += KursWaluty(kalkakcwal) * kalkakc * PozycjeZKompletow(i).Ilosc
					ENDIF
					ENDIF
				ENDIF
			ENDIF
	ENDIF
NEXT i

ObliczAkcyze = tot_akcyza
ENDSUB

int sub ObliczWys( string s, int szer )
	int t
	ObliczWys=0
	sBroken=""
	iBroken=0
	if GRAF then szer -= TextWidth("  ")
	if !s then exit
	while	s
		t = BreakLine(szer,0,1,s)
		if TextWidth(Mid(s,1,t))>szer then t = BreakLine(szer,0,0,s)
		ObliczWys += TextHeight(Mid(s,1,t))
		if GRAF then sBroken +=" "
		sBroken+=Mid(s,1,t)+lf
		iBroken += 1
		s = Mid(s,t+1)
		if s && mid(s,1,1)==" " then s = Mid(s,2)
		if s && mid(s,1,1)=="\n" then s = Mid(s,2)
	wend
endsub
//----------------------------------------------------
string sub formatuj(float liczba, int dokl)
int pos, dl, posb
string sliczba
string wynik, spom

sliczba = using "%f",liczba
//	sliczba=liczba
	posb = move 0
	spom=buf
	buf = sliczba

	if find "." then
		pos = move 0
		wynik = mid(sliczba,pos+1,dokl)
		wynik= ","+wynik
		if val(mid(wynik,2))==0 then wynik=",00"
		while size(wynik)<dokl+1
			wynik=wynik+"0"
		wend		
	else
		wynik="     "
		pos=size(buf)+1
	endif

	pos=pos-3
	dl=3
	if pos<=0 then dl=dl+pos-1: pos=1
	wynik = mid(sliczba,pos,dl)+wynik

	while pos>1
		pos=pos-3
		dl=3
		if pos<=0 then dl=dl+pos-1: pos=1
		wynik = mid(sliczba,pos,dl)+" "+wynik
	wend
	formatuj = wynik
	buf=spom
	move to posb
endsub
