//"intezkfk.sci","Integracja ZK do FK - include",12016,0,1.0.0,SYSTEM
//"Integracja z FK-a",12015,14,62
/////////////////////////////////////////
// "Integracja ZK do FK - include"
// intezkfk.sci
/////////////////////////////////////////

// dostpne opcje wywoania fukcji IntegrortZK()
#define ROWNOLEGLE_KSIEG_MAG		0x1
record	TestRej
	int Rej
	int Typ
endrec

#include "Integracja ZK do FK - include2"

int Sub IntegrZK(long idDK, int iOpcje)
// zmienne globalne: BaseDK basDK, BaseDP basDP, InfoVat StVat(6)

	IntegrZK = 0

	string sTyp, sFKDok
	int err
	int bKorekta = 0, bRozliczony
	int nCount = 1
	int nPozycja = 0
	int iStVat
	int iRejVat, iPom,iPom2
	int index = 1

	nLastZap = 0

	String strOkres
	float dWartosc
	String strTmp
	int iSubtyp

	string sRej
	long lSuper
	long lABC

	TestRej TabTestRej(1)

	int IDFK_K
	
	strOpis = ""

	if basDK.GetRecById(idDK) then error "Brak takiego rekordu w bazie DK"

	sukces=0
	for i=1 to i>size(RokFK)
		if RokFK(i).IdRok == dbd.firmainfo.GetRokByDate(basDK.GetField("data")) && RokFK(i).Zap == 1 then sukces=i
	next i
	if sukces then
		dst=RokFK(sukces).Rok
		plkn=RokFK(sukces).PlanKont
		defdok=RokFK(sukces).DefDokument
		defrej=RokFK(sukces).DefRejestr
	else
		if !(size(RokFK)==1 && RokFk(1).Zap == 0) then grow RokFK, 1
		sParam = using "%d;BUFOR", dbd.firmainfo.GetRokByDate(basDK.GetField("data"))
		RokFK(size(RokFK)).Rok.Create(ObjectFK(".PDokument"))
		RokFK(size(RokFK)).Rok.Open(sParam,dbd)

		sParam = using "%d", dbd.firmainfo.GetRokByDate(basDK.GetField("data"))
		RokFK(size(RokFK)).PlanKont.Create(ObjectFK(".PlanKont"))
		RokFK(size(RokFK)).PlanKont.Open(sParam,dbd)
		if !RokFK(size(RokFK)).PlanKont.MoveFirst() then
			AddError("Brak planu kont.",0)
		endif

		RokFK(size(RokFK)).DefDokument.Create(ObjectFK(".DefDokum"))
		RokFK(size(RokFK)).DefDokument.Open(sParam,dbd)
		RokFK(size(RokFK)).DefRejestr.Create(ObjectFK(".DefRej"))
		RokFK(size(RokFK)).DefRejestr.Open(sParam,dbd)
		RokFK(size(RokFK)).IdRok=dbd.firmainfo.GetRokByDate(basDK.GetField("data"))
		RokFK(size(RokFK)).Zap=1

		dst = RokFK(size(RokFK)).Rok
		plkn = RokFK(size(RokFK)).PlanKont
		defdok = RokFK(size(RokFK)).DefDokument
		defrej = RokFK(size(RokFK)).DefRejestr
	endif

	// sprawdzamy typ dokumentu
	iSubtyp = basDK.GetField("subtypi")
	Select Case iSubtyp
		Case FVZ, FKZ, RUZ, RKZ, DIM, DKM, FVR, FKR, ZRZ, ZRK , FVM, FKM, FZZ, ZKZ, WNT, FWZ, WKZ, WNK
		Case Else
			IntegrZK = 1 // pomijamy
			AddError("Nie mona wysa dokumentu " + basDK.GetField("kod") + ".",idDK)
	EndSelect
	if ( IntegrZK == 1 ) then Exit

	if CzyIntegrBrakSchematu(basDK.GetField("schemat"), basDK.GetField("kod"), idDK) then
		IntegrZK = 1 // pomijamy
		Exit
	endif

	if CzyIntegrBlednySchemat(basDK.GetField("schemat"), basDK.GetField("kod"), basDK.GetField("subtypi"), idDK) then
		IntegrZK = 1 // pomijamy
		Exit
	endif

	if 0 != basDK.GetField("khid") then
		if basKH.GetRecById(basDK.GetField("khid")) then error "Brak takiego rekordu w bazie KH"
		IntegrZK = CzyIntegrBrakIDFK(basKH.GetField("idfk"), basDK.GetField("kod"), idDK)
		if IntegrZK then exit
	endif

	sTyp = basDK.GetField("typ_dk")
	if (basDK.GetField("exp_fki")&FDK_IMPORT) then
		basXT.SetKey("kod")
		basXT.SetKeySeg("typi", XTustaDOK)
		basXT.SetKeySeg("kod", basDK.GetField("typ_dk"))
		err = basXT.GetRec(GE)
		sTyp = ""
		while !err && basXT.GetField("typi") == XTustaDOK && basXT.GetField("kod") != basDK.GetField("typ_dk") && basXT.GetField("long") != basDK.GetField("subtypi")
			err = basXT.GetRec(NX)
		wend
		if basXT.GetField("typi") == XTustaDOK && basXT.GetField("kod") == basDK.GetField("typ_dk") && basXT.GetField("long") == basDK.GetField("subtypi") then
			sTyp = basDK.GetField("typ_dk")
		else
			basXT.SetKey("kod")
			basXT.SetKeySeg("typi", XTustaDOK)
			basXT.SetKeySeg("kod", TypDOK(basDK.GetField("subtypi")))
			err = basXT.GetRec(GE)
			while !err && basXT.GetField("typi") == XTustaDOK && basXT.GetField("kod") != TypDOK(basDK.GetField("subtypi")) && basXT.GetField("long") != basDK.GetField("subtypi")
				err = basXT.GetRec(NX)
			wend
			if basXT.GetField("typi") == XTustaDOK && basXT.GetField("kod") == TypDOK(basDK.GetField("subtypi")) && basXT.GetField("long") == basDK.GetField("subtypi") then
				sTyp = TypDOK(basDK.GetField("subtypi"))
			else
				IntegrZK = CzyIntegrBrakTypDK("", basDK.GetField("kod"), idDK, TypDOK(basDK.GetField("subtypi")))
			endif
		endif
	endif
	if !(basDK.GetField("exp_fki")&FDK_IMPORT) || ((basDK.GetField("exp_fki")&FDK_IMPORT) && sTyp != "") then
		basDK2.SetKey("numer")
		basDK2.SetKeySeg("typi", 101)	// KARTAdkTYP
		basDK2.SetKeySeg("kod",  sTyp)
		if basDK2.GetRec(EQ)  then error "Brak takiego rekordu w bazie DK"
		IntegrZK = CzyIntegrBrakTypDK(basDK2.GetField("khadres"), basDK.GetField("kod"), idDK, sTyp)
	endif
	if IntegrZK then exit

	iSubtyp = basDK.GetField("subtypi")
	Select Case iSubtyp
		Case FVZ, FKZ, RUZ, RKZ, DIM, DKM, FVR, FKR, ZRZ, ZRK, FVM, FKM, FZZ, ZKZ, WNT, FWZ, WKZ, WNK
			basDP.SetKey("super")
			basDP.SetKeySeg("super", idDK)
			err = basDP.GetRec(GE)
			while !err && basDP.GetKeySeg("super") == idDK
				if !(basDP.GetField("flag") & BFLAGdpDOKOMPL) then
					iStVat = basDP.GetField("stvati")
					sRej = (using "%d",basDP.GetField("rejestrVati"))
					lSuper = 10700
					basXT.SetKey("super")
					basXT.SetKeySeg("super", lSuper)
					basXT.SetKeySeg("kod", "")
					basNT.SetKey("super")
					basNT.SetKeySeg("typi", 18)
					basNT.SetKeySeg("baza", 2)
					err = basXT.GetRec(GE)
					while !err && basXT.GetKeySeg("super") == lSuper					
						strTmp = Using "%l", basXT.GetField("long")							
						if sRej == strTmp then
							basNT.SetKeySeg("super", basXT.GetField("id"))
							if !basNT.GetRec(EQ) then
								buf = basNT.GetField("opis")
								move 0
								find "\$\$"
								IntegrZK = CzyintegrBlednyRej(mid(buf,1,(move 0)-1), basDK.GetField("kod"), idDK)							
								TabTestRej(size(TabTestRej)).Rej = val(mid(buf,1,(move 0)-1))
								TabTestRej(size(TabTestRej)).Typ = basXT.GetField("zawartosc")
								grow TabTestRej,1
							else
								IntegrZK = CzyintegrBlednyRej("", basDK.GetField("kod"), idDK)
							endif
							exit // wyjcie z ptli
						endif
						err = basXT.GetRec(NX)
					wend
					if (iSubtyp == FWZ || iSubtyp == WKZ) then
						iStVat = basDP.GetField("stvati")
						sRej = (using "%d",basDP.GetField("grupaceni"))
						lSuper = 10500
						basXT.SetKey("super")
						basXT.SetKeySeg("super", lSuper)
						basXT.SetKeySeg("kod", "")
						basNT.SetKey("super")
						basNT.SetKeySeg("typi", 18)
						basNT.SetKeySeg("baza", 2)
						err = basXT.GetRec(GE)
						while !err && basXT.GetKeySeg("super") == lSuper					
							strTmp = Using "%l", basXT.GetField("long")							
							if sRej == strTmp then
								basNT.SetKeySeg("super", basXT.GetField("id"))
								if !basNT.GetRec(EQ) then
									buf = basNT.GetField("opis")
									move 0
									find "\$\$"
									IntegrZK = CzyintegrBlednyRej(mid(buf,1,(move 0)-1), basDK.GetField("kod"), idDK)							
									TabTestRej(size(TabTestRej)).Rej = val(mid(buf,1,(move 0)-1))
									TabTestRej(size(TabTestRej)).Typ = basXT.GetField("zawartosc")
									grow TabTestRej,1
								else
									IntegrZK = CzyintegrBlednyRej("", basDK.GetField("kod"), idDK)
								endif
								exit // wyjcie z ptli
							endif
							err = basXT.GetRec(NX)
						wend
					endif
					if IntegrZK then exit
				endif
				err = basDP.GetRec(NX)
				IntegrZK = CzyintegrBrakRej(iif(sRej == strTmp,0,1), basDK.GetField("kod"), idDK)
				if IntegrZK then exit
			wend
	endselect

	if IntegrZK then exit

	shrink TabTestRej,-1
	TabTestRej(1).Rej=-2000
	TabTestRej(1).Typ=-2000
	if IntegrZK then exit

	if ( basDK.GetField("iddokkoryg") ) then bKorekta = 1
	bRozliczony = basDK.GetField("oki")

	dst.Clear()
	sOpisy=0
	dbd.CurrentDate = sDataWpr
	dst.Value("DataDok") = basDK.GetField("datasp")

// w przeciwnym razie FK-a generuje ostrzeenia e okres dokumentu nie zgadza si z okresem rejestru
	if basDK.GetField("subtypi") == DIM || basDK.GetField("subtypi") == DKM then
		dst.Value("DataOkr") = basDK.GetField("datasp")
	else
		dst.Value("DataOkr") = sDataWpr	//basDK.GetField("datasp")
	endif

	dst.Value("DataOper") = basDK.GetField("datasp")
	dst.Value("Datawpr") = sDataWpr
	if basDK.GetField("khid") != 0 && !basKH.GetRecById(basDK.GetField("khid")) then
		dst.Value("kontrahent") = basKH.GetField("idfk")
	endif
	if 0 == basDK.GetField("khid") && basDK.GetField("khnazwa") != "" then
		kontrah.ClearRecord()
		kontrah.Value("nazwa") = basDK.GetField("khnazwa")
		kontrah.Value("nip") = basDK.GetField("khnip")
		kontrah.Value("ulica") = basDK.GetField("khadres")
		kontrah.Value("nrDomu") = basDK.GetField("khdom")
		kontrah.Value("nrMieszkania") = basDK.GetField("khlokal")
		kontrah.Value("miejscowosc") = basDK.GetField("khmiasto")
		kontrah.Value("kodPocztowy") = basDK.GetField("khkodpocz")
		IDFK_K = kontrah.CheckIfExists()
		if !IDFK_K then
			if kontrah.Validate() && (IntegrZK == 0) then
				if !kontrah.Insert() && kontrah.CheckIfExists() then
					dst.Value("kontrahent") = kontrah.GetExistingId(0)
				endif
			endif
		else
			dst.Value("kontrahent") = kontrah.GetExistingId(0)
		endif
	endif
	if 0 != basDK.GetField("khid") then
	endif
	if 0 != basDK.GetField("odid") then
	endif
	dst.Value("Kwota") = Round( ((-1)*(basDK.GetField("netto") + basDK.GetField("vat"))),2 )

	sTyp = basDK.GetField("typ_dk")
	if (basDK.GetField("exp_fki")&FDK_IMPORT) then
		basXT.SetKey("kod")
		basXT.SetKeySeg("typi", XTustaDOK)
		basXT.SetKeySeg("kod", basDK.GetField("typ_dk"))
		err = basXT.GetRec(GE)
		sTyp = ""
		while !err && basXT.GetField("typi") == XTustaDOK && basXT.GetField("kod") != basDK.GetField("typ_dk") && basXT.GetField("long") != basDK.GetField("subtypi")
			err = basXT.GetRec(NX)
		wend
		if basXT.GetField("typi") == XTustaDOK && basXT.GetField("kod") == basDK.GetField("typ_dk") && basXT.GetField("long") == basDK.GetField("subtypi") then
			sTyp = basDK.GetField("typ_dk")
		else
			basXT.SetKey("kod")
			basXT.SetKeySeg("typi", XTustaDOK)
			basXT.SetKeySeg("kod", TypDOK(basDK.GetField("subtypi")))
			err = basXT.GetRec(GE)
			while !err && basXT.GetField("typi") == XTustaDOK && basXT.GetField("kod") != TypDOK(basDK.GetField("subtypi")) && basXT.GetField("long") != basDK.GetField("subtypi")
				err = basXT.GetRec(NX)
			wend
			if basXT.GetField("typi") == XTustaDOK && basXT.GetField("kod") == TypDOK(basDK.GetField("subtypi")) && basXT.GetField("long") == basDK.GetField("subtypi") then
				sTyp = TypDOK(basDK.GetField("subtypi"))
			else
				error "Brak takiego rekordu w bazie DK"
			endif
		endif
	endif
	if !(basDK.GetField("exp_fki")&FDK_IMPORT) || ((basDK.GetField("exp_fki")&FDK_IMPORT) && sTyp != "") then
		basDK2.SetKey("numer")
		basDK2.SetKeySeg("typi", 101)	// KARTAdkTYP
		basDK2.SetKeySeg("kod",  sTyp)
		if basDK2.GetRec(EQ)  then error "Brak takiego rekordu w bazie DK"
	endif
	// "symbol FK" i "obsuguj jak"
	sFKDok = basDK2.GetField("khadres")
	dst.Value("skrot") = basDK2.GetField("khadres")

	// numer i data dokumentu korygowanego
	basDK2.GetRecById(basDK.GetField("iddokkoryg"))
	strTmp = basDK2.GetField("kod_obcy")
	strTmp += " ["
	strTmp += basDK2.GetField("kod")
	strTmp += "]"
	strTmp = Mid(strTmp, 1, iif(len(strTmp)>28,28,len(strTmp)))
	dst.Value("NazwaKor") = strTmp
	dst.Value("DataKor") = basDK2.GetField("datasp")

	// pozycje dokumentu
	basDP.SetKey("super")
	basDP.SetKeySeg("super", idDK)
	err = basDP.GetRec(GE)
	while !err && basDP.GetKeySeg("super") == idDK
		iStVat = basDP.GetField("stvati")
		sRej = (using "%d",basDP.GetField("rejestrVati"))
		lSuper = 10700
		iRejVat=-2000
		basXT.SetKey("super")
		basXT.SetKeySeg("super", lSuper)
		basXT.SetKeySeg("kod", "")
		basNT.SetKey("super")
		basNT.SetKeySeg("typi", 18)
		basNT.SetKeySeg("baza", 2)
		err = basXT.GetRec(GE)
		while !err && basXT.GetKeySeg("super") == lSuper					
			strTmp = Using "%l", basXT.GetField("long")							
			if sRej == strTmp then
				basNT.SetKeySeg("super", basXT.GetField("id"))
				if !basNT.GetRec(EQ) then
					buf = basNT.GetField("opis")
					move 0
					find "\$\$"					
					iRejVat = val(mid(buf,1,(move 0)-1))
					lABC = basXT.GetField("zawartosc")
				endif
				exit // wyjcie z ptli
			endif
			err = basXT.GetRec(NX)
		wend
		if NULL_VAT != basDP.GetField("stvati") then 
			TabRejVat.Wstaw(iRejVat,iStVat, basDP.GetField("wartNetto"), basDP.GetField("wartVat"), 0,lABC, 0)
		else
			TabRejVat.Wstaw(iRejVat,iStVat, 0, 0, basDP.GetField("wartNetto"),lABC, 0)
		endif
		if (iSubtyp == FWZ || iSubtyp == WKZ) then
			iStVat = basDP.GetField("stvati")
			sRej = (using "%d",basDP.GetField("grupaceni"))
			lSuper = 10500
			iRejVat=-2000
			basXT.SetKey("super")
			basXT.SetKeySeg("super", lSuper)
			basXT.SetKeySeg("kod", "")
			basNT.SetKey("super")
			basNT.SetKeySeg("typi", 18)
			basNT.SetKeySeg("baza", 2)
			err = basXT.GetRec(GE)
			while !err && basXT.GetKeySeg("super") == lSuper					
				strTmp = Using "%l", basXT.GetField("long")							
				if sRej == strTmp then
					basNT.SetKeySeg("super", basXT.GetField("id"))
					if !basNT.GetRec(EQ) then
						buf = basNT.GetField("opis")
						move 0
						find "\$\$"					
						iRejVat = val(mid(buf,1,(move 0)-1))
						lABC = basXT.GetField("zawartosc")
					endif
					exit // wyjcie z ptli
				endif
				err = basXT.GetRec(NX)
			wend
			if NULL_VAT != basDP.GetField("stvati") then 
				TabRejVat.Wstaw(iRejVat,iStVat, basDP.GetField("wartNetto"), basDP.GetField("wartVat"), 0,lABC, 1)
			else
				TabRejVat.Wstaw(iRejVat,iStVat, 0, 0, basDP.GetField("wartNetto"),lABC, 1)
			endif
		endif
		DodajDoOpisu(basDP.GetField("opis"), "/")
		err = basDP.GetRec(NX)
	wend

	//////////////////////////////////////////////////////
	// numer dokumentu w FK
	strTmp = basDK.GetField("kod_obcy")
	strTmp += " ["
	strTmp += basDK.GetField("kod")
	strTmp += "]"
	strTmp = Mid(strTmp, 1, iif(len(strTmp)>28,28,len(strTmp)))
	dst.Value("nazwa") = strTmp

	strTmp = using "%4.4d-%2.2d-%2.2d", (basDK.GetField("paragon")&0xffff0000)/65536,(basDK.GetField("paragon")&0x0000ff00)/256,(basDK.GetField("paragon")&0x000000ff)
	dst.Value("Datawpl") = strTmp
	obl.Add(BAS_ZK, idDK)

	dst.Value("tresc")	= obl.Tresc  //opis fk
			
	nLastZap = ZapiszZAP(obl, 0, 0, basDK.GetField("oki"),basDK.GetField("plattermin"))

	// rwnolege ksigowania magazynowe
	if iOpcje & ROWNOLEGLE_KSIEG_MAG then
		nCount += 1

		// dokumenty magazynowe rozliczajce dokument handlowy
		basMG.SetKey("idhandl")
		basMG.SetKeySeg("idhandl", idDK)
		err = basMG.GetRec(GE)
		while !err && basMG.GetKeySeg("idhandl") == idDK
			if !IntegrZatwWart(basMZ, basPW, basMG.GetField("id"), basMG.GetField("kod"), basDK.GetField("kod")) then	
				obl.Add(BAS_MG, basMG.GetField("id"))
				nLastZap = ZapiszZAP(obl, 1, nLastZap,0,basMG.GetField("termin"))
			endif
			err = basMG.GetRec(NX)
		wend
	endif // rwnolege ksigowania magazynowe

	// rejestry VAT
	if sFKDok != "DP" then
		RejestryVAT(idDK)
	endif
	obl.Clear()

	dst.Validate()
	if (ers.Count) then IntegrZK = ShowError(basDK.GetField("nazwa")+" "+basDK.GetField("kod"))
	if IntegrZK == 0 then dst.Insert()
	ShowStatus(basDK.GetField("kod"),idDK, IntegrZK)

EndSub

int Sub BeginProcessZK()
	int iVal

	//////////////////////////
	// otwarcie baz 
	if ( basKH.Open() ) then error "Bd otwarcia bazy KH"
	if ( basXT.Open() ) then error "Bd otwarcia bazy XT"
	if ( basTW.Open() ) then error "Bd otwarcia bazy TW"
	if ( basDK.Open() ) then error "Bd otwarcia bazy DK"
	if ( basDK2.Open() ) then error "Bd otwarcia bazy DK"
	if ( basDP.Open() ) then error "Bd otwarcia bazy DP"
	if ( basMG.Open() ) then error "Bd otwarcia bazy MG"
	if ( basMZ.Open() ) then error "Bd otwarcia bazy MZ"
	if ( basPW.Open() ) then error "Bd otwarcia bazy PW"
	if ( basNT.Open() ) then error "Bd otwarcia bazy NT"

	TabRejVat.ClearRec()
EndSub

int Sub DoProcessZK(long idDK)
	DoProcessZK = 0

	int iVal, err
	int iOpcje = 0

	if basDK.GetRecById(idDK) then error "Brak takiego rekordu w bazie DK"

	if ( iNieIntegrOznak && (basDK.GetField("exp_fki") & 0x1) ) then
		DoProcessZK = 1 // pomijamy
			AddError("Nie mona powtrnie wysa dokumentu " + basDK.GetField("kod") + ".",idDK)
		Exit // nie wysylamy oznakowanych dokumentw
	endif

	// czy rwnolege ksigowanie magazynowe
	if ( iRownoKsiegMag ) then iOpcje |= ROWNOLEGLE_KSIEG_MAG

	TabRejVat.ClearRec()
	DoProcessZK = IntegrZK(idDK, iOpcje)
	if	DoProcessZK then Exit	 // pomijamy

	/////////////////////////////////////////////////
	// oznaczamy wyslany dokument
	if ( iOznaczaj ) then
		iVal = basDK.GetField("exp_fki")
		iVal |= 0x1
		basDK.SetField("exp_fki", iVal)
		basDK.Update()

		// dokumenty magazynowe rozliczajce dokument handlowy
		if ( iRownoKsiegMag ) then
			basMG.SetKey("idhandl")
			basMG.SetKeySeg("idhandl", idDK)
			err = basMG.GetRec(GE)
			while !err && basMG.GetKeySeg("idhandl") == idDK
				iVal = basMG.GetField("exp_fki")
				iVal |= 0x1
				basMG.SetField("exp_fki", iVal)
				basMG.Update()
				err = basMG.GetRec(NX)
			wend
		endif
	endif
EndSub

int Sub EndProcessZK()
	basKH.close()
	basXT.close()
	basTW.close()
	basDK.close()
	basDK2.close()
	basDP.close()
	basMG.close()
	basMZ.close()
	basPW.close()
	basNT.close()
EndSub