//"archfir2.sc","Przeniesienie do archiwum cz.2",12001,0,1.0.1,SYSTEM
//"System",2400,14,62
////////////////////////////
// Przeniesienie do archiwum cz.2
// archfir2.sc
///////////////////////////

#define DALEJ		2
#define WROC		3
#define WYKONAJ	4
#define ANULUJ -1

String g_sNazwaFirmy

#ifdef HMHL
BaseAll srcOMG
if srcOMG.SetBase("MG") then error "Nie mona otworzy bazy src. MG"
srcOMG.Open()

BaseAll srcOMZ
if srcOMZ.SetBase("MZ") then error "Nie mona otworzy bazy src. MZ"
srcOMZ.Open()
#endif

BaseAll srcZZ1
if srcZZ1.SetBase("ZZ") then error "Nie mona otworzy bazy src. ZZ"
srcZZ1.Open()

BaseAll srcODK
if srcODK.SetBase("DK") then error "Nie mona otworzy bazy src. DK"
srcODK.Open()

BaseAll srcOPN
if srcOPN.SetBase("PN") then error "Nie mona otworzy bazy src. PN"
srcOPN.Open()

BaseAll srcODP
if srcODP.SetBase("DP") then error "Nie mona otworzy bazy src. DP"
srcODP.Open()

long DkPrzenDoArch(1)

long g_ilDokPn, g_ilDokDk, g_ilDokMg
int srcDK0, srcDK, srcDK1, dstDK, srcIDK, dstIDK

int srcDP, dstDP, srcIDP, dstIDP
int srcPN0, srcPN, srcPN1, dstPN, dstPN1, srcIPN, srcIPN1, dstIPN, dstIPN1
int srcRL, dstRL
int srcMG, srcMG1, dstMG, srcIMG, dstIMG
int srcMZ, dstMZ, srcIMZ, dstIMZ
int srcBD, dstBD
int srcBP, dstBP
int srcPW, dstPW, srcPW1, dstPW1
int srcDW, dstDW
int srcXT, dstXT
int srcTW, dstTW
int srcKH, dstKH
int dstSM
int srcZZ, dstZZ
int srcRV, dstRV
int srcIT, dstIT

Record SeriaT
	string seria[5+1]
	int dzial
	int okres
	long serianr
	string kod[25+1]
	long id
EndRec

SeriaT g_serieDK(1)
MapValue InfoSeriaDK
InfoSeriaDK.clear()
InfoSeriaDK.Type(int)
SeriaT g_serieMG(1)
MapValue InfoSeriaMG
InfoSeriaMG.clear()
InfoSeriaMG.Type(int)
SeriaT g_seriePN(1)
MapValue InfoSeriaPN
InfoSeriaPN.clear()
InfoSeriaPN.Type(int)

Record Rc2
	long id
	long wartosc
	long wartosc2
	float fWartosc3
EndRec

//---
//string NAZWA_PLIKU = "temp.txt"
string sRaportDescription
str.wydruk(0,-1,0)
strona 50,100,50,100

int iVer, err
string sDialogTitle
record ProgressCounter
	long all,curr,last,new
	int sub Reset( long a )
		if !a then a=1
		all=a : curr = last = 0
		WriteStatusBar("")
	endsub
	int sub NextOne()
		curr+=1 : new = (curr*100)/all
		if new>last then last = new
		if last>100 then last = 100 : curr=all
		WriteStatusBar(using "=%d%%%%",last)
	endsub
endrec

ProgressCounter progress

sDialogTitle = "Kontynuacja firmy od daty"
//sRepaired =""

string sDataOd = Data()
string sNewDir, sNewName, sTemp

long lTemp
int pom
int bsrc, bdst
//int Stany, NrDostaw, bRozrach, bStany, bNrDostaw
int xt,kh
int pn,sm,dw,tw

iVer=Val(Mid(firma.Ver,1,1))
if ((firma.code != "HM") && (firma.code != "FP")) then error "Raport przeznaczony jest dla programw Handel premium oraz Faktura premium"

//---

int sub OpenBase( string bas )
	OpenBase = open KatalogFirmy() + "51" + bas + ".dat" for base bas
	BaseError(OpenBase,4)
endsub

int sub OpenBaseI( string bas )
	OpenBaseI = open KatalogFirmy() + "5" + bas + ".dat" for base bas
	BaseError(OpenBaseI,4)
endsub

int sub OpenNewBase( string b )
	OpenNewBase=open sNewDir+"51"+b+".dat" for base b
	baseerror(OpenNewBase,4)
endsub

int sub OpenNewBaseI( string b )
	OpenNewBaseI=open sNewDir+"5"+b+".dat" for base b
	baseerror(OpenNewBaseI,4)
endsub

//---

string sub CreateNewDir( long num )
	buf=KatalogFirmy()
	if Mid(buf,len(buf))=="\\" then buf=Mid(buf,1,Len(buf)-1)
	sTemp="Nowa"
	if (find regular "{[~\\]+}$") && (regular 1) then sTemp=regular 1
	buf = using "%l",num
	if Len(buf)+len(sTemp)>8 then
		CreateNewDir = Mid(sTemp,1,8-Len(buf))+buf
	else
		CreateNewDir = sTemp+buf
	endif
endsub

//---

int sub CreateMirrorBase(string baza)
	PopUp( 1, "Tworzenie bazy "+baza )
	if (create sNewDir+"5"+baza+".dat" for base baza) then error(using "Bd tworzenia bazy %s w katalogu %s",baza,sNewDir)
endsub


int sub CreateBase(string baza)
	PopUp( 1, "Tworzenie bazy "+baza )
	if (create sNewDir+"51"+baza+".dat" for base baza) then error(using "Bd tworzenia bazy %s w katalogu %s",baza,sNewDir)
endsub

//---

int sub CopyFile(string src, stRing dst)
	PopUp( 1, "Kopiowanie pliku "+src )
	bdst = open dst for binary output
	if bdst<=0 then error "bd otwierania pliku "+dst+" do zapisu"
		if !(append src to bdst) then error "Bad kopiowania pliku "+src
	close(bdst)
endsub

//---

int sub CopyBase(string base)
	int err
	if len(base)==2 then
		CreateBase(base)
		buf="51"+base+".dat"
	else
		CreateMirrorBase(base)
		buf="5"+base+".dat"
	endif
	PopUp( 1, "Kopiowanie bazy "+base )
	bsrc = open KatalogFirmy()+buf for base base
	BaseError(bsrc,4)
	bdst = open sNewDir+buf for base base
	BaseError(bdst,4)
	SetKey(bsrc,"id")
	progress.Reset(GetRecordCount(bsrc))
	err=GetRec(bsrc,FS)
	while !err
		progress.NextOne()

		// czy zapisywa
		select case base
			case "NT"
				pom = GetField(bsrc,"baza")
				if pom == 0x14 || pom == 0x16 then err=1
			case "TW","KH"
				If GetField(bsrc, "kod") != "Rekord blokujcy id" Then err=1
			case "UZ","WL","XT"
				err=1
			case "ZZ"
				err=1
				pom = GetField(bsrc,"typi")
				if pom==0x50 || pom==0x60 || pom==0x62 || pom==0x70 then err=0
				if (pom>=0x80 && pom<=0x90) || pom==0xa0 then err=0
			case "PN"
			case "iPN"
			case "RL"
				SetKeySeg(pn,"id",GetField(bsrc,"id1"))
				if !GetKey(pn,EQ) then
					CopyFields(bsrc,bdst)
					SetField(bdst,"id2",0)
					err=1
				else
					SetKeySeg(pn,"id",GetField(bsrc,"id2"))
					if !GetKey(pn,EQ) then
						CopyFields(bsrc,bdst)
						SetField(bdst,"id1",0)
						err=1
					endif
				endif
				if err && InsRec(bdst) then error "bd wstawiania rekordu do nowej bazy "+base
				err=0
			case "SM"
				if !GetField(bsrc,"magazyn") then
					CopyFields(bsrc,bdst)
					SetField(bdst,"stan",0)
					SetField(bdst,"stanHandl",0)
					SetField(bdst,"wartosc",0)
					if InsRec(bdst) then error "bd wstawiania rekordu do nowej bazy "+base
				endif
				err=0
		endselect

		if err then
			CopyFields(bsrc,bdst)
			if InsRec(bdst) then error "bd wstawiania rekordu do nowej bazy "+base
		endif
		err=GetRec(bsrc,NX)
	wend
	
	close(bsrc)
	close(bdst)
	WriteStatusBar("")
endsub

//---

int sub CopyFiles(string ext)
	buf=find file KatalogFirmy()+"*."+ext
	while buf
		sTemp=buf
		if (find regular "^*{[~\\]+}$") && ( regular 1) then CopyFile(buf,sNewDir+(regular 1))
		buf = find next file
	wend
endsub

//---

int sub ZeroNumOfAllDocs( long id )
	SetKeySeg(xt,"id",id)
	if !GetRec(xt,EQ) then
		SetField(xt,"zawartosc",0)
		PutRec(xt)
	endif
#ifndef LITE
	SetKeySeg(xt,"id",id+99)
	if !GetRec(xt,EQ) then
		SetField(xt,"zawartosc",0)
		PutRec(xt)
	endif
#endif
endsub

//---

int sub ZeroNode(int xtb)
	int err
	SetField(xtb,"zawartosc",0)
	PutRec(xtb)
	int xtn=OpenNewBase("XT")
	SetKey(xtn,"super")
	SetKeySeg(xtn,"super",GetField(xtb,"id"))
	SetKeySeg(xtn,"kod","")
	err=GetRec(xtn,GE)
	while !err && GetField(xtn,"super")==GetField(xtb,"id")
		ZeroNode( xtn )
		err=GetRec(xtn,NX)
	wend
	close(xtn)
endsub

//---

int sub ZeroKinds(long root)
	// rodzaje
	SetKeySeg(xt,"id",root)
	if !GetRec(xt,EQ) then
		SetField(xt,"zawartosc",0)
		PutRec(xt)
		SetKey(xt,"super")
		SetKeySeg(xt,"super",root)
		SetKeySeg(xt,"kod","")
		err=GetRec(xt,GE)
		while !err && GetField(xt,"super")==root
			SetField(xt,"zawartosc",0)
			PutRec(xt)
			err=GetRec(xt,NX)
		wend
		SetKey(xt,"id")
	endif

	// katalogi
	SetKeySeg(xt,"id",root-1000)
	if !GetRec(xt,EQ) then ZeroNode(xt)
endsub

//---

int sub RecountDocuments()
	xt=OpenNewBase("XT")
	kh=OpenNewBase("KH")
	SetKey(xt,"id")
	ZeroNumOfAllDocs(4300)
	ZeroKinds(3300)
#ifdef HMHL
	ZeroNumOfAllDocs(4500)
	ZeroNumOfAllDocs(4600)
	ZeroKinds(3500)
	ZeroKinds(3600)
#endif

	// iloci dokumentw w rejestrach pieninych
	pn=OpenNewBase("PN")
	SetKey(pn,"rejestr")
	SetKey(xt,"super")
	SetKeySeg(xt,"super",3400)
	SetKeySeg(xt,"kod","")
	SetKey(kh,"id")
	err=GetRec(xt,GE)
	while !err && GetField(xt,"super")==3400
			SetKeySeg(pn,"rejestr",GetField(xt,"id"))
			SetKeySeg(pn,"termin","")
			SetKeySeg(pn,"id",0)
			SetKeySeg(pn,"typi",0)
			lTemp=0
			err=GetKey(pn,GE)
			while !err && GetKeySeg(pn,"rejestr")==GetField(xt,"id")
				lTemp+=1
				err=GetKey(pn,NX)
			wend
			SetField(xt,"zawartosc",lTemp)
		PutRec(xt)
		err=GetRec(xt,NX)
	wend
	close(pn)

	close(xt)
	close(kh)
endsub

//---

string sub Normalize( float f)
	Normalize = using "%.6f",Round(f,6)
endsub

//---

#ifdef HMHL
Int Sub AktualizujStanyMagazynowe(int SM, int DW, int TW)
	int errM, i
	long idtw
	float old ,stan ,stanHandl,wartosc

	MapValue mIloscHandlowa
	MapValue mRezIlosciowe
	MapValue mRezWszystkie
	MapValue mWartosc

	mIloscHandlowa.Type(float)
	mRezIlosciowe.Type(float)
	mRezWszystkie.Type(float)
	mWartosc.Type(float)

	PopUp(1, "Aktualizacja stanw magazynowych.")

	SetKey (TW, "id")
	SetKey (SM, "towar")

	// po kolejnych towarach
	SetKey(DW, "towar")
	errM=GetRec(DW, FS)
	While !errM && GetField(DW, "idtw") < 0
		errM=GetRec(DW, NX)
	Wend
	if !errM then idtw = GetField(DW, "idtw")

	while !errM
		mIloscHandlowa.Clear()
		mRezIlosciowe.Clear()
		mRezWszystkie.Clear()
		mWartosc.Clear()

		do		// kolejne rekordy dostaw dla tego samego towaru
			If GetField(DW, "magazyn") Then
				buf=using "%d",GetField(dw,"magazyn")
				If GetField(DW,"numer") < 0 Then
					old=mRezIlosciowe.Get(buf,0)
					mRezIlosciowe.Set(buf,old+GetField(dw,"iloscdosp"))
					mIloscHandlowa.Set(buf,mIloscHandlowa.Get(buf,0))
					mWartosc.Set(buf,mWartosc.Get(buf,0))
				Else
					old=mIloscHandlowa.Get(buf,0)
					mIloscHandlowa.Set(buf,old+GetField(dw,"iloscdosp"))
					old = mWartosc.Get(buf,0)
					mWartosc.Set(buf,old+GetField(dw,"wartoscdosp"))
					mRezIlosciowe.Set(buf,mRezIlosciowe.Get(buf,0))
				EndIf
				mRezWszystkie.Set(buf,mRezWszystkie.Get(buf,0))
			EndIf

			errM=GetRec(dw,NX)
			while !errM && GetField(dw,"idtw")<0
				errM=GetRec(dw,NX)
			wend
		loop while !errM && GetField(dw,"idtw")==idtw

		// sprawdzenie czy w SM s takie wartoci
		SetKeySeg(TW, "id",idtw)
		GetRec(TW, EQ)
		for i=1 to i>mIloscHandlowa.Size()
			SetKeySeg(SM, "idtw", idtw)
			SetKeySeg(SM, "magazyn", Val(mIloscHandlowa.GetKey(i)))
			if GetRec(SM, EQ) then
				buf = mIloscHandlowa.GetKey(i)
				stan = mIloscHandlowa.Get(buf)+mRezIlosciowe.Get(buf)+mRezWszystkie.Get(buf)
				if Sign(stan) || GetField(tw,"typi")!=100 then
					Clear(sm)
					buf=mIloscHandlowa.GetKey(i)
					SetField(sm,"kod",GetField(tw,"kod"))
					SetField(sm,"nazwa",GetField(tw,"nazwa"))
					SetField(sm,"stan",stan)
					SetField(sm,"stanHandl",mIloscHandlowa.Get(buf)+mRezIlosciowe.Get(buf))
					SetField(sm,"idtw",idtw)
					SetField(sm,"magazyn",Val(buf))
					SetField(sm,"wartosc",mWartosc.Get(buf))
					SetField(sm,"subtypi",GetField(tw,"subtypi"))
					InsertRec(sm,"SM")
				endif
			else
				// czy wartoci si zgadzaj
				if GetField(tw,"subtypi")==0 then
					buf = mIloscHandlowa.GetKey(i)
					if Sign(GetField(sm,"stan")-mIloscHandlowa.Get(buf)-mRezIlosciowe.Get(buf)-mRezWszystkie.Get(buf)) || Sign(GetField(sm,"stanHandl")-mIloscHandlowa.Get(buf)-mRezIlosciowe.Get(buf)) || Sign( GetField(sm,"wartosc")-mWartosc.Get(buf)) then
						buf=mIloscHandlowa.GetKey(i)
						SetField(sm,"stan",mIloscHandlowa.Get(buf)+mRezIlosciowe.Get(buf)+mRezWszystkie.Get(buf))
						SetField(sm,"stanHandl",mIloscHandlowa.Get(buf)+mRezIlosciowe.Get(buf))
						SetField(sm,"wartosc",mWartosc.Get(buf))
						UpdateRec(sm,"SM")
					endif
				else
					// usuga lub zestaw do ktrego jest rezerwacja (istnieje rekord DW 'rezerwacja ilociowa')
					if Sign(GetField(sm,"stan")) || Sign(GetField(sm,"stanHandl")-1) || Sign(GetField(sm,"wartosc")) then
						SetField(sm,"stan",0)
						SetField(sm,"stanHandl",1)
						SetField(sm,"wartosc",0)
						UpdateRec(sm,"SM")
					endif
				endif
			endif
		next i

		// sprawdzenie stanu rekordw sumujcych po magazynach
		stan = stanHandl = wartosc = 0
		for i=1 to i>mIloscHandlowa.Size()
			buf = mIloscHandlowa.GetKey(i)
			stan += mIloscHandlowa.Get(buf)+mRezIlosciowe.Get(buf)+mRezWszystkie.Get(buf)
			stanHandl += mIloscHandlowa.Get(buf)+mRezIlosciowe.Get(buf)
			wartosc += mWartosc.Get(buf)
		next i

		SetKeySeg(sm,"idtw",idtw)
		SetKeySeg(sm,"magazyn",0)
		if GetRec(sm,EQ) then
			if GetField(tw,"typi")!=100 then
				Clear(sm)
				SetField(sm,"subtypi",GetField(tw,"subtypi"))
				SetField(sm,"kod",GetField(tw,"kod"))
				SetField(sm,"nazwa",GetField(tw,"nazwa"))
				SetField(sm,"idtw",GetField(tw,"id"))
				SetField(sm,"stan",stan)
				SetField(sm,"stanHandl",stanHandl)
				SetField(sm,"wartosc",wartosc)
				InsertRec(sm,"SM")
			endif
		else
			// porwnujemy wartosci
			if GetField(tw,"subtypi")==0 then
				if Sign(GetField(sm,"stan")-stan) || Sign(GetField(sm,"stanHandl")-stanHandl) || Sign(GetField(sm,"wartosc")-wartosc) then
					SetField(sm,"stan",stan)
					SetField(sm,"stanHandl",stanHandl)
					SetField(sm,"wartosc",wartosc)
					UpdateRec(sm,"SM")
				endif
			else
				// usuga lub zestaw
				if Sign(GetField(sm,"stan")) || Sign(GetField(sm,"stanHandl")-1) || Sign(GetField(sm,"wartosc")) then
					SetField(sm,"stan",0)
					SetField(sm,"stanHandl",1)
					SetField(sm,"wartosc",0)
					UpdateRec(sm,"SM")
				endif
			endif		
		endif

		idtw=GetField(dw,"idtw")
	Wend

	PopUp(1,"")
EndSub
#endif

//-------------------------------------
// DK, MG, DP, MZ, PW, DW, PN, RL, NT, ZZ ||| TW, KH, XT
Int Sub DodajOstatnieRekordy()
	long lId
	long iddk, idmg, iddw, idmz, iddp, idpn
	int err, nr

	PopUp(1, "Dodawanie rekordw podziau bazy.")

	//--------
	// rekord DK
	srcODK.SetKey("numer") : srcODK.SetKeySeg("typi", 102)
	err = srcODK.GetRec(GE)
	While !err && srcODK.GetKeySeg("typi") == 102
		If Mid(srcODK.GetField("nazwa"),1,12) == "Podzia bazy" Then nr = srcODK.GetField("serianr")
		err = srcODK.GetRec(NX)
	Wend
	nr += 1
	srcODK.SetKey("id")
	srcODK.GetRec(LS)
	iddk = srcODK.GetField("id") + 1
	srcODK.Clear()
	srcODK.SetField ("id", iddk)
	srcODK.SetField ("typi", 102)
	srcODK.SetField ("subtypi", 2)
	srcODK.SetField ("nazwa", "Podzia bazy nr. " + (using "%d", nr))
	srcODK.SetField ("kod", "Podzia bazy nr. " + (using "%d", nr))
	srcODK.SetField ("opis", "operacja: " +Data()+ ", przecicie: " +sDataOd)
	srcODK.SetField ("serianr", nr)
	srcODK.SetField ("seria", "id")
	srcODK.SetField ("datasp", sDataOd)
	srcODK.Insert ()

	#ifdef HMHL
	//--------
	// rekord MG
	srcOMG.SetKey("id")
	srcOMG.GetRec(LS)
	idmg = srcOMG.GetField("id") + 1
	srcOMG.Clear()
	srcOMG.SetField ("id", idmg)
	srcOMG.SetField ("typi", 102)
	srcOMG.SetField ("subtypi", 2)
	srcOMG.SetField ("nazwa", "Podzia bazy nr. " + (using "%d", nr))
	srcOMG.SetField ("kod", "Podzia bazy nr. " + (using "%d", nr))
	srcOMG.SetField ("serianr", nr)
	srcOMG.SetField ("seria", "id")
	srcOMG.SetField ("opis", "operacja: " +Data()+ ", przecicie: " +sDataOd)
	srcOMG.SetField ("idhandl", iddk)
	srcOMG.Insert()
	#endif
	
	//-----------------
	// rekord DP
	srcODP.Clear()
	srcODP.SetField("kod", "Podzia bazy nr. " + (using "%d", nr))
	srcODP.SetField("opis", "o.: " +Data()+ ", p.: " +sDataOd)
	srcODP.SetField("typi", 1)
	srcODP.SetField("subtypi", 102)
	srcODP.SetField("super", iddk)
	srcODP.Insert()
	srcODP.SetKey("id") : srcODP.GetRec(LS) : iddp = srcODP.GetField("id")

#ifdef HMHL
	//---
	// rekord MZ
	srcOMZ.Clear()
	srcOMZ.SetField ("kod", "Podzia bazy nr. " + (using "%d", nr))
	srcOMZ.SetField ("opis", "o.: " +Data()+ ", p.: " +sDataOd)
	srcOMZ.SetField("typi", 1)
	srcOMZ.SetField("subtypi", 102)
	srcOMZ.SetField("super", idmg)
	srcOMZ.SetField("idhandl", iddp)
	srcOMZ.Insert()
	srcOMZ.SetKey("id") : srcOMZ.GetRec(LS) : idmz = srcOMZ.GetField("id")

	//---
	// rekord DW
	Clear(srcDW)
	SetField( srcDW, "kod", "Podzia bazy nr. " + (using "%d", nr))
	SetField( srcDW, "subtypi", 2)
	SetField( srcDW, "iddkpz", idmg)
	SetField( srcDW, "iddkzk", iddk )
	SetField( srcDW, "numer", nr)
	InsertRec(srcDW, "DW")
	SetKey(srcDW, "id") : GetRec(srcDW, LS) : iddw = GetField(srcDW, "id")

	//---
	// rekord PW
	Clear(srcPW)
	SetField( srcPW, "typi", 37)
	SetField( srcPW, "subtypi", 2)
	SetField( srcPW, "iddkmg", idmg)
	SetField( srcPW, "idmg", idmz)
	SetField( srcPW, "iddw", iddw)
	InsertRec(srcPW, "PW")
#endif

	//---
	// rekord PN
	srcOPN.SetKey("id") : srcOPN.GetRec(LS)
	idpn = srcOPN.GetField("id") + 1
	srcOPN.Clear()
	srcOPN.SetField ("id", idpn)
	srcOPN.SetField ("dkid", iddk)
	srcOPN.SetField ("kod", "Podzia bazy nr. " + (using "%d", nr))
	srcOPN.SetField ("opis", "o.: " +Data()+ ", p.: " +sDataOd)
	srcOPN.SetField ("typi", 1)
	srcOPN.SetField ("subtypi", 2)
	srcOPN.SetField ("serianr", nr)
	srcOPN.SetField ("seria", "id")
	srcOPN.Insert ()

	//---
	// rekord RL
	Clear(srcRL)
	SetField( srcRL, "kod1", "Podzia bazy nr. " + (using "%d", nr))
	SetField( srcRL, "kod2", "Podzia bazy nr. " + (using "%d", nr))
	SetField( srcRL, "typi", 102)
	SetField( srcRL, "id1", idpn)
	SetField( srcRL, "id2", idpn)
	InsertRec(srcRL, "RL")

	//---
	// rekord NT
	Clear(srcNT)
	SetField( srcNT, "typi", 102)
	SetField( srcNT, "baza", 16)
	SetField( srcNT, "super", iddk)
	SetField( srcNT, "opis", "Podzia bazy nr. "+ (using "%d", nr) +", "+ "operacja: " +Data()+ ", przecicie: " +sDataOd)
	InsertRec(srcNT, "NT")

	//---
	// rekord ZZ
	DodajBlokujacyRekordZZ(dstZZ, srcZZ)
	
	//--
	// rekordy TW, KH, XT

	// TW
	SetKey(srcTW, "kod") : SetKeySeg(srcTW, "typi", 101) : SetKeySeg(srcTW, "kod", "Rekord blokujcy id")
	If !GetRec(srcTW, EQ) Then UsunRekord(srcTW, -1, "srcTW")
	Clear(srcTW)
	SetField(srcTW, "typi", 101)
	SetField(srcTW, "kod", "Rekord blokujcy id")
	SetField(srcTW, "vatspi", 2)
	InsertRec(srcTW, "srcTW")

	// KH
	int srcKH = OpenBase("KH")
	SetKey(srcKH, "kod") : SetKeySeg(srcKH, "typi", 111) : SetKeySeg(srcKH, "kod", "Rekord blokujcy id")
	If !GetRec(srcKH, EQ) Then UsunRekord(srcKH, -1, "srcKH")
	Clear(srcKH)
	SetField(srcKH, "typi", 111)
	SetField(srcKH, "kod", "Rekord blokujcy id")
	InsertRec(srcKH, "srcKH")
	Close(srcKH)

	// XT
	SetKey(dstXT, "super") : SetKeySeg(dstXT, "super", 8000) : SetKeySeg(dstXT, "kod", "Rekord blokujcy id")
	If !GetRec(dstXT, EQ) Then UsunRekord(dstXT, -1, "dstXT")
	SetKey(srcXT, "super") : SetKeySeg(srcXT, "super", 8000) : SetKeySeg(srcXT, "kod", "Rekord blokujcy id")
	If !GetRec(srcXT, EQ) Then UsunRekord(srcXT, -1, "srcXT")
	Clear(srcXT)
	SetField(srcXT, "super", 8000)
	SetField(srcXT, "subtypi", 47)
	SetField(srcXT, "kod", "Rekord blokujcy id")
	InsertRec(srcXT, "srcXT")

	PopUp(1, "")
EndSub

//----

int sub OdtworzRekMGZZ(int typ, int nFlag)
	Clear(dstZZ)
	SetField(dstZZ, "typi",typ)
	SetField(dstZZ, "flag",nFlag)
	SetField(dstZZ, "baza1",33)
	SetField(dstZZ, "id1",	GetField(dstMG, "id"))
	SetField(dstZZ, "baza2",20)
	SetField(dstZZ, "id2",	GetField(dstMG, "magazyn")*0x1000000 + GetField(dstMG, "khid"))
	SetField(dstZZ, "kod1",	GetField(dstMG, "kod"))
	SetField(dstZZ, "kod2",	GetField(dstMG, "khkod"))
	SetField(dstZZ, "data",	GetField(dstMG, "data"))
	SetField(dstZZ, "termin",	GetField(dstMG, "termin"))
	SetField(dstZZ, "cena",	GetField(dstMG, "netto"))
	SetField(dstZZ, "opis",	GetField(dstMG, "nazwa"))
	SetField(dstZZ, "magazyn",	GetField(dstMG, "magazyn"))
	InsertRec(dstZZ, "dstZZ")
endsub

//---

int Sub OdtworzRekDKZZ(int typ, int baza, int flag)
	Clear(dstZZ)
	SetField(dstZZ, "typi", typ)
	SetField(dstZZ, "flag", flag)
	SetField(dstZZ, "baza1", baza)
	SetField(dstZZ, "id1", GetField(dstDK, "id"))
	SetField(dstZZ, "baza2",20)
	SetField(dstZZ, "id2", GetField(dstDK, "magazyn")*0x1000000+ GetField(dstDK, "khid"))
	SetField(dstZZ, "kod1", GetField(dstDK, "kod"))
	SetField(dstZZ, "kod2", GetField(dstDK, "khkod"))
	SetField(dstZZ, "data", GetField(dstDK, "data"))
	SetField(dstZZ, "termin", GetField(dstDK, "data"))
	SetField(dstZZ, "cena", GetField(dstDK, "netto")+ GetField(dstDK, "vat"))
	SetField(dstZZ, "opis", GetField(dstDK, "nazwa"))
#ifdef HMHL
	SetField(dstZZ, "magazyn", GetField(dstDK, "magazyn"))
#endif
	InsertRec(dstZZ, "dstZZ")
EndSub

//---

Int Sub OdtwarzanieRekordowZZwArch()
	int err, err1, i = 1
	int iTemp, iTemp2, iFlag

	PopUp(1,"Odtwarzanie rekordw zwizkw.")

	SetKey(dstDK, "id") : SetKeySeg(dstDK, "id", 0)
	err=GetRec(dstDK, GT)
	While !err
		iTemp = GetField(dstDK, "typi")

		If iTemp==0 || iTemp==202 || iTemp==100 || iTemp==112 Then

		If GetField(dstDK, "subtypi") && GetField(dstDK, "oki")!=1 Then

			Clear(dstZZ)
			If GetField(dstDK, "typi") == 202 Then		// dokument zakupu
				SetField(dstZZ, "typi", 141) : SetField(dstZZ, "baza1", 0x22)
			Else																		// dokument sprzeday
				SetField(dstZZ, "typi", 140) : SetField(dstZZ, "baza1", 0x10)
			EndIf

			SetField(dstZZ, "id1",	GetField(dstDK, "id"))
			SetField(dstZZ, "baza2", 20)
			SetField(dstZZ, "kod1",	GetField(dstDK, "kod"))
			SetField(dstZZ, "id2",	GetField(dstDK, "khid"))
			SetField(dstZZ, "kod2",	GetField(dstDK, "khkod"))
			SetField(dstZZ, "opis",	GetField(dstDK, "nazwa"))
			SetField(dstZZ, "cena",	GetField(dstDK, "netto") + GetField(dstDK, "vat"))
			SetField(dstZZ, "data",	GetField(dstDK, "data"))
			SetField(dstZZ, "termin",	GetField(dstDK, "plattermin"))

			SetKey(dstPN, "dkid") : SetKeySeg(dstPN, "dkid", GetField(dstDK, "id"))
			err1 = GetRec(dstPN, EQ)
			#ifdef HMHL
			if !err1 then SetField(dstZZ, "ilosc2", GetField(dstPN, "kwota"))
			#endif
			InsertRec(dstZZ, "dstZZ")
		EndIf

#ifdef HMHL

		If GetField(dstDK, "typi") == 0 && GetField(dstDK, "subtypi") != 0 Then
			iFlag = 0 : iTemp2 = 1
			if ((firma.code == "HM") || (firma.code == "HL")) then
				If GetField(dstDK, "rozlmgi") == 0 Then
					iTemp2=0
				Else
					If GetField(dstDK, "iddokkoryg") != 0 Then iFlag = 1
				Endif
			Else
				If GetField(dstDK, "subtypi") == 49 Then
					iTemp2 = !GetField(dstDK, "iddokkoryg")
				EndIf
			Endif
			If iTemp2 then OdtworzRekDKZZ(0x83,0x10,iFlag)
		endif

		if GetField(dstDK, "typi")==202 && GetField(dstDK, "subtypi") != 0 then
			iFlag = 0 : iTemp2=1
			If GetField(dstDK, "rozlmgi")==0 Then
				iTemp2=0
			Else
				If GetField(dstDK, "iddokkoryg") != 0 Then iFlag = 1
			endif

			If iTemp2 then OdtworzRekDKZZ(0x84, 0x22, iFlag)
		endif
#endif

		EndIf
		err=GetRec(dstDK, NX)
	Wend

#ifdef HMHL

	//----------------------
	// dokumenty magazynowe
	int nFlag

	SetKey(dstMG, "id")
	err = GetRec(dstMG, FS)

	while !err
		nFlag = 0
		If GetField(dstMG, "typi")==201 Then
			err=1
			buf = using "%d",GetField(dstMG, "subtypi")

			If GetField(dstMG, "oki") != 0 Then err = 0
			If err Then
				nFlag = GetField(dstMG, "iddokkoryg") != 0 
				If !nFlag then
					If GetField(dstMG, "idhandl") > 0 then
						nFlag = 1
					Else
						If GetField(dstMG, "idhandl") < 0 Then
							If GetField(dstMG, "flag") & 0x0400 Then nFlag = 1
						Endif
					Endif
				Endif
			Endif

			If err then
				Select case GetField(dstMG, "subtypi")
					case 78,88	//WZ,WZK	- wydania zewntrznego
						OdtworzRekMGZZ(0x85, nFlag)	
					case 89,81 //PZ,PZK		-	przyjcia zewntrznego
						OdtworzRekMGZZ(0x86, nFlag)
					case 76,84,77,85 // RW	-	rozchodu wewntrznego
						OdtworzRekMGZZ(0x87, nFlag)
					case 74,82,81,83,90,91	// PW,MM+,PWK,MPK,KWM,PWM	-	przychodu wewntrznego
						OdtworzRekMGZZ(0x88, nFlag)
				EndSelect
			Endif
		Endif
		err = GetRec(dstMG, NX)
	wend
#endif

	PopUp(1,"")
	PopUp(2,"")
EndSub

//---

Int Sub ZnajdzRekordySerii(string tab, string seria, int dzial, int okres, long serianr, string kod, long id)
	int i, rok, miesiac, nowy
	rok = Val(Mid(Data(),1,4))
	miesiac = Val(Mid(Data(),6,2))

	If seria == "" Then Exit
	If okres != 32200 Then															// numeracja ciga
		If (okres-30000)!= rok Then												// numeracja roczna
			If (okres-30000-(rok-1996)*12) != miesiac Then	// numeracja miesiczna
				Exit
			EndIf
		EndIf
	EndIf

 Select Case tab
	case "DK" 
			if i=InfoSeriaDK.Index(using "%s_%d_%d",seria,dzial,okres) then
		
				If g_serieDK(i).serianr < serianr Then
					g_serieDK(i).serianr = serianr
					g_serieDK(i).kod = kod
					g_serieDK(i).id = id
				EndIf
			else
			i=InfoSeriaDK.size()
			InfoSeriaDK.Set((using "%s_%d_%d",seria,dzial,okres),1)
			g_serieDK(i).seria = seria
			g_serieDK(i).dzial = dzial
			g_serieDK(i).okres = okres
			g_serieDK(i).serianr = serianr
			g_serieDK(i).kod = kod
			g_serieDK(i).id = id
			grow g_serieDK, 1
			EndIf
		
	case "MG"
			if i=InfoSeriaMG.Index(using "%s_%d_%d",seria,dzial,okres) then	
				If g_serieMG(i).serianr < serianr Then
					g_serieMG(i).serianr = serianr
					g_serieMG(i).kod = kod
					g_serieMG(i).id = id
				EndIf
			else
			i=InfoSeriaMG.size()
			InfoSeriaMG.Set((using "%s_%d_%d",seria,dzial,okres),1)
			g_serieMG(i).seria = seria
			g_serieMG(i).dzial = dzial
			g_serieMG(i).okres = okres
			g_serieMG(i).serianr = serianr
			g_serieMG(i).kod = kod
			g_serieMG(i).id = id
			grow g_serieMG, 1
			EndIf
	case "PN" 
			if i=InfoSeriaPN.Index(using "%s_%d_%d",seria,dzial,okres) then	
				If g_seriePN(i).serianr < serianr Then
					g_seriePN(i).serianr = serianr
					g_seriePN(i).kod = kod
					g_seriePN(i).id = id
				EndIf
			else
			i=InfoSeriaPN.size()			
			InfoSeriaPN.Set((using "%s_%d_%d",seria,dzial,okres),1)
			g_seriePN(i).seria = seria
			g_seriePN(i).dzial = dzial
			g_seriePN(i).okres = okres
			g_seriePN(i).serianr = serianr
			g_seriePN(i).kod = kod
			g_seriePN(i).id = id
			grow g_seriePN, 1
			EndIf
		
	endselect		
EndSub

//---

Int Sub DodanieOstatnichRekordowWSerii()
	int i, err
	srcODK.SetKey("id")
	For i=1 To i > Size(g_serieDK)
		If g_serieDK(i).seria != "" Then
			srcODK.SetKeySeg ("id", g_serieDK(i).id)
			If srcODK.GetRec(EQ) Then
				srcODK.Clear()
				srcODK.SetField ("seria", g_serieDK(i).seria)
				srcODK.SetField ("dzial", g_serieDK(i).dzial)
				srcODK.SetField ("okres", g_serieDK(i).okres)
				srcODK.SetField ("serianr", g_serieDK(i).serianr)
				srcODK.SetField ("id", g_serieDK(i).id)
				srcODK.SetField ("typi", 103)
				srcODK.SetField ("subtypi", 2)
				srcODK.SetField ("nazwa", "Rekord serii")
				srcODK.SetField ("kod", g_serieDK(i).kod)
				srcODK.Insert ()
			EndIf
		EndIf
	Next i

#ifdef HMHL
	srcOMG.SetKey("id")
	For i=1 To i > Size(g_serieMG)
		If g_serieMG(i).seria != "" Then
			srcOMG.SetKeySeg ("id", g_serieMG(i).id)
			If srcOMG.GetRec(EQ) Then
				srcOMG.Clear()
				srcOMG.SetField ("seria", g_serieMG(i).seria)
				srcOMG.SetField ("dzial", g_serieMG(i).dzial)
				srcOMG.SetField ("okres", g_serieMG(i).okres)
				srcOMG.SetField ("serianr", g_serieMG(i).serianr)
				srcOMG.SetField ("id", g_serieMG(i).id)
				srcOMG.SetField ("typi", 103)
				srcOMG.SetField ("subtypi", 2)
				srcOMG.SetField ("nazwa", "Rekord serii")
				srcOMG.SetField ("kod", g_serieMG(i).kod)
				srcOMG.Insert ()
			EndIf
		EndIf
	Next i
#endif

	srcOPN.SetKey("id")
	For i=1 To i > Size(g_seriePN)
		If g_seriePN(i).seria != "" Then
			srcOPN.SetKeySeg ("id", g_seriePN(i).id)
			If srcOPN.GetRec(EQ) Then
				srcOPN.Clear()
				srcOPN.SetField ("seria", g_seriePN(i).seria)
				srcOPN.SetField ("dzial", g_seriePN(i).dzial)
				srcOPN.SetField ("okres", g_seriePN(i).okres)
				srcOPN.SetField ("serianr", g_seriePN(i).serianr)
				srcOPN.SetField ("opis", "Rekord serii")
				srcOPN.SetField ("id", g_seriePN(i).id)
				srcOPN.SetField ("typi", 1)
				srcOPN.SetField ("subtypi", 2)
				srcOPN.SetField ("kod", g_seriePN(i).kod)
				srcOPN.Insert ()
			EndIf
		EndIf
	Next i

EndSub

//---

int Sub UsunDokWprStanu()	//usuwanie dok, wpr. stany po poprzednich arch.
#ifdef HMHL
	int err, err1, err2
	long temp

	SetKey(srcPW, "dostawy")
	srcOMZ.SetKey ("super")
	srcOMG.SetKey ("seria")

	srcOMG.SetKeySeg ("seria", "sARC")
	srcOMG.SetKeySeg ("dzial", 0) :	srcOMG.SetKeySeg ("okres", 0) : srcOMG.SetKeySeg ("serianr", 0)
	err = srcOMG.GetRec (GE)
	While !err && srcOMG.GetKeySeg("seria")=="sARC"

		srcOMZ.SetKeySeg ("super", srcOMG.GetField("id")) : srcOMZ.SetKeySeg ("lp", 0)
		err1 = srcOMZ.GetRec (GE)
		While !err1 && srcOMZ.GetKeySeg("super") == srcOMG.GetField("id")

			SetKeySeg(srcPW, "typi", 37) : SetKeySeg(srcPW, "idmg", srcOMZ.GetField("id"))
			SetKeySeg(srcPW, "iddw", 0)
			err2= GetRec(srcPW, GE)

			While !err2 && GetKeySeg(srcPW, "idmg")==srcOMZ.GetField("id")
				If GetField(srcPW, "iddkmg")==srcOMG.GetField("id") Then DelRec(srcPW)
				err2= GetRec(srcPW, NX)
			Wend			

			srcOMZ.Delete()
			err1 = srcOMZ.GetRec (NX)
		Wend

		srcOMG.Delete()
		err = srcOMG.GetRec (NX)
	Wend
#endif
EndSub

