//"diag_dos.sc","Diagnostyka dostaw i stanw magazynowych",12004,0,1.0.0,SYSTEM
//"Diagnostyka",12001,14,16
////////////////////////////
// Diagnostyka dostaw i stanw magazynowych
// diag_dos.sc
////////////////////////////
// Napisa: Sebastian Nowak
// data:    99.07.01

#define NAZWA_PLIKU "DIAG_DOS.TXT"

string sRaportDescription = "Raport sprawdza poprawno danych zapisanych w rekordach dostaw oraz stanw magazynowych na podstawie bazy PW. W przypadku wykrycia niepoprawnych wartoci, raport zapisuje nowe wartoci do baz DW oraz SM na podstawie zawartoci bazy PW."

#include "Diagnostyka - funkcje"

sDialogTitle += "dostaw i stanw magazynowych"

TextOut("Podsumowanie sprawdzania poprawnoci dostaw i stanw magazynowych\n\n")

int sm,sm2,xt,dw,pw,mz
float smStan,smStanHandl,smWartosc
float magStan,magStanHandl,magWartosc
float dwIlosc,dwIloscDosp,dwWartoscDosp,dwIloscPz, dwRezWartIlosc,dwRezWartWartosc
string tMagazyny(1)

int sub ZliczPW(string typ)
	SetKeySeg(pw,"typi",val(typ))
	SetKeySeg(pw,"iddw",GetField(dw,"id"))
	SetKeySeg(pw,"idmg",0)
	err=GetRec(pw,GE)
	while !err && GetField(pw,"iddw")==GetField(dw,"id") && GetField(pw,"typi")==val(typ)
		if GetField(pw,"flag")&8 then dwIlosc -= GetField(pw,"ilosc")
		dwIloscDosp -= GetField(pw,"ilosc")
		dwWartoscDosp -= GetField(pw,"wartosc")
		if GetField(pw,"flag")&16 then dwIloscPz -= GetField(pw,"ilosc")
		if typ=="26" then
			dwRezWartIlosc += GetField(pw,"ilosc")
			dwRezWartWartosc += GetField(pw,"wartosc")
		endif
		err=GetRec(pw,NX)
	wend
endsub

int sub ZliczDlaDostawy()
	dwIlosc = dwIloscDosp = dwWartoscDosp = dwIloscPz = dwRezWartIlosc = dwRezWartWartosc = 0
	ZliczPW("37")	
	ZliczPW("26")	
endsub

int sub ZliczWMagazynie()
	// dla rekordu rezerwacji ilociowych
	SetKey(dw,"towar")
	SetKeySeg(dw,"idtw",GetField(sm,"idtw"))
	SetKeySeg(dw,"numer",-GetField(sm2,"magazyn"))
	dwIlosc = dwIloscDosp = dwWartoscDosp = dwIloscPz = dwRezWartIlosc = dwRezWartWartosc = 0
	if !GetRec(dw,EQ) then
		ZliczDlaDostawy()
		if Sign(dwIlosc-GetField(dw,"ilosc"),4) || Sign(dwIloscDosp-GetField(dw,"iloscdosp"),4) || Sign(dwWartoscDosp-GetField(dw,"wartoscdosp")) ||  Sign(dwIloscPz-GetField(dw,"iloscPz"),4) then
			if TextOutAndAsk(1,(using "Nie zgadzaj si wartoci lub iloci towaru '%s' dla dostawy '%s'",GetField(sm,"kod"),GetFIeld(dw,"kod")),(using ".\nIlosc: jest %.2f powinno by %.2f\nIlosc do sprzeday: jest %.2f powinno by %.2f\nWarto: jest %.2f powinno by %.2f\nIlosc PZ: jest %.2f powinno by %.2f\nCzy naprawi?",GetField(dw,"ilosc"),dwIlosc,GetField(dw,"iloscdosp"),dwIloscDosp,GetField(dw,"wartoscdosp"),dwWartoscDosp,GetField(dw,"iloscPZ"),dwIloscPz)) then
				SetField(dw,"ilosc",dwIlosc)
				SetField(dw,"iloscdosp",dwIloscDosp)
				SetField(dw,"wartoscdosp",dwWartoscDosp)
				SetField(dw,"iloscPz",dwIloscPz)
				UpdateRec(dw,"DW")
			else
				TextOut(sNoRepair)
			endif
		endif
	
	endif
	magStan += ( dwIloscDosp + dwRezWartIlosc )
	magStanHandl += dwIloscDosp
	magWartosc += (dwWartoscDosp + dwRezWartWartosc )

	SetKey(dw,"dostawy")
	SetKeySeg(dw,"magazyn",GetField(sm2,"magazyn"))
	SetKeySeg(dw,"idtw",GetField(sm,"idtw"))
	SetKeySeg(dw,"data","")
	SetKeySeg(dw,"numer",0)
	SetKeySeg(dw,"typi",0)
	err=GetRec(dw,GE)
	while !err && GetField(dw,"magazyn")==GetField(sm2,"magazyn") && GetField(dw,"idtw")==GetField(sm,"idtw")
		if GetField(dw,"numer")>0 then
			ZliczDlaDostawy()
			if Sign(dwIlosc-GetField(dw,"ilosc"),4) || Sign(dwIloscDosp-GetField(dw,"iloscdosp"),4) || Sign(dwWartoscDosp-GetField(dw,"wartoscdosp")) ||  Sign(dwIloscPz-GetField(dw,"iloscPz"),4) then
				if TextOutAndAsk(1,(using "Nie zgadzaj si wartoci lub iloci towaru '%s' dla dostawy '%s'",GetField(sm,"kod"),GetFIeld(dw,"kod")),(using ".\nIlosc: jest %.2f powinno by %.2f\nIlosc do sprzeday: jest %.2f powinno by %.2f\nWarto: jest %.2f powinno by %.2f\nIlosc PZ: jest %.2f powinno by %.2f\nCzy naprawi?",GetField(dw,"ilosc"),dwIlosc,GetField(dw,"iloscdosp"),dwIloscDosp,GetField(dw,"wartoscdosp"),dwWartoscDosp,GetField(dw,"iloscPZ"),dwIloscPz)) then
					SetField(dw,"ilosc",dwIlosc)
					SetField(dw,"iloscdosp",dwIloscDosp)
					SetField(dw,"wartoscdosp",dwWartoscDosp)
					SetField(dw,"iloscPz",dwIloscPz)
					UpdateRec(dw,"DW")
				else
					TextOut(sNoRepair)
				endif
			endif
			magStan += ( dwIloscDosp + dwRezWartIlosc )
			magStanHandl += dwIloscDosp
			magWartosc += (dwWartoscDosp + dwRezWartWartosc )

		endif
		err=GetRec(dw,NX)
	wend

//// zliczanie po rekordach mz tylko dla magazynw typu oddzia firmy ////
	SetKey(xt,"id")
	SetKeySeg(xt,"id",GetField(sm2,"magazyn"))
	if !GetRec(xt,EQ) && (GetField(xt,"flag")&0x10) then 
		SetKey(mz,"tw")
		SetKeySeg(mz,"idtw",GetField(sm,"idtw"))
		err=GetRec(mz,EQ)
		while !err && GetField(mz,"idtw")==GetField(sm,"idtw")
			if (GetField(mz,"magazyn")==GetField(sm2,"magazyn")) && !(GetField(mz,"typi")&0x01) then
				magStan -= GetField(mz,"ilosc")
				magStanHandl = magStan
				magWartosc -= GetField(mz,"wartTowaru")
			endif
			err=GetRec(mz,NX)
		wend
	endif
//////////////////////////////////////////////////////////////////////////

endsub

int sub ZliczWMagazynach()
	SetKeySeg(sm2,"idtw",GetField(sm,"idtw"))
	SetKeySeg(sm2,"magazyn",1)
	err=GetRec(sm2,GE)
	while !err && GetField(sm2,"idtw")==GetField(sm,"idtw")
		magStan = magStanHandl = magWartosc = 0
		ZliczWMagazynie()
		if Sign(magStan-GetField(sm2,"stan"),4) || Sign(magStanHandl-GetField(sm2,"stanhandl"),4) || Sign(magWartosc-GetField(sm2,"wartosc")) then
			if TextOutAndAsk(1,(using "Nie zgadzaj si wartoci lub iloci towaru '%s' w magazynie '%s'",GetField(sm,"kod"),tMagazyny(GetFIeld(sm2,"magazyn"))),(using ".\nStan: jest %.2f powinno by %.2f\nStan handlowy: jest %.2f powinno by %.2f\nWarto: jest %.2f powinno by %.2f\nCzy naprawi?",GetField(sm2,"stan"),magStan,GetField(sm2,"stanhandl"),magStanHandl,GetField(sm2,"wartosc"),magWartosc)) then
				SetField(sm2,"stan",magStan)
				SetField(sm2,"stanHandl",magStanHandl)
				SetField(sm2,"wartosc",magWartosc)
				UpdateRec(sm2,"SM")
			else
				TextOut(sNoRepair)
			endif
		endif
		smStan += magStan
		smStanHandl += magStanHandl
		smWartosc += magWartosc
		err=GetRec(sm2,NX)
	wend
endsub


// *******************************

// zebranie kodw magazynw
xt=OpenBase("xt")
SetKey(xt,"super")
SetKeySeg(xt,"super",6900)
SetKeySeg(xt,"kod","")
err=GetRec(xt,GE)
while !err && GetField(xt,"super")==6900
	if GetField(xt,"klient")>size(tMagazyny) then grow tMagazyny,GetField(xt,"klient")-size(tMagazyny)
	tMagazyny(GetField(xt,"klient"))=GetFIeld(xt,"kod")
	err=GetRec(xt,NX)
wend


sm=OpenBase("SM")
sm2=OpenBase("SM")
dw=OpenBase("DW")
pw=OpenBase("PW")
mz=OpenBase("MZ")

SetKey(sm2,"towar")
SetKey(pw,"pozycje")
SetKey(sm,"kod")
SetKeySeg(sm,"magazyn",0)
SetKeySeg(sm,"kod","")
err=GetRec(sm,GE)
PopUp(1,"Sprawdzanie towaru:")
while !err && !GetField(sm,"magazyn")
	PopUp(2,GetField(sm,"kod"))
	if GetField(sm,"subtypi")==0 then
		smStan = smStanHandl = smWartosc = 0
		ZliczWMagazynach()
		if Sign(smStan-GetField(sm,"stan"),4) || Sign(smStanHandl-GetField(sm,"stanhandl"),4) || Sign(smWartosc-GetField(sm,"wartosc")) then
			if TextOutAndAsk(1,(using "Nie zgadzaj si sumaryczne wartoci lub iloci towaru '%s'",GetField(sm,"kod")),(using ".\nStan: jest %.2f powinno by %.2f\nStan handlowy: jest %.2f powinno by %.2f\nWarto: jest %.2f powinno by %.2f\nCzy naprawi?",GetField(sm,"stan"),smStan,GetField(sm,"stanhandl"),smStanHandl,GetField(sm,"wartosc"),smWartosc)) then
				SetField(sm,"stan",smStan)
				SetField(sm,"stanHandl",smStanHandl)
				SetField(sm,"wartosc",smWartosc)
				UpdateRec(sm,"SM")
			else
				TextOut(sNoRepair)
			endif
		endif
	endif
	err=GetRec(sm,NX)
wend

TextOut("\nZakoczono")
ShowFileInfo()
close


