//"diag_zz.sc","51zz : diagnostyka zwizkw",12004,0,1.0.2,SYSTEM
//"Diagnostyka",12001,14,16
////////////////////////////
// 51zz : diagnostyka zwizkw
// diag_zz.sc
////////////////////////////
// Napisa: Sebastian Nowak
// data:    1999.08.30


string NAZWA_PLIKU = "DIAG_ZZ.TXT"

string sRaportDescription = "Raport sprawdza poprawno typw rekordw ZZ oraz istnienie oraz poprawno typw rekordw ktre s wizane przez rekordy ZZ."

#include "Diagnostyka - funkcje"
UsunRekord_0("ZZ")

sDialogTitle += "zwizkw"

int tBases(0x62)
int zz,nTyp,nPom,bAllowNullId,bm
MapValue mBazy
MapValue mDok2Pos
MapValue mTypeDesc
int nLastValidType = 0xa1		// staa: max warto poprawnego typu
int tQuest(nLastValidType+2)
int tQuestLen(nLastValidType+2)
int nQuestNext=1

int bSpecID = 0
long lSpecID,lTemp

string buttons = "[&Usu:o](Pozosta&w:p)(&Przerwij:a)"
string sDelQuest = ".\nCzy usun rekord ZZ?"

int sub QN( int num )
	// oblicza numer pytania na podstawie typu i numeru pytania dla typu
	if nTyp>nLastValidType || !tQuestLen(nTyp+1) then
		QN=tQuest(nLastValidType+2)+num
	else
		if num >= tQuestLen(nTyp+1) then error using "zadano pytanie o numerze wikszym ni przewidziano dla typu %d",nTyp
		QN=tQuest(nTyp+1)+num
	endif	
	if QN==0 then error using "nie wyznaczono numerw pyta dla typu %d",nTyp
endsub


int sub AddQestionSet(int typ, int ile)
	tQuest(typ+1)=nQuestNext
	tQuestLen(typ+1)=ile
	nQuestNext+=ile
	tQuest(nLastValidType+2)=nQuestNext
endsub

int sub OB(int idx, string bName)
	tBases(idx) = open KatalogFirmy() + "51" + bName + ".dat" for base bName
	BaseError(tBases(idx),4)
	mBazy.Set((using "%d",idx),bName)
endsub


string sub BaseNum2Desc(int b)
	if mBazy.Index(using "%d",b) then
		BaseNum2Desc = mBazy.Get(using "%d",b)
	else
		BaseNum2Desc=""
	endif	
endsub

string sub GetRecType( int typ )
	if mTypeDesc.Index(using "%d",typ) then
		GetRecType = mTypeDesc.Get(using "%d",typ)
	else
		GetRecType = "NIEZNANY"
	endif
	GetRecType = using "%s (%d)",GetRecType,typ
endsub


int sub DelZZ()
	if DeleteRec(zz,"ZZ") then
		DelZZ=2
	else
		DelZZ=0
	endif
endsub


int sub CheckMain(string id, string baza, int offs)
	// zwraca 2 gdy nie ok ale kontynuujemy
	// zwraca 1 gdy ok
	// zwraca 0 gdy usunito rekord
	buf = BaseNum2Desc(GetField(zz,baza))
	if !buf then
		if TextOutAndAsk2(QN(offs),(using "Rekord bazy ZZ id=%l typ='%s' czy rekord nieznanej bazy %s=%d %s=%l",GetField(zz,"id"),GetRecType(nTyp),baza,GetField(zz,baza),id,GetField(zz,id)),sDelQuest,buttons) then
			CheckMain=DelZZ()
		else
			TextOut(sNoRepair)
			CheckMain=2
		endif
	else
		lTemp=GetField(zz,id)
		if bAllowNullId && !lTemp then CheckMain=2 : exit
		if bSpecId then lTemp=lSpecId
		SetKeySeg(tBases(GetField(zz,baza)),"id",lTemp)
		if GetRec(tBases(GetField(zz,baza)),EQ) then
			if TextOutAndAsk2(QN(offs+1),(using "Rekord bazy ZZ id=%l typ='%s' czy nieistniejcy rekord bazy %s %s=%l",GetField(zz,"id"),GetRecType(nTyp),buf,id,lTemp),sDelQuest,buttons) then
				CheckMain=DelZZ()
			else
				TextOut(sNoRepair)
				CheckMain=2
			endif			
		else
			CheckMain=1
		endif
	endif
endsub


int sub Check1()
	Check1=CheckMain("id1","baza1",0)
endsub

int sub Check2()
	Check2=CheckMain("id2","baza2",2)
endsub

int sub GetDkPosBase(int b)
	GetDkPosBase=0
	if !mDok2Pos.Index(using "%d",b) then exit
	if !tBases(mDok2Pos.Get(using "%d",b)) then exit
	GetDkPosBase = tBases(mDok2Pos.Get(using "%d",b)) 
endsub


int sub Check3()
	int b2
	Check3=CheckMain("id3","baza3",4)
	if Check3==1 then
		buf=using "%d",GetField(zz,"baza3")
		b2 = GetDkPosBase( GetField(zz,"baza3"))
		if b2 then
			SetKeySeg(b2,"id",GetField(zz,"id3pos"))
			if GetRec(b2,EQ) then
				if TextOutAndAsk2(QN(6),(using "Rekord bazy ZZ id=%l typ='%s' czy nieistniejcy rekord pozycji dokumentu w bazie %s id3=%l",GetField(zz,"id"),GetRecType(nTyp),BaseNum2Desc(mDok2Pos.Get(using "%d",GetField(zz,"baza3"))),GetField(zz,"id3")),sDelQuest,buttons) then
					Check3 = DelZZ()
				else
					TextOut(sNoRepair)
				endif
			endif
		else
			if TextOutAndAsk2(QN(7),(using "Rekord bazy ZZ id=%l typ='%s' czy rekord pozycji dokumentu nieznanej bazy baza3=%d id3=%l",GetField(zz,"id"),GetRecType(nTyp),GetField(zz,"baza3"),GetField(zz,"id3")),sDelQuest,buttons) then
				Check3=DelZZ()
			else
				TextOut(sNoRepair)
			endif
		endif
	endif
endsub


int sub Check1Mus( int b, int offs )
	// zwraca to co check1
	// 3 - gdy niewaciwa baza
	if GetField(zz,"baza1")!=b then
		if TextOutAndAsk2(QN(offs),(using "Rekord bazy ZZ id=%l typ='%s' poprzez pole 'baza1' czy rekord bazy %s zamiast %s",GetField(zz,"id"),GetRecType(nTyp),BaseNum2Desc(GetField(zz,"baza1")),BaseNum2Desc(b)),sDelQuest,buttons) then
			Check1Mus = DelZZ()
		else
			TextOut(sNoRepair)
			Check1Mus=3
		endif	
	else
		Check1Mus=Check1()
	endif
endsub


int sub Check2Mus( int b, int offs )
	// zwraca to co check2
	// 3 - gdy niewaciwa baza
	if GetField(zz,"baza2")!=b then
		if TextOutAndAsk2(QN(offs),(using "Rekord bazy ZZ id=%l typ='%s' poprzez pole 'baza2' czy rekord bazy %s zamiast %s",GetField(zz,"id"),GetRecType(nTyp),BaseNum2Desc(GetField(zz,"baza2")),BaseNum2Desc(b)),sDelQuest,buttons) then
			Check2Mus = DelZZ()
		else
			TextOut(sNoRepair)
			Check2Mus=3
		endif
	else
		Check2Mus=Check2()
	endif
endsub

int sub Check1MusAndType(int base, int qn1, int qn2, string typ, string lookFor)
	// zwraca to co check1mus
	// 4 - gdy niewaciwy typ
	Check1MusAndType = Check1Mus(base,qn1)
	if !Check1MusAndType then exit
	if Check1MusAndType==1 then
		buf = using "%d",GetField(tBases(base),"typi")
		if !find regular typ then
			if TextOutAndAsk2(QN(qn2),(using "Rekord '%s' id=%l poprzez pole 'id1' wskazuje na nieodpowiedni rekord bazy %s",GetRecType(nTyp),GetField(zz,"id"),BaseNum2Desc(base)),(using ".\nPole 'typ' ma warto '%d",GetField(tBases(base),"typi"))+"' : oczekowano typu reprezentujcego '"+lookFor+"'"+sDelQuest,buttons) then
				DelZZ()
				Check1MusAndType=0
			else
				TextOut(sNoRepair)
				Check1MusAndType=4
			endif
		endif
	endif
endsub

int sub Check2MusAndType(int base, int qn1, int qn2, string typ, string lookFor)
	// zwraca to co check2mus
	// 4 - gdy niewaciwy typ
	Check2MusAndType = Check2Mus(base,qn1)
	if !Check2MusAndType then exit
	if Check2MusAndType==1 then
		buf = using "%d",GetField(tBases(base),"typi")
		if !find regular typ then
			if TextOutAndAsk2(QN(qn2),(using "Rekord '%s' id=%l poprzez pole 'id2' wskazuje na nieodpowiedni rekord bazy %s",GetRecType(nTyp),GetField(zz,"id"),BaseNum2Desc(base)),(using ".\nPole 'typ' ma warto '%d",GetField(tBases(base),"typi"))+"' : oczekowano typu reprezentujcego '"+lookFor+"'"+sDelQuest,buttons) then
				DelZZ()
				Check2MusAndType=0
			else
				TextOut(sNoRepair)
				Check2MusAndType=4
			endif
		endif
	endif
endsub


int sub Sprawdz0x80(int bb, string typ, string lookfor, string lf_KH, string lf_KH_desc)
	// sprzeda w buforze

	int nFlag = 0
	Sprawdz0x80 = Check1Mus(bb, 4)
	if !Sprawdz0x80 then exit
	if Sprawdz0x80==1 then
		// sprawdzenie czy nie rozliczony
		nPom=1		// wiemy e jest i zakadamy e nie zmieniamy tego
		// nPom=0 gdy nie powinien by
		select case bb

			case 0x26	//BM
				

			case 0x22	// ZK
				if ((firma.code != "HM") && (firma.code != "HL")) then
					nPom = GetField(tBases(bb), "subtypi") == 49 && !GetField(tBases(bb),"iddokkoryg")
				else
					if GetField(tBases(bb),"rozlmgi")==0 then
						nPom=0
					else
						nFlag = GetField(tBases(bb),"iddokkoryg") != 0

						if !nFlag then
							SetKeySeg(bm,"idhandl",GetField(tBases(bb),"id"))
							SetKeySeg(bm,"data","")
							if !GetKey(bm,GE) && GetKeySeg(bm,"idhandl")==GetField(tBases(bb),"id") then nFlag=1
						endif
					endif
				endif

			case 0x21	//MG
				buf = using "%d",GetField(tBases(bb),"subtypi")

				if GetField(tBases(bb),"oki")!=0 then nPom=0
				if nPom then 
					nFlag = GetField(tBases(bb),"iddokkoryg") != 0 
					
					if !nFlag then
						if GetField(tBases(bb),"idhandl") > 0 then
							nFlag = 1
						else
							if GetField(tBases(bb),"idhandl") < 0 then
								if GetField(tBases(bb),"flag") & 0x0400 then
									nFlag = 1
								endif
							endif
						endif
					endif
				endif


			case 0x10	// DK
				if ((firma.code == "HM") || (firma.code == "HL")) then
					if GetField(tBases(bb),"rozlmgi")==0 then
						nPom=0
					else
						nFlag = 0 != GetField(tBases(bb),"iddokkoryg")

						if !nFlag then
							SetKeySeg(bm,"idhandl",GetField(tBases(bb),"id"))
							SetKeySeg(bm,"data","")
							if !GetKey(bm,GE) && GetKeySeg(bm,"idhandl")==GetField(tBases(bb),"id") then nFlag=1
						endif
					endif
				else
					if GetField(tBases(bb),"subtypi")==49 then
						nPom = !GetField(tBases(bb),"iddokkoryg")
					else
						nPom=0
					endif
				endif

			case 0x1c	// BD
				buf=using "%d",GetField(tBases(bb),"typi")
				if buf=="0" || buf=="202" || buf=="1" || buf=="203" then
					if buf=="1" || buf=="203" then
						if GetField(tBases(bb),"oki")!=0 then nPom=0
					endif
				else
					nPom=0
				endif

		endselect
		if !nPom then
			if TextOutAndAsk2(QN(8),(using "Rekord '%s' id=%l wskazuje na dokument id=%l w bazie %s ktry zosta ju rozliczony magazynowo",GetRecType(nTyp),GetField(zz,"id"),GetField(tBases(bb),"id"),BaseNum2Desc(bb)), sDelQuest, buttons) then

				DelZZ()
///////////////////////////okazao si potrzebne w jednej firmie /////////////////
//				lTemp=GetField(zz,"id2")
//				lTemp = lTemp & 0xffffff
//
//				if lTemp != GetField(tBases(bb),"khid") then
//					SetField(tBases(bb),"idhandl", 0)
//					SetField(tBases(bb),"khid", lTemp)
//					SetField(tBases(bb),"ok", "0")
//
//					SetKey(tBases(0x14), "id")
//					SetKeySeg(tBases(0x14), "id", lTemp)
//
//					if !GetRec(tBases(0x14), EQ) then
//						SetField(tBases(bb), "khkod", GetField(tBases(0x14), "kod"))
//						SetField(tBases(bb), "khnazwa", GetField(tBases(0x14), "nazwa"))
//						SetField(tBases(bb), "khadres", GetField(tBases(0x14), "ulica"))
//						SetField(tBases(bb), "khmiasto", GetField(tBases(0x14), "miejscowosc"))
//						SetField(tBases(bb), "khkodpocz", GetField(tBases(0x14), "kodpocz"))
//						SetField(tBases(bb), "khnip", GetField(tBases(0x14), "nip"))
//					endif
//
//					PutRec(tBases(bb))
//				endif
/////////////////////////////////////////////////////////////////////////////////

				exit
			else
				TextOut(sNoRepair)
			endif
		else
			if nFlag != GetField(zz, "flag") then
				if TextOutAndAsk2(QN(8),(using "Rekord '%s' id=%l ma le wypenione pole flag",GetRecType(nTyp),GetField(zz,"id")), ".\nCzy uaktualni rekord ZZ?", "[&Popraw:o](Pozosta&w:p)(&Przerwij:a)") then
					SetField(zz, "flag", nFlag)
					PutRec(zz)
				else
					TextOut(sNoRepair)
				endif
			endif
		endif
	endif
	Sprawdz0x80 = Check1MusAndType(bb, 4,5, typ,lookfor)
	if !Sprawdz0x80 then exit
	lTemp=GetField(zz,"id2")
	lTemp = lTemp & 0xffffff
	if lTemp then
		lSpecId=lTemp
		bSpecId=1
		Sprawdz0x80 = Check2MusAndType(0x14,6,7,lf_KH, lf_KH_desc)
		bSpecId=0
	endif
endsub
int sub CheckCodeFW(string s)
		//0 gdy zy kod
string baza = "baza"+s
int bazaDoc = tBases(GetField(zz,baza))
	if GetField(bazaDoc,"kod")!=GetField(zz,"kod"+s) then
		if TextOutAndAsk2(QN(0),(using "Rekord %s id=%l poprzez pole 'id%s' i 'kod%s' czy z nieprawidowym dokumentem",GetRecType(nTyp),GetField(zz,"id"),s,s),(using ".\nPole 'kod' dokumentu ma warto '%s' : oczekiwano wartoci '%s'",GetField(bazaDoc,"kod"),GetField(zz,"kod"+s))+sDelQuest,buttons) then
			DelZZ()
		else
			TextOut(sNoRepair)
		endif
		CheckCodeFW=0
	else
		CheckCodeFW=1
	endif	
endsub	

int sub SprawdzZwiazki()
	PopUp(1,"Sprawdzanie zwizkw")
	SetKey(zz,"id")
	err=GetRec(zz,FS)
	progress.Reset(GetRecordCount(zz))
	while !err
		progress.NextOne()
		nTyp = GetField(zz,"typi")
		select case nTyp

			case 0x20
				err = Check1MusAndType(0x14,4,5,"^(103)|(101)$","osoba lub firma") && Check2()

			case 0x40
				// upust indywidualny
				bAllowNullId=1
				Check1()
				Check2()
				bAllowNullId=0

			case 0x41
				// upust ilociowy
				if GetField(zz,"baza1")==2 then
					Check1MusAndType(0x2, 2, 3, "^4$","rodzaj towaru")
				else
					Check1MusAndType(0x16, 2, 3, "^(0)|(100)$","towar")
				endif

			case 0x45
				// zestaw towarw
				if Check1MusAndType(0x16, 4, 5, "^(0)|(100)$","towar") then
					if Check2MusAndType(0x16, 6, 7, "^(0)|(100)$","towar") then

						SetKey(tBases(0x16),"id")
						SetKeySeg(tBases(0x16),"id", GetField(zz,"id1"))
						IF !GetRec(tBases(0x16), EQ) THEN
							IF !( GetField(tBases(0x16), "subtypi")==3 || GetField(tBases(0x16), "subtypi")==2 ) THEN
								if TextOutAndAsk2(QN(0),(using "Rekord bazy ZZ id=%l, typu zestaw lub komplet, poprzez pole id1=%l wskazuje na nieodpowiedni rekord bazy %s", GetField(zz,"id"), GetField(zz,"id1"), BaseNum2Desc(0x16)),sDelQuest,buttons) then
									DelZZ()
								else
									TextOut(sNoRepair)
								endif
							ENDIF
						ENDIF

					endif
				endif

			case 0x46
				// zestaw dla rodzaju
				if Check1MusAndType(0x2, 4, 5, "^4$","zestaw dla rodzaju") then
					 Check2MusAndType(0x16, 6, 7, "^(0)|(100)$","towar")
				endif

			case 0x50
				if ((firma.code == "HM") || (firma.code == "HL")) then
					if TextOutAndAsk2(QN(0),(using "Rekord bazy ZZ id=%l ma typ='%s' ktry to nie powinien wystpowa w tej wersji programu",GetField(zz,"id"),GetRecType(nTyp)),sDelQuest,buttons) then
						DelZZ()
					else
						TextOut(sNoRepair)
					endif
				else
					err=Check1() && Check2()
				endif


			case 0x60
				// rezerwacja utworzona automatycznie
				if Check1MusAndType(0x16, 8, 9, "^(0)|(100)$","towar") then
						if GetField(zz,"id2") then Check2MusAndType(0x14, 10, 11, "^(0)|(100)|(105)$","kontrahent lub magazyn")
					 Check3()
				endif

			case 0x62
				// rezerwacja utworzona rcznie
				if Check1MusAndType(0x16, 8, 9, "^(0)|(100)$","towar") then
						Check2MusAndType(0x14, 10, 11, "^(0)|(100)$","kontrahent")
				endif

			case 0x64
				// brak dostpu do rejestru patnoci
				if Check1MusAndType(0x02, 4, 5, "^30$","uytkownik") then
					 Check2MusAndType(0x02, 6, 7, "^8$","rejestr patnoci")
				endif

			case 0x65
				// brak dostpu do magazynu
				if Check1MusAndType(0x02, 4, 5, "^30$","uytkownik") then
					 Check2MusAndType(0x02, 6, 7, "^82$","magazyn")
				endif

			case 0x66
				// magazyn biecy uytkownika
				if Check1MusAndType(0x02, 4, 5, "^30$","uytkownik") then
					 Check2MusAndType(0x02, 6, 7, "^82$","magazyn")
				endif

			case 0x68
				// dane dla query uytkownika
				Check1Mus(0x02,2)

			case 0x70
				// nazwa dostawy dla pozycji przychodowej w buforze
				Check1Mus(0x27,2)

			case 0x80
				// sprzeda w buforze nie rozl. magazynowo
				Sprawdz0x80(0x1c,"^(0)|(1)$","dokument sprzeday w buforze lub zamwienie obce","^(0)|(100)$","kontrahent")

			case 0x81
				// zakup w buforze nie rozl. magazynowo
				Sprawdz0x80(0x1c,"^(202)|(203)$","dokument zakupu w buforze lub zamwienie wasne","^(0)|(100)$","kontrahent")

			case 0x82
				// dok. magazynowy w buforze nie rozl. magazynowo
				Sprawdz0x80(0x26,"^201$","dokument magazynowy w buforze","^(0)|(100)|(105)$","kontrahent lub magazyn")

			case 0x83
				//sprzeda nie rozl. magazynowo
				Sprawdz0x80(0x10,"^(0)|(1)|(100)$","dokument sprzeday","^(0)|(100)$","kontrahent")

			case 0x84
				//zakup nie rozl. magazynowo
				Sprawdz0x80(0x22,"^(202)|(203)|(112)$","dokument zakupu","^(0)|(100)$","kontrahent")

			case 0x85
				// wydanie zewntrzne nie rozl. magazynowo
				Sprawdz0x80(0x21,"^(201)|(111)$","dokument magazynowy","^(0)|(100)$","kontrahent")

			case 0x86
				// przyjcie zewntrzne nie rozl. magazynowo
				Sprawdz0x80(0x21,"^(201)|(111)$","dokument magazynowy","^(0)|(100)$","kontrahent")

			case 0x87
				// wydanie wewntrzne nie rozl. magazynowo
				Sprawdz0x80(0x21,"^(201)|(111)$","dokument magazynowy","^(0)|(100)$","kontrahent")

			case 0x88
				// przychd wewntrzny nie rozl. magazynowo
				Sprawdz0x80(0x21,"^(201)|(111)$","dokument magazynowy","^(0)|(100)$","kontrahent")

			case 0x89
				// zamwienie wasne nie rozl. magazynowo
				Sprawdz0x80(0x1c,"^203$","zamwienie wasne","^(0)|(100)$","kontrahent")

			case 0x8a
				//zamwienie obce	nie rozl. magazynowo
				Sprawdz0x80(0x1c,"^1$","zamwienie obce","^(0)|(100)$","kontrahent")

			case 0x8b
				// wydanie kontrahentowi w FakturzePro
				if ((firma.code == "HM") || (firma.code == "HL")) then
					if TextOutAndAsk2(QN(0),(using "Rekord bazy ZZ id=%l ma typ='%s' ktry to nie powinien wystpowa w tej wersji programu",GetField(zz,"id"),GetRecType(nTyp)),sDelQuest,buttons) then
						DelZZ()
					else
						TextOut(sNoRepair)
					endif
				else
					Sprawdz0x80(0x10,"^(0)|(1)|(100)$","dokument sprzeday","^(0)|(100)$","kontrahent")
				endif

			case 0x8c
				//dokument sprzeday nierozliczony pieninie
				nPom = Check1MusAndType(0x10, 4, 5, "^0$","dokument sprzeday")
				if nPom then
					if nPom==1 && (!GetField(tBases(0x10),"subtypi") || GetField(tBases(0x10),"oki")==1) then
						buf = "rozliczony"
						if !GetField(tBases(0x10),"subtypi") then buf = "anulowany"
						if TextOutAndAsk2(QN(8),(using "Rekord '%s' id=%l poprzez pole 'id1' wskazuje na %s dokument sprzeday",GetRecType(nTyp),GetField(zz,"id"),buf),sDelQuest,buttons) then
							DelZZ()
							nPom=0
						else
							nPom=1
							TextOut(sNoRepair)
						endif
					endif
					bAllowNullId=1
					if nPom then Check2MusAndType(0x14, 6, 7, "^(0)|(100)$","kontrahent lub kontrahent w koszu")
					bAllowNullId=0
				endif

			case 0x8d
				//dokument zakupu nierozliczony pieninie
				nPom = Check1MusAndType(0x22, 4, 5, "^202$","dokument zakupu")
				if nPom then
					if nPom==1 && (!GetField(tBases(0x22),"subtypi") || GetField(tBases(0x22),"oki")==1) then
						buf = "rozliczony"
						if !GetField(tBases(0x22),"subtypi") then buf = "anulowany"
						if TextOutAndAsk2(QN(8),(using "Rekord '%s' id=%l poprzez pole 'id1' wskazuje na %s dokument zakupu",GetRecType(nTyp),GetField(zz,"id"),buf),sDelQuest,buttons) then
							DelZZ()
							nPom=0
						else
							nPom=1
							TextOut(sNoRepair)
						endif
					endif
					bAllowNullId=1
					if nPom then Check2MusAndType(0x14, 6, 7, "^(0)|(100)$","kontrahent lub kontrahent w koszu")
					bAllowNullId=0
				endif
			case 0x8f
			// kontrakt zakupu nie rozl. magazynowo
			Sprawdz0x80(0x1c,"^203$","kontrakt zakupu","^(0)|(100)$","kontrahent")

			case 0x8e
				//kontrakt sprzeday  nie rozl. magazynowo
				Sprawdz0x80(0x1c,"^1$","kontrakt sprzeday","^(0)|(100)$","kontrahent")


			case 0x90
				//dokument handlowy do zamwienia
				if Check1Mus(0x1c, 4 ) then
					if GetField(zz,"baza2")==0x10 then
						Check2MusAndType(0x10, 5, 6, "^(0)|(100)$","dokument sprzeday")
					else
						if GetField(zz,"baza2")==0x22 then
							Check2MusAndType(0x22, 7, 8, "^(202)|(112)$","dokument zakupu")
						else
							Check2MusAndType(0x1c, 9, 10, "^(0)|(202)$","dokument handlowy w buforze")
						endif
					endif
				endif

			case 0x96
				// paragon i dokument sprzedazy wystawiony na jego podstawie
				if Check1Mus(0x10, 16 ) then
					if GetField(zz,"baza2")==0x10 then
						Check2MusAndType(0x10, 17, 18, "^(0)|(100)$","dokument sprzeday")
					else
						Check2MusAndType(0x1c, 19, 20, "^(0)|(202)$","dokument handlowy w buforze")
					endif
				endif
			case 0x97
			// dokument i faktura wewntrzna wystawiona na jego podstawie
			if Check1()==1 then
				if CheckCodeFW("1") then
					if Check2()==1 then
						CheckCodeFW("2")
					endif
				endif	
			endif
			case 0xa0
				// edycje i usunicia
				// nie sprawdzamy edycji i usuni
				//Check1()

			case 0xa1
				// edycje formy patnoci
				Check1MusAndType(0x02, 2, 3, "^90$","forma patnoci")

			case 0xa2
				// schemat ksiegowan

			case 0xa3
				// wzorzec parametrw ksigowa

			case else
				if nTyp!=0 && GetField(zz,"id")!=65535 then
					if TextOutAndAsk2(QN(0),(using "Rekord bazy ZZ id=%l ma typ='%s' ktrego raport nie potrafi sprawdzi",GetField(zz,"id"),GetRecType(nTyp)),".\nZaleca si pozostawienie rekordu ZZ. Czy usun rekord ZZ?","(&Usun:o)[Pozosta&w:p](&Przerwij:a)") then
						DelZZ()
					else
						TextOut(sNoRepair)
					endif
				endif

		endselect
		err=GetRec(zz,NX)
	wend
endsub


// *********** main ***********

mBazy.Type(string)

// otwarcie wszystkich baz
OB(0x02,"XT")
OB(0x04,"NT")
OB(0x10,"DK")
OB(0x12,"DP")
OB(0x14,"KH")
OB(0x16,"TW")
OB(0x18,"WL")
OB(0x1A,"ZZ")
OB(0x1C,"BD")
OB(0x1E,"BP")
OB(0x1F,"UZ")
OB(0x20,"Pn")
OB(0x2B,"RL")
OB(0x61,"KH")		//WR
OB(0x62,"KH")		//UR

if ((firma.code == "HM") || (firma.code == "HL")) then
	OB(0x21,"MG")
	OB(0x22,"DK") // ZK
	OB(0x23,"SM")
	OB(0x24,"PW")
	OB(0x25,"MZ")
	OB(0x26,"BM")
	OB(0x27,"BZ")
	OB(0x28,"DW")
endif

// baza PR
buf="AM"+firma.code
tBases(6) = open Katalog() + buf + "51pr.dat" for base "PR"
BaseError(tBases(6),4)
mBazy.Set("6","PR")

zz=OpenBase("ZZ")
if ((firma.code == "HM") || (firma.code == "HL")) then
	bm=OpenBase("BM")
	SetKey(bm,"idhandl")
endif

mDok2Pos.Type(int)
mDok2Pos.Set((using"%d",0x10),0x12)
mDok2Pos.Set((using"%d",0x21),0x25)
mDok2Pos.Set((using"%d",0x1C),0x1E)
mDok2Pos.Set((using"%d",0x26),0x27)

mTypeDesc.Type(string)
mTypeDesc.Set((using"%d",0x20),"prawo uytkownika")
mTypeDesc.Set((using"%d",0x40),"upust indywidualny")
mTypeDesc.Set((using"%d",0x41),"upust ilociowy")
mTypeDesc.Set((using"%d",0x45),"zestaw towarw")
mTypeDesc.Set((using"%d",0x46),"zestaw dla rodzajw")
mTypeDesc.Set((using"%d",0x50),"rozliczenie patnoci/nalenoci")
mTypeDesc.Set((using"%d",0x60),"rezerwacja utworzona automatycznie")
mTypeDesc.Set((using"%d",0x62),"rezerwacja utworzona rcznie")
mTypeDesc.Set((using"%d",0x64),"brak dostpu do rejestru patnoci")
mTypeDesc.Set((using"%d",0x65),"brak dostpu do magazynu")
mTypeDesc.Set((using"%d",0x66),"magazyn biecy uytkownika")
mTypeDesc.Set((using"%d",0x68),"dane dla query uytkownika")
mTypeDesc.Set((using"%d",0x70),"nazwa dostawy dla pozycji przychodowej w buforze")
mTypeDesc.Set((using"%d",0x80),"sprzeda w buforze nie rozl. magazynowo")
mTypeDesc.Set((using"%d",0x81),"zakup w buforze nie rozl. magazynowo")
mTypeDesc.Set((using"%d",0x82),"dok. magazynowy w buforze nie rozl. magazynowo")
mTypeDesc.Set((using"%d",0x83),"sprzeda nie rozl. magazynowo")
mTypeDesc.Set((using"%d",0x84),"zakup nie rozl. magazynowo")
mTypeDesc.Set((using"%d",0x85),"wydanie zewntrzne nie rozl. magazynowo")
mTypeDesc.Set((using"%d",0x86),"przyjcie zewntrzne nie rozl. magazynowo")
mTypeDesc.Set((using"%d",0x87),"wydanie wewntrzne nie rozl. magazynowo")
mTypeDesc.Set((using"%d",0x88),"przychd wewntrzny nie rozl. magazynowo")
mTypeDesc.Set((using"%d",0x89),"zamwienie wasne nie rozl. magazynowo")
mTypeDesc.Set((using"%d",0x8a),"zamwienie obce nie rozl. magazynowo")
mTypeDesc.Set((using"%d",0x8b),"wydanie kontrahentowi w FakturzePro")
mTypeDesc.Set((using"%d",0x8c),"dokument sprzeday nierozliczony pieninie")
mTypeDesc.Set((using"%d",0x8d),"dokument zakupu nierozliczony pieninie")
mTypeDesc.Set((using"%d",0x90),"dokumenty handlowe do zamwie")
mTypeDesc.Set((using"%d",0x96),"paragon i dokument sprzeday wystawiony na jego podstawie")
mTypeDesc.Set((using"%d",0x97),"dokument i faktura wewntrzna wystawiona na jego podstawie")
mTypeDesc.Set((using"%d",0xa0),"edycja i usunicia")
mTypeDesc.Set((using"%d",0xa1),"edycja formy patnoci")

AddQestionSet(0,4)
AddQestionSet(0x20,6)
AddQestionSet(0x40,8)
AddQestionSet(0x41,4)
AddQestionSet(0x45,8)
AddQestionSet(0x46,8)
AddQestionSet(0x50,4)
AddQestionSet(0x60,12)
AddQestionSet(0x62,12)
AddQestionSet(0x64,8)
AddQestionSet(0x65,8)
AddQestionSet(0x66,8)
AddQestionSet(0x68,3)
AddQestionSet(0x70,3)
AddQestionSet(0x80,9)
AddQestionSet(0x81,9)
AddQestionSet(0x82,9)
AddQestionSet(0x83,9)
AddQestionSet(0x84,9)
AddQestionSet(0x85,9)
AddQestionSet(0x86,9)
AddQestionSet(0x87,9)
AddQestionSet(0x88,9)
AddQestionSet(0x89,9)
AddQestionSet(0x8a,9)
AddQestionSet(0x8b,9)
AddQestionSet(0x8c,9)
AddQestionSet(0x8d,9)
AddQestionSet(0x90,11)
AddQestionSet(0xa0,2)
AddQestionSet(0xa1,4)

TextOut("Podsumowanie sprawdzania poprawnoci bazy zwizkw\n\n")

SprawdzZwiazki()

// sprawdzanie istnienia i poprawnoci rekordw ktre s czone poprzez rekordy ZZ


TextOut("\nZakoczono.")

ShowFileInfo()
close

