//"dokengkw.sci","Engine do korekt wyda",12401,0,1.0.0,SYSTEM
//"Dokumenty magazynowe",12400,14,62
////////////////////////////
// Engine do korekt wyda
// dokengkw.sci
////////////////////////////

// wykomentowa ponisz lini, aby drukowanie ORYGINA/KOPIA itd. na podstawie arg3
// arg9=""

Limit 10000

#include "Nagwek i stopka raportu I"
record InfoPoz
	int lp
	long idpozkoryg
	string Opis[8192]
	string Kod[40]
	string  KodObcy[26]
	float Ilosc
	float IloscWP
	float Cena
	float CenaWP
	string Jm[9]
	string JmWP[9]
	float Wartosc
	long 		idtw
	float PrzelJmDod
endrec

record InfoDost
	int  lp
	long id
	int   typ		// 1-pozycja przed korekt 2-korekta 3-po korekcie
	string nazwa[40]
	float ilosc
	float Cena
	float wartosc
endrec


InfoPoz PozycjeBaza(1)
InfoPoz PozycjeKoryg(1)
InfoPoz PozycjePoKor(1)
InfoDost Dostawy(1)
string KodyKorekt(1)
long noweid(1)
string sKodDokHand, sDataDokHand
float fWartKUzup(1) //pole wartk z bazy mz - mowi o ile zmienia sie wartosc pozycji bazowej przy istnieniu KWM
long idTemp
MapValue IdNaIndex

int nt,GRAF,BUFOR,mg,mz,err,pw,dw,dk,dp,mg2,mz2,mgb,mzb,zz,uz,tw
int nPoz,i,j,k,l,nDostawy
string sMG,sMZ,sDK,sDP
long iddok,lTemp
float tot_netto,tot_nettoPrzed,tot_nettoPo
int no_chg(1)
// ****************************

int sub OpenBase( string bas )
	OpenBase = open KatalogFirmy() + "51" + bas + ".dat" for base bas
	BaseError(OpenBase,4)
endsub


string sub DajNIP( string NIP )
// funkcja zwraca "REGON: ","PESEL: ","NIP: "
// w zmiennej buf zwraca cig odpowiednich cyfr
	buf=NIP
	if find regular "{[rRpP]}/:{*$}" then
		Select Case regular 1
		Case "R","r"
			DajNip = "REGON: "
		Case "P","p"
			DajNip = "PESEL: "
		EndSelect
		NIP = regular 2
		buf = NIP
	else
		DajNIP="NIP: "
		buf = NIP
	endif
endsub
string sub GetName(int m)
	if GetField( m,"idlongname" ) then
		SetKey( nt,"id" )
		SetKeySeg( nt,"id",GetField( m,"idlongname" ) )
		GetRec( nt,EQ )
		BaseError( nt,4 )
		GetName = GetField( nt,"opis" )
	else
		GetName = GetField( m,"opis" )
	endif
endsub

string sub KodPaskowy_pozycji(InfoPoz poz)
	if !(Poz.idtw) then  KodPaskowy_pozycji = "" : exit
	SetKeySeg(tw,"ID",Poz.idtw)
	if GetRec(tw,EQ) then KodPaskowy_pozycji = "" : exit
	KodPaskowy_pozycji = GetField(tw,"kodpaskowy")
endsub

long lHighNum
long sub DajNumerLp(long lNumer)
string s=(using "%l",lNumer)
int i	
	s=mid(s,2)
// > 10000 oznacza pozycje nie podlegajaca VAT
	if lNumer<10000 then 
		if lNumer>lHighNum then lHighNum=lNumer
		DajNumerLp=lNumer : exit
	endif
	for i=1 to i > len(s)
		if mid(s,i,1)!="0" then DajNumerLp=val(mid(s,i))+lHighNum : exit
	next i
endsub

int sub ZbierzPozycje( InfoPoz poz, int m, int typ, string mzTyp, string prefix, int pozDost )
	if !poz.lp then
		poz.lp=GetField(m,"lp")
		poz.idpozkoryg = iif(GetField(m,"idpozkoryg")<0,-GetField(m,"idpozkoryg"),GetField(m,"idpozkoryg"))
		poz.Opis=GetName(m)
		if ((firma.code == "HM") || (firma.code == "HL")) then
			SetKeySeg(uz,"iduz",GetField(m,"idtw"))
			SetKeySeg(uz,"idkh",GetField(m,"idkh"))
			if !GetRec(uz,EQ) then poz.KodObcy=GetField(uz,"kodobcy")
		endif
		poz.Kod=GetField(m,"kod")
		poz.Jm=GetField(m,"jm")	
		poz.JmWP=GetField(m,"jmWP")	
		poz.idtw = GetField ( m,"idtw" )
	endif
	if typ==1 then
		
		if GetField(m,"iloscWP") then fWartKUzup(size(fWartKUzup))=getfield(m,"wartk")/GetField(m,"IloscWP")
		poz.Ilosc+=GetField(m,"ilosc")
		poz.IloscWP+=GetField(m,"iloscWP")
		poz.wartosc+=GetField(m,"wartNetto")+GetField(m,"wartk")
		poz.Cena+=GetField(m,"cena")
		Poz.CenaWP=Poz.Cena
	else
		poz.Ilosc+=GetField(m,"ilosc")
		poz.IloscWP+=GetField(m,"iloscWP")
		poz.wartosc+=GetField(m,"wartNetto")
		poz.Cena+=GetField(m,"cena")
		Poz.CenaWP=Poz.Cena
	endif

	SetKeySeg(pw,"typi",val(mzTyp))
	SetKeySeg(pw,"idmg",GetField(m,"id"))
	SetKeySeg(pw,"iddw",0)
	err=GetRec(pw,GE)
	while !err && GetField(pw,"idmg")==GetField(m,"id") && GetField(pw,"typi")==val(mzTyp)
		// czy ta dostawa ju jest
		for i=1 to i>nDostawy
			if dostawy(i).typ==typ && dostawy(i).lp==poz.lp && dostawy(i).id==GetField(pw,"iddw") then
				dostawy(i).ilosc+=GetField(pw,"ilosc")
				dostawy(i).wartosc+=GetField(pw,"wartosc")
				if Sign(dostawy(i).ilosc,4) then Dostawy(i).cena = Dostawy(i).wartosc/Dostawy(i).ilosc
				i=nDostawy+2
			endif
		next i
		if i==nDostawy+1 then		// dodajemy now dostaw
			if nDostawy then grow dostawy,1
			nDostawy+=1
			dostawy(nDostawy).typ=typ
			dostawy(nDostawy).lp=pozDost
			dostawy(nDostawy).id=GetField(pw,"iddw")
			SetKeySeg(dw,"id",GetField(pw,"iddw"))
			if !GetRec(dw,EQ) then dostawy(nDostawy).nazwa=GetField(dw,"kod")
			dostawy(nDostawy).ilosc=GetField(pw,"ilosc")
			dostawy(nDostawy).wartosc=GetField(pw,"wartosc")
			if Sign(dostawy(nDostawy).ilosc,4) then Dostawy(nDostawy).cena = Dostawy(nDostawy).wartosc/Dostawy(nDostawy).ilosc
		endif
		err=GetRec(pw,NX)
	wend
endsub


int sub ZbierzRezerwacje( InfoPoz poz, int m, int typ, string prefix, int pozDost )
	if !poz.lp then
		poz.lp=GetField(m,"lp")
		poz.Opis=GetName(m)
		if ((firma.code == "HM") || (firma.code == "HL")) then
			SetKeySeg(uz,"iduz",GetField(m,"idtw"))
			SetKeySeg(uz,"idkh",GetField(m,"idkh"))
			if !GetRec(uz,EQ) then poz.KodObcy=GetField(uz,"kodobcy")
		endif
		poz.Kod=GetField(m,"kod")
		poz.idtw = GetField ( m,"idtw" )
		poz.Jm=GetField(m,"jm")	
		poz.JmWP=GetField(m,"jmWP")	
	endif

	SetKeySeg(zz,"id",GetField(m,"rezerwacja"))
	err=GetRec(zz,GE)
	if err then exit

	SetKeySeg(pw,"typi",26)
	SetKeySeg(pw,"idmg",GetField(m,"rezerwacja"))
	SetKeySeg(pw,"iddw",0)
	err = GetRec(pw,GE)
	while  !err && GetField(pw,"idmg")==GetField(m,"rezerwacja") && GetField(pw,"typi")==26

		if nDostawy then grow dostawy,1
		nDostawy+=1
		dostawy(nDostawy).typ=typ
		dostawy(nDostawy).lp=pozDost
		dostawy(nDostawy).ilosc=GetField(pw,"ilosc")
		dostawy(nDostawy).wartosc=GetField(pw,"wartosc")
		if Sign(dostawy(nDostawy).ilosc,4) then Dostawy(nDostawy).cena = Dostawy(nDostawy).wartosc/Dostawy(nDostawy).ilosc

		SetKeySeg(dw,"id",GetField(pw,"iddw"))
		if !GetRec(dw,EQ) then dostawy(nDostawy).nazwa=GetField(dw,"kod") : dostawy(nDostawy).id=GetField(dw,"id")

		err=GetRec(pw,NX)
	wend

endsub


// ***********************************

iddok = Val ( Arg1 )
if !iddok then message "Raport mona wykona tylko z okna dokumentu" : Error ""
GRAF = !Val ( Arg0 )
BUFOR = Val ( Arg2 )

if arg9 then
	sNapis = arg9
else
	select case Val ( Arg3 )
		case 0
			sNapis = "ORYGINA"
		case 1
			sNapis = "KOPIA"
		case 2
			sNapis = "ORYGINA/KOPIA"
		case 4
			sNapis = "DUPLIKAT"
	endselect
endif

sMG = "mg"
sMZ = "mz"
sDK = "dk"
sDP = "dp"
if BUFOR then sMG="bm" : sMZ="bz" : sDK="bd" : sDP="bp"

mgb = OpenBase(sMG)
mzb = OpenBase(sMZ)
mg = OpenBase("mg")
mz = OpenBase("mz")
nt = OpenBase("nt")
pw = OpenBase("pw")
dw = OpenBase("dw")
zz = OpenBase("zz")
uz = OpenBase("uz")
tw = OpenBase("tw")

SetKey( uz, "kodnasz")
SetKeySeg(uz,"typi",32)

SetKey ( mgb,"id" )
SetKeySeg( mgb,"id",iddok )
if GetRec( mgb,EQ ) then BaseError ( mgb,4 )
SetKey ( mg,"id" )
SetKey(zz,"id")

SetKey(mz,"super")
SetKey(pw,"dostawy")
SetKey( dw,"id" )


if GetField(mgb,"idhandl") then
	dk = OpenBase(sDK)
	SetKey(dk,"id")
	SetKeySeg(dk,"id",GetField(mgb,"idhandl"))
	if !GetRec(dk,EQ) then
		sKodDokHand = GetField(dk,"kod")
		sDataDokHand = GetField(dk,"data")		
	endif
	close dk
endif

// zbieranie dokumentu korygujcego
mz2 = OpenBase("mz")
SetKey(mz2,"super")
SetKey(mzb,"super")
SetKeySeg(mzb,"super",iddok)
SetKeySeg(mzb,"lp",0)
err = GetRec(mzb,GE)

while !err && GetField(mzb,"super")==iddok
	buf="37"
	if BUFOR then buf = "39"
	if GetField(mzb,"typi")&0x10 then
		// wyrwnanie pozycji
		j=0
		for i=1 to i>nPoz
			if PozycjeKoryg(i).lp == GetField(mzb,"lp") then j=i : i=nPoz+1
		next i
		if j then
			ZbierzPozycje(PozycjeKoryg(j),mzb,2,buf,"K",j)
		else
//			Message "Brak pozycji do pozycji wyrwnujcej"
		endif
	else
		if nPoz then grow PozycjeKoryg,1 : grow PozycjePoKor,1 : grow fWartKUzup,1 
		nPoz+=1
		ZbierzPozycje(PozycjeKoryg(nPoz),mzb,2,buf,"K",nPoz)
		if BUFOR && GetField(mzb,"rezerwacja") then ZbierzRezerwacje(PozycjeKoryg(nPoz),mzb,2,"K",nPoz)

		tot_netto+=PozycjeKoryg(nPoz).wartosc
		// dodanie pozycji po korekcie
		PozycjePoKor(nPoz).lp=PozycjeKoryg(nPoz).lp
		PozycjePoKor(nPoz).Opis=PozycjeKoryg(nPoz).Opis
		PozycjePoKor(nPoz).KodObcy=PozycjeKoryg(nPoz).KodObcy
		PozycjePoKor(nPoz).Kod=PozycjeKoryg(nPoz).Kod
		PozycjePoKor(nPoz).idtw = PozycjeKoryg(nPoz).idtw
		PozycjePoKor(nPoz).Jm=PozycjeKoryg(nPoz).Jm	
		PozycjePoKor(nPoz).JmWP=PozycjeKoryg(nPoz).JmWP	
	endif

	err = GetRec(mzb,NX)
wend

close mz2

// tworzenie dokumentu przed korekt
if GetField(mgb,"iddokkoryg")>0 then
	// zwyka korekta wydania z magazynu
	SetKeySeg(mg,"id",GetField(mgb,"iddokkoryg"))
	grow PozycjeBaza,nPoz-1
	do
		if GetRec(mg,EQ) then Error "Brak dokumentu korygowanego lub ktrej z jego korekt w bazie dokumentw magazynowych"
		if KodyKorekt(1) then grow KodyKorekt,1
		KodyKorekt(size(KodyKorekt))=GetField(mg,"kod")+" "+GetField(mg,"data")
		SetKeySeg(mz,"super",GetField(mg,"id"))
		SetKeySeg(mz,"lp",0)
		err=GetRec(mz,GE)
		while !err && GetField(mz,"super")==GetField(mg,"id")
			for k=1 to k>nPoz
				if PozycjeKoryg(k).lp == GetField(mz,"lp") && !(GetField(mz,"flag")&0x1000) then
					ZbierzPozycje(PozycjeBaza(k),mz,1,"37","B",k)
					k=nPoz	// koniec szukania
				endif
			next k
			err=GetRec(mz,NX)
		wend
		SetKeySeg( mg,"id",GetField(mg,"idkorekt"))
	loop while GetKeySeg(mg,"id")!=iddok && (!BUFOR || GetField(mg,"idkorekt"))
else
	// korekta zbiorcza (kilku WZ-w)
	dk=OpenBase("dk")
	dp=OpenBase("dp")
	SetKey(dp,"super")
	mg2 = OpenBase("mg")
	mz2 = OpenBase("mz")
	SetKey(mg2,"idhandl")
	SetKey(mz2,"idhandl")

	IdNaIndex.Type(int)
	grow PozycjeBaza,nPoz-1
	grow noweid,nPoz-1
	for i=1 to i>nPoz
		PozycjeBaza(i).lp=PozycjeKoryg(i).lp
	next i
	// po kolejnych dokumentach handlowych
	SetKey(dk,"id")
	SetKeySeg(dk,"id",-GetField(mgb,"iddokkoryg"))
	if GetRec(dk,EQ) then error "Nie znaleziono dokumentu handlowego skojarzonego z korekt zbiorcz"
	err=0
	do
		// dla kadego przegldamy dokumeny magazynowe z nim skojarzone
		// i gdy id<iddok to dodajemy jego zawarto

		// tworzymy map id-w pozycji, do ktrych mamy korekty (id)->index w tablicy pozycji korygowanych
		lTemp=GetField(dk,"id")

		IdNaIndex.Clear()
		SetKeySeg(dp,"super",lTemp)
		SetKeySeg(dp,"lp",0)
		err=GetRec(dp,GE)
	
		while !err && GetField(dp,"super")==lTemp
			for i=1 to i>nPoz
//2-gi warunek w przypadku kiedy jest to kolejna korekta WZ wystawiona na podstawie FKS, bez tego
//warunku raport blednie naliczal ilosc bazowa biorac wartosc z dokumentu WZ nie uwzgledniajac korekt
				idTemp=GetField(dp,"idpozkoryg")
				if !idTemp then idTemp=GetField(dp,"id")
				if PozycjeKoryg(i).idpozkoryg == idTemp then 
					IdNaIndex.Set((using "%d",GetField(dp,"id")),i)
					noweid(i)=GetField(dp,"id")	
				endif
			next i
			err=GetRec(dp,NX)
		wend
		SetKeySeg(mg2,"idhandl",lTemp)
		SetKeySeg(mg2,"data","")
		err=GetRec(mg2,GE)
		while !err && ( GetField(mg2,"idhandl")==lTemp || GetField(mg2,"idhandl")== -lTemp )
			if GetField(mg2,"id")<iddok || BUFOR then
				// dodanie tego dokumentu do wartoci sprzed korekty
				// kolejno po pozycjach tego dokumentu
				if KodyKorekt(1) then grow KodyKorekt,1
				KodyKorekt(size(KodyKorekt))=GetField(mg2,"kod")+" "+GetField(mg2,"data")
				SetKeySeg(mz,"super",GetField(mg2,"id"))
				SetKeySeg(mz,"lp",0)
				err=GetRec(mz,GE)
				while !err && GetField(mz,"super")==GetField(mg2,"id")
					if IdNaIndex.Index(using "%d",GetField(mz,"idhandl")) then
						// ta pozycja rozlicza pozycj korygowan
						i = IdNaIndex.Get(using "%d",GetField(mz,"idhandl"))
						if !PozycjeBaza(i).kod then
							PozycjeBaza(i).Opis = GetName(mz)
							if ((firma.code == "HM") || (firma.code == "HL")) then
								SetKeySeg(uz,"iduz",GetField(mz,"idtw"))
								SetKeySeg(uz,"idkh",GetField(mz,"idkh"))
								if !GetRec(uz,EQ) then PozycjeBaza(i).KodObcy=GetField(uz,"kodobcy")
							endif
							PozycjeBaza(i).Kod = GetField(mz,"kod")
							PozycjeBaza(i).idtw = GetField ( mz,"idtw" )
							PozycjeBaza(i).Jm = GetField(mz,"jm")	
							PozycjeBaza(i).JmWP = GetField(mz,"jmWP")	
						endif
						ZbierzPozycje(PozycjeBaza(IdNaIndex.Get(using "%d",GetField(mz,"idhandl"))),mz,1,"37","B",IdnaIndex.Get(using "%d",GetField(mz,"idhandl")))
					endif
					err=GetRec(mz,NX)
				wend

			endif
			err=GetRec(mg2,NX)
		wend

		lTemp=GetField(dk,"idkorekt")
		if lTemp then
			SetKeySeg(dk,"id",lTemp) : err=GetRec(dk,EQ)
			if err then message using "Brak dokumentu handlowego id=%s w acuchu korekt",lTemp
		endif
		for i=1 to i>size(noweid) 
			PozycjeKoryg(i).idpozkoryg=noweid(i)
		next i
	loop while ltemp

	close dk
	close dp
	close mg2
	close mz2
endif
for i=1 to i>size(PozycjeKoryg)
	if !PozycjeBaza(i).Kod then
		PozycjeBaza(i)=PozycjeKoryg(i)
		PozycjeBaza(i).Ilosc=0
		PozycjeBaza(i).IloscWP=0
		PozycjeBaza(i).Wartosc=0
		PozycjeKoryg(i).Cena=0
		PozycjeKoryg(i).CenaWP=0
	endif
	
next i
grow no_chg,size(PozycjeKoryg)-1
// cena bazowa=wartosc/ilosc
// cena pozycji koryg=(wart_przed+wart_korekty)/(ilosc_przed+ilosc_korekty)-cena_przed
for i=1 to i>nPoz
	if Sign(PozycjeBaza(i).ilosc,4) && sign(PozycjeBaza(i).Wartosc,4) then
		PozycjeBaza(i).Cena=Round(PozycjeBaza(i).Wartosc/iif(PozycjeBaza(i).ilosc!=0,PozycjeBaza(i).ilosc,1),6)
		PozycjeBaza(i).CenaWP=Round(PozycjeBaza(i).Wartosc/iif(PozycjeBaza(i).iloscWP!=0,PozycjeBaza(i).iloscWP,1),6)
	endif
	if PozycjeBaza(i).IloscWP && PozycjeBaza(i).Ilosc then PozycjeBAza(i).PRzelJMDod=PozycjeBaza(i).Ilosc/PozycjeBaza(i).IloscWP
	if !PozycjeBaza(i).PrzelJMDod then PozycjeBaza(i).PrzelJMDod=1
	PozycjeKoryg(i).PrzelJMDod=PozycjeBaza(i).PrzelJMDod
	if Sign(PozycjeBaza(i).IloscWP+PozycjeKoryg(i).IloscWP,4) then PozycjeKoryg(i).PrzelJMDod=(PozycjeKOryg(i).Ilosc+PozycjeBaza(i).Ilosc)/(PozycjeKoryg(i).IloscWP+PozycjeBAza(i).IloscWP)
	if !PozycjeKoryg(i).PrzelJmDod then PozycjeKoryg(i).PrzelJMDod=1
	Pozycjekoryg(i).CenaWP=PozycjeBaza(i).CenaWP*PozycjeKOryg(i).PrzelJMDod/PozycjeBaza(i).PrzelJmDod - PozycjeBaza(i).CenaWP
	if Sign(PozycjeBaza(i).ilosc + PozycjeKoryg(i).ilosc,4 ) then
		PozycjeKoryg(i).cena = Round((PozycjeBaza(i).wartosc + PozycjeKoryg(i).wartosc )/(PozycjeBaza(i).ilosc + PozycjeKoryg(i).ilosc ) - PozycjeBaza(i).cena,6)
		PozycjeKoryg(i).cenaWP = Round(PozycjeKoryg(i).cena *((PozycjeBaza(i).ilosc + PozycjeKoryg(i).ilosc)/(PozycjeBaza(i).iloscWP + PozycjeKoryg(i).iloscWP)),6)
	endif
	if !PozycjeKoryg(i).cena && PozycjeKoryg(i).Ilosc && PozycjeKoryg(i).IloscWP then
		no_chg(i)=1
		PozycjeKoryg(i).Cena=PozycjeKoryg(i).Wartosc/PozycjeKoryg(i).ilosc
		PozycjeKoryg(i).CenaWP=PozycjeKoryg(i).Wartosc/PozycjeKoryg(i).IloscWP
	else
		no_chg(i)=0
	endif
next i	

 //uzupenienie tych pozycji dostaw, ktre s korekt ceny
for i=1 to i>nDostawy
	if Dostawy(i).typ==2 && !Sign(Dostawy(i).ilosc,4) && !Sign(Dostawy(i).wartosc) then
		j = Dostawy(i).lp
		Dostawy(i).wartosc = ((PozycjeBaza(j).ilosc+PozycjeKoryg(j).ilosc)*Dostawy(i).Cena)
	endif
next i


SetKeySeg(mgb,"id",iddok)
GetRec(mgb,EQ)
sNazwaDok = GetField( mgb, "nazwa" )
sDataWyst = GetField( mgb,"datasp" )
sNumerDok = GetField( mgb,"kod" )
string sDataSp = GetField( mgb,"data" )
string sNabywca = GetField( mgb,"khnazwa" )
string sNabKodPocz = GetField( mgb,"khkodpocz" )
string sNabMiasto = GetField( mgb,"khmiasto" )
string sNabAdres = BuildAdresKh( mgb )
string sNabNip = GetField( mgb,"khnip" )
string sNabKod = GetField( mgb,"khkod" )
int 	 nMagazyn = GetField(mgb, "magazyn")
string sOpis = GetField( mgb,"opis" )
int bAnulowano
if GetField( mgb,"subtypi" ) == 0 || GetField( mgb,"subtypi" ) == 1 then bAnulowano = 1

SetKey ( nt,"super" )
SetKeySeg( nt,"typi",0 )
SetKeySeg( nt,"baza",33 )
if BUFOR then SetKeySeg( nt,"baza",38 )
SetKeySeg( nt,"super",iddok )
string sNotatka
if !GetRec( nt,EQ ) then
	Arg "\r",""
	buf = GetField( nt,"opis" )
	replace arg
	sNotatka = buf
endif

firma.Magazyn(nMagazyn)
if !firma.Uzywaj then firma.Magazyn(0)

// wyznaczenie po korekcie
int tabpom(1)
grow tabpom,nDostawy-1
for i=1 to i>nDostawy
	tabpom(i)=1
next i
l=nDostawy
for j=1 to j>nDostawy
	if tabpom(j) then
		tabpom(j)=0
		l+=1
		grow Dostawy,1
		dostawy(l).lp=Dostawy(j).lp
		dostawy(l).id=Dostawy(j).id
		dostawy(l).typ=3
		dostawy(l).nazwa=Dostawy(j).nazwa
		dostawy(l).ilosc=Dostawy(j).ilosc
		dostawy(l).wartosc=Dostawy(j).wartosc
		for k=j+1 to k>nDostawy
			if tabpom(k) && dostawy(k).lp==dostawy(j).lp && dostawy(k).id==dostawy(l).id then
				tabpom(k)=0
				dostawy(l).ilosc+=dostawy(k).ilosc
				dostawy(l).wartosc+=dostawy(k).wartosc
			endif
		next k
		if Sign(dostawy(l).ilosc,4) then dostawy(l).cena = dostawy(l).wartosc / dostawy(l).ilosc
//		if !Sign(dostawy(l).ilosc,4) then l-=1 : shrink dostawy,1
	endif
next j

for i=1 to i>nPoz
	PozycjePoKor(i).ilosc=PozycjeBaza(i).ilosc+PozycjeKoryg(i).ilosc
	PozycjePoKor(i).iloscWP= PozycjeKoryg(i).iloscWP + PozycjeBaza(i).iloscWP
	PozycjePoKor(i).wartosc=PozycjeBaza(i).wartosc+PozycjeKoryg(i).wartosc
	if (PozycjeBaza(i).CenaWP+j)==PozycjeKoryg(i).CenaWP || !PozycjeKoryg(i).CenaWP then 
		PozycjePoKor(i).cena=PozycjeKoryg(i).Cena +PozycjeBaza(i).Cena
		PozycjePoKor(i).cenaWP=PozycjeKoryg(i).CenaWP +PozycjeBaza(i).CenaWP
	else
		if no_chg(i) then
		PozycjePoKor(i).cena=PozycjeBaza(i).cena
		PozycjePoKor(i).cenaWP=PozycjeBaza(i).cenaWP
		else
		PozycjePoKor(i).cena=iif(PozycjePoKor(i).ilosc!=0,PozycjePoKor(i).wartosc/PozycjePoKor(i).ilosc,PozycjeBaza(i).cena+fWartKUzup(i)+PozycjeKoryg(i).cena)
		PozycjePoKor(i).cenaWP=iif(PozycjePoKor(i).iloscWP!=0,PozycjePoKor(i).wartosc/PozycjePoKor(i).iloscWP,PozycjeBaza(i).cenaWP+PozycjeKoryg(i).cenaWP)
		endif
	endif
	if !PozycjeKoryg(i).IloscWP then PozycjeKoryg(i).iloscWP = PozycjeKoryg(i).ilosc * (iif((PozycjeBaza(i).iloscWP + PozycjeKoryg(i).iloscWP)!=0,(PozycjeBaza(i).iloscWP + PozycjeKoryg(i).iloscWP),1)/iif((PozycjeBaza(i).ilosc + PozycjeKoryg(i).ilosc)!=0,(PozycjeBaza(i).ilosc + PozycjeKoryg(i).ilosc),1))
	PozycjePoKor(i).PrzelJmDod=iif(PozycjePoKor(i).IloscWP,PozycjePoKor(i).Ilosc/PozycjePoKor(i).IloscWP,PozycjeBaza(i).PrzelJmDod)
	if !PozycjePoKor(i).PrzelJmDod then PozycjePoKor(i).PrzelJmDod=1
	tot_nettoPrzed+=PozycjeBaza(i).wartosc
	tot_nettoPo+=PozycjePoKor(i).wartosc
next i
nDostawy=l


