//"eksp_sp.sc","Eksport rozrachunkw",12329,0,2.1.1,SYSTEM
//"Pienidze",12002,14,16
//////////////////////////////////////////////////////////////////////
// Eksport rozrachunkw
// eksp_sp.sc


/*
Format pliku wejciowego:

1 - data rozrachunku									DATE
2 - kwota rozrachunku									FLOAT
3 - termin rozrachunku								DATE
4 - Kod kontrahenta										STRING 25
5 - rejestr rozrachunku								BYTE
6 - numer nierozliczonego dokumentu		STRING 25		opcjonalnie
7 - Opis rozrachunku									STRING 40		opcjonalnie
8 - kwota juz rozliczona							FLOAT				opcjonalnie
9 - typ kontrahenta										BYTE   0-kontrahent 1-pracownik 2-urzd		opcjonalnie

- kolumny oddzielone s od siebie tabulacjami
- kolumny opcjonalne mog nie zawiera znakw lecz mimo to powinny by oddzielane
	znakiem tabulacji
- ostatnie kolumny w linii ktre nie zawieraj znakw z racjii statusu opcjonalnoci
	mog zosta usunite cznie ze znakami tabulacji

*/

string fname = KatalogFirmy()+"rw.txt"
string sTemp
int err, inFile
BasePN pn

int sub OpenFile()
	inFile = open fname for Output
	if inFile<=0 then Message "Bd otwierania pliku "+fname+" do zapisu." : error ""
endsub

int sub Choose()
	Choose = 1
	Save
	sTemp = FileDlg(1,"Plik tekstowy (*.txt)","*.txt","Wszystkie pliki (*.*)","*.*" )
	if sTemp then
		fname = sTemp
		Choose = 1
	endif
endsub

//----------------------------------------------------------------------------------------------

form "Eksport rozrachunkw",350,120

	Group "Plik &danych",5,5,335,50
	edit "",fname,15,25,236,20

	button "&OK",160,65,80,25,2
	button "&Anuluj",255,65,80,25,-1

	button "&Przegldaj...",260,23,70,24,Choose()

if execform==-1 then error""

OpenFile()

print "\n Eksport rozrachunkw\n Plik danych: "+fname+lf+lf

int pn2=open KatalogFirmy()+"51pn.dat" for base "PN"
BaseError(pn2,4)

int added = 0
pn.Open()
pn.SetKey("id")
err = SetTaggedPos(FS):long id
WHILE err
 	id = GetLineId()
	pn.SetKeySeg("id", id)
	pn.GetRec(EQ)

	IF (pn.GetField("typi") == 0) THEN
		print #inFile; pn.GetField("data"), pn.GetField("kwota"), pn.GetField("termin"), pn.GetField("khkod"), pn.GetField("rejestr"), pn.GetField("kod"), pn.GetField("opis"), pn.GetField("kwotarozl"), pn.GetField("typkh");LF
		print using " Wyeksportowano rozrachunek '%s'.\n", pn.GetField("kod")
		err = pn.GetRec(NX)
		added += 1
	ELSE
		print using " Dokument '%s' nie jest rozrachunkiem.\n", pn.GetField("kod")
	ENDIF

	err=SetTaggedPos(NX)
WEND

close inFile

print using "\n\n Ilo wyeksportowanych rozrachunkw: %d",added
