//"kont_fir.sc","Kontynuacja firmy bez dokumentw",12010,0,1.0.5,SYSTEM
//"Pomocnicze",12001,14,16
////////////////////////////
// Kontynuacja firmy bez dokumentw
// kont_fir.sc
///////////////////////////

string sNewDir,sTemp
long lTemp
int err,bsrc,bdst,pom,bRozrach,bStany, bNrDostaw, bPlatn
int Stany, NrDostaw
int xt,kh
int pn,sm,dw,tw
int iDaneFirmy

record ProgressCounter
	long all,curr,last,new
	int sub Reset( long a )
		if !a then a=1
		all=a : curr = last = 0
		WriteStatusBar("")
	endsub
	int sub NextOne()
		curr+=1 : new = (curr*100)/all
		if new>last+4 then last = new
		if last>100 then last = 100 : curr=all
		WriteStatusBar(using "=%d%%%%",last)
	endsub
endrec

ProgressCounter progress

//  ************************************

if ((firma.code != "HM") && (firma.code != "FP")) then error "Raport przeznaczony jest dla programw Handel premium oraz Faktura premium"


int sub OpenNewBase( string b )
	OpenNewBase=open sNewDir+"51"+b+".dat" for base b
	baseerror(OpenNewBase,4)
endsub


string sub CreateNewDir( long num )
	buf=KatalogFirmy()
	if Mid(buf,len(buf))=="\\" then buf=Mid(buf,1,Len(buf)-1)
	sTemp="Nowa"
	if (find regular "{[~\\]+}$") && (regular 1) then sTemp=regular 1
	buf = using "%l",num
	if Len(buf)+len(sTemp)>8 then
		CreateNewDir = Mid(sTemp,1,8-Len(buf))+buf
	else
		CreateNewDir = sTemp+buf
	endif
endsub

int sub CheckExists( string dir )
	err = open dir+"firma."+firma.code for binary input
	if err>0 then
		CheckExists = 1
		close(err)
	else
		CheckExists = 0
	endif
endsub

int sub CreateDir()
	Save

	int n
	n = Len(sNewDir)
	IF	sNewDir(n) == '\\' THEN
		sNewDir = Mid(sNewDir,1,n-1)
	ENDIF

	CreateDir = !MkDir(sNewDir)

	sNewDir = sNewDir + "\\"
endsub


int sub CreateMirrorBase(string baza)
	PopUp( 1, "Tworzenie bazy "+baza )
	if (create sNewDir+"5"+baza+".dat" for base baza) then error(using "Bd tworzenia bazy %s w katalogu %s",baza,sNewDir)
endsub

int sub CreateBase(string baza)
	PopUp( 1, "Tworzenie bazy "+baza )
	if (create sNewDir+"51"+baza+".dat" for base baza) then error(using "Bd tworzenia bazy %s w katalogu %s",baza,sNewDir)
endsub


int sub CopyFile(string src, stRing dst)
	PopUp( 1, "Kopiowanie pliku "+src )
	bdst = open dst for binary output
	if bdst<=0 then error "bd otwierania pliku "+dst+" do zapisu"
		if !(append src to bdst) then error "Bad kopiowania pliku "+src
	close(bdst)
endsub


int sub CopyBase(string base)
	string strKod
	BaseDK basDK

	if len(base)==2 then
		CreateBase(base)
		buf="51"+base+".dat"
	else
		CreateMirrorBase(base)
		buf="5"+base+".dat"
	endif
	PopUp( 1, "Kopiowanie bazy "+base )
	bsrc = open KatalogFirmy()+buf for base base
	BaseError(bsrc,4)
	bdst = open sNewDir+buf for base base
	BaseError(bdst,4)
	SetKey(bsrc,"id")
	progress.Reset(GetRecordCount(bsrc))
	err=GetRec(bsrc,FS)
	while !err
		progress.NextOne()

		// czy zapisywa
		select case base
			case "DK","iDK"
				pom = GetField(bsrc,"typi")
				if pom!=0 && pom!=1 && pom!=202 && pom!=203 && pom!=100 && pom!=112 then err=1
			case "MG","iMG"
				pom = GetField(bsrc,"typi")
				if pom!=201 && pom!=111 then err=1
			case "NT"
				pom = GetField(bsrc,"baza")
				if pom == 0x14 || pom == 0x16 then err=1
			case "TW","KH","UZ","WL","XT"
				err=1
			case "ZZ"
				err=1
				pom = GetField(bsrc,"typi")
				if pom==0x50 || pom==0x60 || pom==0x62 || pom==0x70 then err=0
				if (pom>=0x80 && pom<=0x97) || pom==0xa0 then err=0
			case "PN"
				if bRozrach then
					if GetField(bsrc,"typi")==0 then
						CopyFields(bsrc,bdst)
						if (GetField(bsrc,"dkid")) && (!basDK.GetRecById(GetField(bsrc,"dkid"))) && (basDK.GetField("typi")==202) then
						//jesli dokument zakupu to numer zostaje przebity na numer dokumentu w FK
							strKod = basDK.GetField("kod_obcy")
							strKod += " ["
							strKod += basDK.GetField("kod")
							strKod += "]"
							strKod = Mid(strKod, 1, iif(len(strkod)>29,29,len(strkod)))
							SetField(bdst,"kod",strKod)
						endif
						SetField(bdst,"dkid",0)
						if InsRec(bdst) then error "bd wstawiania rekordu do nowej bazy "+base
					endif
				endif
			case "iPN"
				if bRozrach then if GetField(bsrc,"typi")==0 then err=1
			case "RL"
				SetKeySeg(pn,"id",GetField(bsrc,"id1"))
				if !GetKey(pn,EQ) then
					CopyFields(bsrc,bdst)
					SetField(bdst,"id2",0)
					err=1
				else
					SetKeySeg(pn,"id",GetField(bsrc,"id2"))
					if !GetKey(pn,EQ) then
						CopyFields(bsrc,bdst)
						SetField(bdst,"id1",0)
						err=1
					endif
				endif
				if err && InsRec(bdst) then error "bd wstawiania rekordu do nowej bazy "+base
				err=0
			case "SM"
				if !GetField(bsrc,"magazyn") then
					CopyFields(bsrc,bdst)
					SetField(bdst,"stan",0)
					SetField(bdst,"stanHandl",0)
					SetField(bdst,"wartosc",0)
					if InsRec(bdst) then error "bd wstawiania rekordu do nowej bazy "+base
				endif
				err=0
		endselect

		
		if err then
			CopyFields(bsrc,bdst)
			if InsRec(bdst) then error "bd wstawiania rekordu do nowej bazy "+base
		endif
		err=GetRec(bsrc,NX)
	wend
	
	close(bsrc)
	close(bdst)
	WriteStatusBar("")
endsub


int sub CopyFiles(string ext)
	buf=find file KatalogFirmy()+"*."+ext
	while buf
		sTemp=buf
		if (find regular "^*{[~\\]+}$") && ( regular 1) then CopyFile(buf,sNewDir+(regular 1))
		buf = find next file
	wend
endsub

int sub ZeroNumOfAllDocs( long id )
	SetKeySeg(xt,"id",id)
	if !GetRec(xt,EQ) then
		SetField(xt,"zawartosc",0)
		PutRec(xt)
	endif

	if (firma.code != "HL") then
		SetKeySeg(xt,"id",id+99)
		if !GetRec(xt,EQ) then
			SetField(xt,"zawartosc",0)
			PutRec(xt)
		endif
	endif
endsub

int sub ZeroNode(int xtb)
	SetField(xtb,"zawartosc",0)
	PutRec(xtb)
	int xtn=OpenNewBase("XT")
	SetKey(xtn,"super")
	SetKeySeg(xtn,"super",GetField(xtb,"id"))
	SetKeySeg(xtn,"kod","")
	err=GetRec(xtn,GE)
	while !err && GetField(xtn,"super")==GetField(xtb,"id")
		ZeroNode( xtn )
		err=GetRec(xtn,NX)
	wend
	close(xtn)
endsub

int sub ZeroKinds(long root)
	// rodzaje
	SetKeySeg(xt,"id",root)
	if !GetRec(xt,EQ) then
		SetField(xt,"zawartosc",0)
		PutRec(xt)
		SetKey(xt,"super")
		SetKeySeg(xt,"super",root)
		SetKeySeg(xt,"kod","")
		err=GetRec(xt,GE)
		while !err && GetField(xt,"super")==root
			SetField(xt,"zawartosc",0)
			PutRec(xt)
			err=GetRec(xt,NX)
		wend
		SetKey(xt,"id")
	endif

	// katalogi
	SetKeySeg(xt,"id",root-1000)
	if !GetRec(xt,EQ) then ZeroNode(xt)
endsub

int sub RecountDocuments()
	xt=OpenNewBase("XT")
	kh=OpenNewBase("KH")
	SetKey(xt,"id")
	ZeroNumOfAllDocs(4300)
	ZeroKinds(3300)
if ((firma.code == "HM") || (firma.code == "HL")) then
	ZeroNumOfAllDocs(4500)
	ZeroNumOfAllDocs(4600)
	ZeroKinds(3500)
	ZeroKinds(3600)
endif

	// iloci dokumentw w rejestrach pieninych
	pn=OpenNewBase("PN")
	SetKey(pn,"rejestr")
	SetKey(xt,"super")
	SetKeySeg(xt,"super",3400)
	SetKeySeg(xt,"kod","")
	SetKey(kh,"id")
	err=GetRec(xt,GE)
	while !err && GetField(xt,"super")==3400
		if !bRozrach then
			SetKeySeg(kh,"id",GetField(xt,"klient"))
			if !GetRec(kh,EQ) then
				SetField(kh,"stannl",0)
				if !bPlatn then SetField(kh,"stanpl",0)
				PutRec(kh)
			endif
			SetField(xt,"zawartosc",0)
		else
			if !bPlatn then
				SetKeySeg(kh,"id",GetField(xt,"klient"))
				if !GetRec(kh,EQ) then
					SetField(kh,"stanpl",0)
					PutRec(kh)
				endif
			endif
			SetKeySeg(pn,"rejestr",GetField(xt,"id"))
			SetKeySeg(pn,"termin","")
			SetKeySeg(pn,"id",0)
			SetKeySeg(pn,"typi",0)
			lTemp=0
			err=GetKey(pn,GE)
			while !err && GetKeySeg(pn,"rejestr")==GetField(xt,"id")
				lTemp+=1
				err=GetKey(pn,NX)
			wend
			SetField(xt,"zawartosc",lTemp)
		endif
		PutRec(xt)
		err=GetRec(xt,NX)
	wend
	close(pn)

	close(xt)
	close(kh)
endsub

string sub Normalize( float f)
	Normalize = using "%.6f",Round(f,6)
endsub


int sub Protokol()
	int fl
	int file_num=1
	PopUp(1,"Tworzenie protokow wprowadzenia")
	xt=open KatalogFirmy()+"51xt.dat" for base "XT"
	BaseError(xt,4)
	sm=Open KatalogFirmy()+"51sm.dat" for base "SM"
	BaseError(sm,4)
	SetKey(sm,"kod")
	SetKey(xt,"super")
	SetKeySeg(xt,"super",6900)
	SetKeySeg(xt,"kod","")
	err=GetRec(xt,GE)
	while !err && GetField(xt,"super")==6900
		fl=0
		SetKeySeg(sm,"magazyn",GetField(xt,"id"))
		SetKeySeg(sm,"kod","")
		err=GetRec(sm,GE)
		while !err && GetField(sm,"magazyn")==GetFIeld(xt,"id")
			if Sign(GetField(sm,"stan")) then
				if !fl then
					buf = using "%d",file_num
					buf= "INWENT\\INV"+Pattern(5-Len(buf),"0")+buf+".TXT"
					fl=Open sNewDir+buf for output
					if fl<=0 then error "Bd tworzenia pliku protokou wprowadzenia"
					print #fl;using "@%s\t%d\tKontynuacja firmy - wprowadzenie stanw magazynowych\t%s\t0\t2\t\n",Data(),GetField(xt,"id"),CurrentUser()
				endif
				print #fl;GetField(sm,"kod")
				buf = "0.0"
				if Sign(GetField(sm,"stan")) then buf = Normalize(GetField(sm,"wartosc")/GetField(sm,"stan"))
				print #fl;using "\t%s\t%s\t\t%s\t%l\t0\t0.000000\t\n",buf,Normalize(GetField(sm,"stan")),Normalize(GetField(sm,"wartosc")),GetField(sm,"idtw")
			endif
			err=GetRec(sm,NX)
		wend
		close(fl)
		err=GetRec(xt,NX)
		file_num+=1
	wend
	Close(xt)
	Close(sm)
endsub

//----------------------------------------------------------------------------------------------

int sub Protokol1()
float temp
	int fl
	int file_num=1
	PopUp(1,"Tworzenie protokow wprowadzenia")

	tw=Open KatalogFirmy()+"51tw.dat" for base "TW"
	BaseError(tw,4)
	SetKey(tw, "id")		

	xt=open KatalogFirmy()+"51xt.dat" for base "XT"
	BaseError(xt,4)
	dw=Open KatalogFirmy()+"51dw.dat" for base "DW"
	BaseError(dw,4)

	SetKey(xt,"super")
	SetKeySeg(xt,"super",6900)
	SetKeySeg(xt,"kod","")
	err=GetRec(xt,GE)

	while !err && GetField(xt,"super")==6900
		SetKey(dw,"id")
		err=GetRec(dw,FS)
		fl=0
		while !err
			if GetField(dw,"magazyn")==GetFIeld(xt,"id") then
				if Sign(GetField(dw,"stan")) && GetField(dw,"idtw")>0 then
					if !fl then
						buf = using "%d",file_num
						buf= "INWENT\\INV"+Pattern(5-Len(buf),"0")+buf+".TXT"
						fl=Open sNewDir+buf for output
						if fl<=0 then error "Bd tworzenia pliku protokou wprowadzenia"
						print #fl;using "@%s\t%d\tKontynuacja firmy - wprowadzenie stanw magazynowych\t%s\t0\t2\t\n",Data(),GetField(xt,"id"),CurrentUser()
					endif
					SetKeySeg(tw,"id",GetField(dw,"idtw"))
					GetRec(tw,EQ)
					print #fl;GetField(tw,"kod")
					buf = "0.0"
					if Sign(GetField(dw,"stan")) then buf = Normalize(GetField(dw,"wartoscst")/GetField(dw,"stan"))
					print #fl;using "\t%s\t%s\t%s\t%s\t%l\t0\t0.000000\t\n",buf,Normalize(GetField(dw,"stan")),GetField(dw,"kod"),Normalize(GetField(dw,"wartoscst")),GetField(dw,"idtw")
				endif
			endif
			err=GetRec(dw,NX)
		wend
		close(fl)
		err=GetRec(xt,NX)
		file_num+=1
	wend
	Close(xt)
	Close(dw)
endsub

//----------------------------------------------------------------------------------------------

int sub OnCommand(int id,int msg)
	if !id && ((firma.code == "HM") || (firma.code == "HL")) then
		if bStany then
			Enable(NrDostaw, 1)
		else
			Enable(NrDostaw, 0)
		endif
	endif
	if id && !msg && ((firma.code == "HM") || (firma.code == "HL")) then
		Select Case id
			Case Stany
				Save
				if bStany then
					Enable(NrDostaw, 1)
				else
					Enable(NrDostaw, 0)
				endif
			Case NrDostaw
			Case Else
		EndSelect
	endif
endsub
//----------------------------------------------------------------------------------------------

// *****************************************

// utworzenie propozycji nowego katalogu
buf=KatalogFirmy()
if (find regular "^{*}[~\\]+\\$") && (regular 1) then sNewDir = (regular 1)
lTemp=1
do
	sTemp = CreateNewDir(lTemp)
	lTemp+=1
loop while CheckExists(sNewDir+sTemp+"\\")
sNewDir = sNewDir+sTemp+"\\"

bRozrach = Val(GetIni( GetReportName(), "Rozrachunki") )
bPlatn = Val(GetIni( GetReportName(), "Platnosci") )
bStany	= Val(GetIni( GetReportName(), "Stany mag.") )
bNrDostaw	= Val(GetIni( GetReportName(), "numery dostaw") )
iDaneFirmy=Val(GetIni( GetReportName(),"zostaw id firmy"))


Form GetReportName(),395,175+20*((firma.code == "HM") || (firma.code == "HL"))
	Group "&Nowy katalog firmy",10,5,370,45
		Edit "",sNewDir,25,23,290,18,CreateDir()

	Group "",10,50,370,60+20*((firma.code == "HM") || (firma.code == "HL"))
		ChkBox "Przenie &rozrachunki",bRozrach,20,65,150,20
		ChkBox "Przenie stan patnoci rejestrw",bPlatn,195,65,180,20
		ChkBox "Pozostaw ten sam identyfikator firmy (wykorzyst. przy imporcie danych)",iDaneFirmy,20,85,350,20
		if ((firma.code == "HM") || (firma.code == "HL")) then 
			Stany = ChkBox "Utwrz protok &wprowadzenia",bStany,20,105,170,20
			NrDostaw = ChkBox "wraz z &nazwami dostaw",bNrDostaw,195,105,140,20
		endif

	Button "&Kontynuuj",230,120+20*((firma.code == "HM") || (firma.code == "HL")),70,25,2
	Button "&Przerwij",310,120+20*((firma.code == "HM") || (firma.code == "HL")),70,25,-2
if ExecForm (OnCommand) !=2 then error ""

int n
n = Len(sNewDir)
IF	sNewDir(n) != '\\' THEN
	sNewDir = sNewDir + "\\"
ENDIF

PutIni(GetReportName(),"Rozrachunki",using"%d",bRozrach)
PutIni(GetReportName(),"Platnosci",using"%d",bPlatn)
PutIni(GetReportName(),"Stany mag.",using"%d",bStany)
PutIni(GetReportName(),"numery dostaw",using"%d",bNrDostaw)
PutIni(GetReportName(),"zostaw id firmy",using "%d",iDaneFirmy)


// tworzenie pustych baz
CreateBase("BD")
if ((firma.code == "HM") || (firma.code == "HL")) then CreateBase("BM")
CreateBase("BP")
if ((firma.code == "HM") || (firma.code == "HL")) then CreateBase("BZ")
CopyBase("DK")
CreateBase("DP")
if ((firma.code == "HM") || (firma.code == "HL")) then CreateBase("DW")
CopyBase("KH")
if ((firma.code == "HM") || (firma.code == "HL")) then CopyBase("MG")
if ((firma.code == "HM") || (firma.code == "HL")) then CreateBase("MZ")
CopyBase("NT")
CopyBase("PN")
if ((firma.code == "HM") || (firma.code == "HL")) then CreateBase("PW")
CreateBase("RV")
if (firma.code == "HM") then CreateBase("IT")

pn=OpenNewBase("PN")
SetKey(pn,"id")
CopyBase("RL")
close(pn)

if ((firma.code == "HM") || (firma.code == "HL")) then CopyBase("SM")
CopyBase("TW")
CopyBase("UZ")
CopyBase("WL")
CopyBase("XT")
CopyBase("ZZ")
CopyBase("iDK")
CreateMirrorBase("iDP")
if ((firma.code == "HM") || (firma.code == "HL")) then CopyBase("iMG")
if ((firma.code == "HM") || (firma.code == "HL")) then CreateMirrorBase("iMZ")
CopyBase("iPN")
if (firma.code == "HM") then CreateBase("WD")

RecountDocuments()

if ((firma.code == "HM") || (firma.code == "HL")) then MkDir( sNewDir+"INWENT" )
// !iDaneFirmy wyzeruj pole long w tabeli XT odpowiadajace za numer firmy
if !iDaneFirmy then 
	xt = open sNewDir+"51xt.dat" for base "XT"
	SetKey(xt,"id")
	SetKeySeg(xt,"id",6800)
	err = getrec(xt,EQ)
	if !err then SetField(xt,"long",0) : PutRec(xt)
	close(xt)
endif

CopyFiles("ini")
CopyFiles("ctx")
if ((firma.code == "HM") || (firma.code == "HL")) then
	if bStany then
		if bNrDostaw then
			Protokol1()			
		else
			Protokol()
		endif
	endif
endif

// na kocu, gdy wszystko si udao kopiowanie pliku firma.hm/fp
buf="firma."+firma.code
CopyFile( KatalogFirmy()+buf,sNewDir+buf )
CopyFile( KatalogFirmy()+"51sec.dat",sNewDir+"51sec.dat" )
Message "Utworzono kopie firmy bez dokumentw w katalogu "+sNewDir
error ""
